/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20230117(212670ceb460441b3ebed29e6ca30aa1e9bdde85)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Q=function(U){for(var i=[],_=0,M=U.length;_<M;_++)i[_]=X[U[_]];return i},Ee=this,Re=typeof global=="object"?global:{},ae;(function(U){U.global=Ee;var i=function(){function _(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(_.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),_.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=_._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},_._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},_}();U.Environment=i})(ae||(ae={}));var ae;(function(U){var i=function(){function A(t,y,v){this.type=t,this.detail=y,this.timestamp=v}return A}();U.LoaderEvent=i;var _=function(){function A(t){this._events=[new i(1,"",t)]}return A.prototype.record=function(t,y){this._events.push(new i(t,y,U.Utilities.getHighPerformanceTimestamp()))},A.prototype.getEvents=function(){return this._events},A}();U.LoaderEventRecorder=_;var M=function(){function A(){}return A.prototype.record=function(t,y){},A.prototype.getEvents=function(){return[]},A.INSTANCE=new A,A}();U.NullLoaderEventRecorder=M})(ae||(ae={}));var ae;(function(U){var i=function(){function _(){}return _.fileUriToFilePath=function(M,A){if(A=decodeURI(A).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A},_.startsWith=function(M,A){return M.length>=A.length&&M.substr(0,A.length)===A},_.endsWith=function(M,A){return M.length>=A.length&&M.substr(M.length-A.length)===A},_.containsQueryString=function(M){return/^[^\#]*\?/gi.test(M)},_.isAbsolutePath=function(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)},_.forEachProperty=function(M,A){if(M){var t=void 0;for(t in M)M.hasOwnProperty(t)&&A(t,M[t])}},_.isEmpty=function(M){var A=!0;return _.forEachProperty(M,function(){A=!1}),A},_.recursiveClone=function(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;var A=Array.isArray(M)?[]:{};return _.forEachProperty(M,function(t,y){y&&typeof y=="object"?A[t]=_.recursiveClone(y):A[t]=y}),A},_.generateAnonymousModule=function(){return"===anonymous"+_.NEXT_ANONYMOUS_ID+++"==="},_.isAnonymousModule=function(M){return _.startsWith(M,"===anonymous")},_.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()},_.NEXT_ANONYMOUS_ID=1,_.PERFORMANCE_NOW_PROBED=!1,_.HAS_PERFORMANCE_NOW=!1,_}();U.Utilities=i})(ae||(ae={}));var ae;(function(U){function i(A){if(A instanceof Error)return A;var t=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(t.stack=A.stack),t}U.ensureError=i;var _=function(){function A(){}return A.validateConfigurationOptions=function(t){function y(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(t=t||{},typeof t.baseUrl!="string"&&(t.baseUrl=""),typeof t.isBuild!="boolean"&&(t.isBuild=!1),typeof t.paths!="object"&&(t.paths={}),typeof t.config!="object"&&(t.config={}),typeof t.catchError>"u"&&(t.catchError=!1),typeof t.recordStats>"u"&&(t.recordStats=!1),typeof t.urlArgs!="string"&&(t.urlArgs=""),typeof t.onError!="function"&&(t.onError=y),Array.isArray(t.ignoreDuplicateModules)||(t.ignoreDuplicateModules=[]),t.baseUrl.length>0&&(U.Utilities.endsWith(t.baseUrl,"/")||(t.baseUrl+="/")),typeof t.cspNonce!="string"&&(t.cspNonce=""),typeof t.preferScriptTags>"u"&&(t.preferScriptTags=!1),t.nodeCachedData&&typeof t.nodeCachedData=="object"&&(typeof t.nodeCachedData.seed!="string"&&(t.nodeCachedData.seed="seed"),(typeof t.nodeCachedData.writeDelay!="number"||t.nodeCachedData.writeDelay<0)&&(t.nodeCachedData.writeDelay=1e3*7),!t.nodeCachedData.path||typeof t.nodeCachedData.path!="string")){var v=i(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",t.onError(v),t.nodeCachedData=void 0}return t},A.mergeConfigurationOptions=function(t,y){t===void 0&&(t=null),y===void 0&&(y=null);var v=U.Utilities.recursiveClone(y||{});return U.Utilities.forEachProperty(t,function(o,c){o==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(c):o==="paths"&&typeof v.paths<"u"?U.Utilities.forEachProperty(c,function(p,e){return v.paths[p]=e}):o==="config"&&typeof v.config<"u"?U.Utilities.forEachProperty(c,function(p,e){return v.config[p]=e}):v[o]=U.Utilities.recursiveClone(c)}),A.validateConfigurationOptions(v)},A}();U.ConfigurationOptionsUtil=_;var M=function(){function A(t,y){if(this._env=t,this.options=_.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var v=this.options.nodeRequire.main.filename,o=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,o+1)}}return A.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var t=0;t<this.options.ignoreDuplicateModules.length;t++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[t]]=!0},A.prototype._createSortedPathsRules=function(){var t=this;this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,function(y,v){Array.isArray(v)?t.sortedPathsRules.push({from:y,to:v}):t.sortedPathsRules.push({from:y,to:[v]})}),this.sortedPathsRules.sort(function(y,v){return v.from.length-y.from.length})},A.prototype.cloneAndMerge=function(t){return new A(this._env,_.mergeConfigurationOptions(t,this.options))},A.prototype.getOptionsLiteral=function(){return this.options},A.prototype._applyPaths=function(t){for(var y,v=0,o=this.sortedPathsRules.length;v<o;v++)if(y=this.sortedPathsRules[v],U.Utilities.startsWith(t,y.from)){for(var c=[],p=0,e=y.to.length;p<e;p++)c.push(y.to[p]+t.substr(y.from.length));return c}return[t]},A.prototype._addUrlArgsToUrl=function(t){return U.Utilities.containsQueryString(t)?t+"&"+this.options.urlArgs:t+"?"+this.options.urlArgs},A.prototype._addUrlArgsIfNecessaryToUrl=function(t){return this.options.urlArgs?this._addUrlArgsToUrl(t):t},A.prototype._addUrlArgsIfNecessaryToUrls=function(t){if(this.options.urlArgs)for(var y=0,v=t.length;y<v;y++)t[y]=this._addUrlArgsToUrl(t[y]);return t},A.prototype.moduleIdToPaths=function(t){if(this._env.isNode){var y=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(t);if(y)return this.isBuild()?["empty:"]:["node|"+t]}var v=t,o;if(!U.Utilities.endsWith(v,".js")&&!U.Utilities.isAbsolutePath(v)){o=this._applyPaths(v);for(var c=0,p=o.length;c<p;c++)this.isBuild()&&o[c]==="empty:"||(U.Utilities.isAbsolutePath(o[c])||(o[c]=this.options.baseUrl+o[c]),!U.Utilities.endsWith(o[c],".js")&&!U.Utilities.containsQueryString(o[c])&&(o[c]=o[c]+".js"))}else!U.Utilities.endsWith(v,".js")&&!U.Utilities.containsQueryString(v)&&(v=v+".js"),o=[v];return this._addUrlArgsIfNecessaryToUrls(o)},A.prototype.requireToUrl=function(t){var y=t;return U.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],U.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},A.prototype.isBuild=function(){return this.options.isBuild},A.prototype.shouldInvokeFactory=function(t){return!!(!this.options.isBuild||U.Utilities.isAnonymousModule(t)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[t])},A.prototype.isDuplicateMessageIgnoredFor=function(t){return this.ignoreDuplicateModulesMap.hasOwnProperty(t)},A.prototype.getConfigForModule=function(t){if(this.options.config)return this.options.config[t]},A.prototype.shouldCatchError=function(){return this.options.catchError},A.prototype.shouldRecordStats=function(){return this.options.recordStats},A.prototype.onError=function(t){this.options.onError(t)},A}();U.Configuration=M})(ae||(ae={}));var ae;(function(U){var i=function(){function o(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(c,p,e,b){var f=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){var g=c.getConfig().getOptionsLiteral().preferScriptTags;g?this._scriptLoader=new _:this._scriptLoader=new t(this._env)}else this._env.isNode?this._scriptLoader=new t(this._env):this._scriptLoader=new _;var L={callback:e,errorback:b};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(L);return}this._callbackMap[p]=[L],this._scriptLoader.load(c,p,function(){return f.triggerCallback(p)},function(w){return f.triggerErrorback(p,w)})},o.prototype.triggerCallback=function(c){var p=this._callbackMap[c];delete this._callbackMap[c];for(var e=0;e<p.length;e++)p[e].callback()},o.prototype.triggerErrorback=function(c,p){var e=this._callbackMap[c];delete this._callbackMap[c];for(var b=0;b<e.length;b++)e[b].errorback(p)},o}(),_=function(){function o(){}return o.prototype.attachListeners=function(c,p,e){var b=function(){c.removeEventListener("load",f),c.removeEventListener("error",g)},f=function(L){b(),p()},g=function(L){b(),e(L)};c.addEventListener("load",f),c.addEventListener("error",g)},o.prototype.load=function(c,p,e,b){if(/^node\|/.test(p)){var f=c.getConfig().getOptionsLiteral(),g=y(c.getRecorder(),f.nodeRequire||U.global.nodeRequire),L=p.split("|"),w=null;try{w=g(L[1])}catch(l){b(l);return}c.enqueueDefineAnonymousModule([],function(){return w}),e()}else{var N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript"),this.attachListeners(N,e,b);var d=c.getConfig().getOptionsLiteral().trustedTypesPolicy;d&&(p=d.createScriptURL(p)),N.setAttribute("src",p);var C=c.getConfig().getOptionsLiteral().cspNonce;C&&N.setAttribute("nonce",C),document.getElementsByTagName("head")[0].appendChild(N)}},o}();function M(o){var c=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var p=c?self.eval(c.createScript("","true")):new Function("true");return p.call(self),!0}catch{return!1}}var A=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(c)),this._cachedCanUseEval},o.prototype.load=function(c,p,e,b){if(/^node\|/.test(p)){var f=c.getConfig().getOptionsLiteral(),g=y(c.getRecorder(),f.nodeRequire||U.global.nodeRequire),L=p.split("|"),w=null;try{w=g(L[1])}catch(C){b(C);return}c.enqueueDefineAnonymousModule([],function(){return w}),e()}else{var N=c.getConfig().getOptionsLiteral().trustedTypesPolicy,d=/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin;if(!d&&this._canUseEval(c)){fetch(p).then(function(C){if(C.status!==200)throw new Error(C.statusText);return C.text()}).then(function(C){C=C+`
//# sourceURL=`+p;var l=N?self.eval(N.createScript("",C)):new Function(C);l.call(self),e()}).then(void 0,b);return}try{N&&(p=N.createScriptURL(p)),importScripts(p),e()}catch(C){b(C)}}},o}(),t=function(){function o(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},o.prototype._initNodeRequire=function(c,p){var e=p.getConfig().getOptionsLiteral().nodeCachedData;if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var b=this,f=c("module");function g(L){var w=L.constructor,N=function(C){try{return L.require(C)}finally{}};return N.resolve=function(C,l){return w._resolveFilename(C,L,!1,l)},N.resolve.paths=function(C){return w._resolveLookupPaths(C,L)},N.main=process.mainModule,N.extensions=w._extensions,N.cache=w._cache,N}f.prototype._compile=function(L,w){var N=f.wrap(L.replace(/^#!.*/,"")),d=p.getRecorder(),C=b._getCachedDataPath(e,w),l={filename:w},h;try{var s=b._fs.readFileSync(C);h=s.slice(0,16),l.cachedData=s.slice(16),d.record(60,C)}catch{d.record(61,C)}var a=new b._vm.Script(N,l),r=a.runInThisContext(l),u=b._path.dirname(w),m=g(this),S=[this.exports,m,this,w,u,process,Re,Buffer],R=r.apply(this.exports,S);return b._handleCachedData(a,N,C,!l.cachedData,p),b._verifyCachedData(a,N,C,h,p),R}},o.prototype.load=function(c,p,e,b){var f=this,g=c.getConfig().getOptionsLiteral(),L=y(c.getRecorder(),g.nodeRequire||U.global.nodeRequire),w=g.nodeInstrumenter||function(r){return r};this._init(L),this._initNodeRequire(L,c);var N=c.getRecorder();if(/^node\|/.test(p)){var d=p.split("|"),C=null;try{C=L(d[1])}catch(r){b(r);return}c.enqueueDefineAnonymousModule([],function(){return C}),e()}else{p=U.Utilities.fileUriToFilePath(this._env.isWindows,p);var l=this._path.normalize(p),h=this._getElectronRendererScriptPathOrUri(l),s=Boolean(g.nodeCachedData),a=s?this._getCachedDataPath(g.nodeCachedData,p):void 0;this._readSourceAndCachedData(l,a,N,function(r,u,m,S){if(r){b(r);return}var R;u.charCodeAt(0)===o._BOM?R=o._PREFIX+u.substring(1)+o._SUFFIX:R=o._PREFIX+u+o._SUFFIX,R=w(R,l);var E={filename:h,cachedData:m},P=f._createAndEvalScript(c,R,E,e,b);f._handleCachedData(P,R,a,s&&!m,c),f._verifyCachedData(P,R,a,S,c)})}},o.prototype._createAndEvalScript=function(c,p,e,b,f){var g=c.getRecorder();g.record(31,e.filename);var L=new this._vm.Script(p,e),w=L.runInThisContext(e),N=c.getGlobalAMDDefineFunc(),d=!1,C=function(){return d=!0,N.apply(null,arguments)};return C.amd=N.amd,w.call(U.global,c.getGlobalAMDRequireFunc(),C,e.filename,this._path.dirname(e.filename)),g.record(32,e.filename),d?b():f(new Error("Didn't receive define call in "+e.filename+"!")),L},o.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var p=c.match(/^([a-z])\:(.*)/i);return p?"file:///"+(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/"):"file://"+c},o.prototype._getCachedDataPath=function(c,p){var e=this._crypto.createHash("md5").update(p,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(p).replace(/\.js$/,"");return this._path.join(c.path,b+"-"+e+".code")},o.prototype._handleCachedData=function(c,p,e,b,f){var g=this;c.cachedDataRejected?this._fs.unlink(e,function(L){f.getRecorder().record(62,e),g._createAndWriteCachedData(c,p,e,f),L&&f.getConfig().onError(L)}):b&&this._createAndWriteCachedData(c,p,e,f)},o.prototype._createAndWriteCachedData=function(c,p,e,b){var f=this,g=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,w=0,N=void 0,d=function(){setTimeout(function(){N||(N=f._crypto.createHash("md5").update(p,"utf8").digest());var C=c.createCachedData();if(!(C.length===0||C.length===L||w>=5)){if(C.length<L){d();return}L=C.length,f._fs.writeFile(e,Buffer.concat([N,C]),function(l){l&&b.getConfig().onError(l),b.getRecorder().record(63,e),d()})}},g*Math.pow(4,w++))};d()},o.prototype._readSourceAndCachedData=function(c,p,e,b){if(!p)this._fs.readFile(c,{encoding:"utf8"},b);else{var f=void 0,g=void 0,L=void 0,w=2,N=function(d){d?b(d):--w===0&&b(void 0,f,g,L)};this._fs.readFile(c,{encoding:"utf8"},function(d,C){f=C,N(d)}),this._fs.readFile(p,function(d,C){!d&&C&&C.length>0?(L=C.slice(0,16),g=C.slice(16),e.record(60,p)):e.record(61,p),N()})}},o.prototype._verifyCachedData=function(c,p,e,b,f){var g=this;!b||c.cachedDataRejected||setTimeout(function(){var L=g._crypto.createHash("md5").update(p,"utf8").digest();b.equals(L)||(f.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+e+"' now, but a RESTART IS REQUIRED")),g._fs.unlink(e,function(w){w&&f.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function y(o,c){if(c.__$__isRecorded)return c;var p=function(b){o.record(33,b);try{return c(b)}finally{o.record(34,b)}};return p.__$__isRecorded=!0,p}U.ensureRecordedNodeRequire=y;function v(o){return new i(o)}U.createScriptLoader=v})(ae||(ae={}));var ae;(function(U){var i=function(){function v(o){var c=o.lastIndexOf("/");c!==-1?this.fromModulePath=o.substr(0,c+1):this.fromModulePath=""}return v._normalizeModuleId=function(o){var c=o,p;for(p=/\/\.\//;p.test(c);)c=c.replace(p,"/");for(c=c.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(c);)c=c.replace(p,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},v.prototype.resolveModule=function(o){var c=o;return U.Utilities.isAbsolutePath(c)||(U.Utilities.startsWith(c,"./")||U.Utilities.startsWith(c,"../"))&&(c=v._normalizeModuleId(this.fromModulePath+c)),c},v.ROOT=new v(""),v}();U.ModuleIdResolver=i;var _=function(){function v(o,c,p,e,b,f){this.id=o,this.strId=c,this.dependencies=p,this._callback=e,this._errorback=b,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return v._safeInvokeFunction=function(o,c){try{return{returnedValue:o.apply(U.global,c),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}},v._invokeFactory=function(o,c,p,e){return o.shouldInvokeFactory(c)?o.shouldCatchError()?this._safeInvokeFunction(p,e):{returnedValue:p.apply(U.global,e),producedError:null}:{returnedValue:null,producedError:null}},v.prototype.complete=function(o,c,p,e){this._isComplete=!0;var b=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var f=v._invokeFactory(c,this.strId,this._callback,p);b=f.producedError,o.record(22,this.strId),!b&&typeof f.returnedValue<"u"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=f.returnedValue)}else this.exports=this._callback;if(b){var g=U.ensureError(b);g.phase="factory",g.moduleId=this.strId,g.neededBy=e(this.id),this.error=g,c.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},v.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},v.prototype.isComplete=function(){return this._isComplete},v}();U.Module=_;var M=function(){function v(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return v.prototype.getMaxModuleId=function(){return this._nextId},v.prototype.getModuleId=function(o){var c=this._strModuleIdToIntModuleId.get(o);return typeof c>"u"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(o,c),this._intModuleIdToStrModuleId[c]=o),c},v.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},v}(),A=function(){function v(o){this.id=o}return v.EXPORTS=new v(0),v.MODULE=new v(1),v.REQUIRE=new v(2),v}();U.RegularDependency=A;var t=function(){function v(o,c,p){this.id=o,this.pluginId=c,this.pluginParam=p}return v}();U.PluginDependency=t;var y=function(){function v(o,c,p,e,b){b===void 0&&(b=0),this._env=o,this._scriptLoader=c,this._loaderAvailableTimestamp=b,this._defineFunc=p,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return v.prototype.reset=function(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},v.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},v.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},v._findRelevantLocationInStack=function(o,c){for(var p=function(l){return l.replace(/\\/g,"/")},e=p(o),b=c.split(/\n/),f=0;f<b.length;f++){var g=b[f].match(/(.*):(\d+):(\d+)\)?$/);if(g){var L=g[1],w=g[2],N=g[3],d=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(d),L=p(L),L===e){var C={line:parseInt(w,10),col:parseInt(N,10)};return C.line===1&&(C.col-=53),C}}}throw new Error("Could not correlate define call site for needle "+o)},v.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],c=0,p=0,e=this._modules2.length;p<e;p++){var b=this._modules2[p];if(!!b){var f=this._buildInfoPath[b.id]||null,g=this._buildInfoDefineStack[b.id]||null,L=this._buildInfoDependencies[b.id];o[c++]={id:b.strId,path:f,defineLocation:f&&g?v._findRelevantLocationInStack(f,g):null,dependencies:L,shim:null,exports:b.exports}}}return o},v.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder},v.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},v.prototype.enqueueDefineAnonymousModule=function(o,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:o,callback:c}},v.prototype.defineModule=function(o,c,p,e,b,f){var g=this;f===void 0&&(f=new i(o));var L=this._moduleIdProvider.getModuleId(o);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var w=new _(L,o,this._normalizeDependencies(c,f),p,e,f);this._modules2[L]=w,this._config.isBuild()&&(this._buildInfoDefineStack[L]=b,this._buildInfoDependencies[L]=(w.dependencies||[]).map(function(N){return g._moduleIdProvider.getStrModuleId(N.id)})),this._resolve(w)},v.prototype._normalizeDependency=function(o,c){if(o==="exports")return A.EXPORTS;if(o==="module")return A.MODULE;if(o==="require")return A.REQUIRE;var p=o.indexOf("!");if(p>=0){var e=c.resolveModule(o.substr(0,p)),b=c.resolveModule(o.substr(p+1)),f=this._moduleIdProvider.getModuleId(e+"!"+b),g=this._moduleIdProvider.getModuleId(e);return new t(f,g,b)}return new A(this._moduleIdProvider.getModuleId(c.resolveModule(o)))},v.prototype._normalizeDependencies=function(o,c){for(var p=[],e=0,b=0,f=o.length;b<f;b++)p[e++]=this._normalizeDependency(o[b],c);return p},v.prototype._relativeRequire=function(o,c,p,e){if(typeof c=="string")return this.synchronousRequire(c,o);this.defineModule(U.Utilities.generateAnonymousModule(),c,p,e,null,o)},v.prototype.synchronousRequire=function(o,c){c===void 0&&(c=new i(o));var p=this._normalizeDependency(o,c),e=this._modules2[p.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports},v.prototype.configure=function(o,c){var p=this._config.shouldRecordStats();c?this._config=new U.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!p&&(this._recorder=null)},v.prototype.getConfig=function(){return this._config},v.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),c.dependencies,c.callback,null,c.stack)}},v.prototype._createLoadError=function(o,c){var p=this,e=this._moduleIdProvider.getStrModuleId(o),b=(this._inverseDependencies2[o]||[]).map(function(g){return p._moduleIdProvider.getStrModuleId(g)}),f=U.ensureError(c);return f.phase="loading",f.moduleId=e,f.neededBy=b,f},v.prototype._onLoadError=function(o,c){var p=this._createLoadError(o,c);this._modules2[o]||(this._modules2[o]=new _(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var e=[],b=0,f=this._moduleIdProvider.getMaxModuleId();b<f;b++)e[b]=!1;var g=!1,L=[];for(L.push(o),e[o]=!0;L.length>0;){var w=L.shift(),N=this._modules2[w];N&&(g=N.onDependencyError(p)||g);var d=this._inverseDependencies2[w];if(d)for(var b=0,f=d.length;b<f;b++){var C=d[b];e[C]||(L.push(C),e[C]=!0)}}g||this._config.onError(p)},v.prototype._hasDependencyPath=function(o,c){var p=this._modules2[o];if(!p)return!1;for(var e=[],b=0,f=this._moduleIdProvider.getMaxModuleId();b<f;b++)e[b]=!1;var g=[];for(g.push(p),e[o]=!0;g.length>0;){var L=g.shift(),w=L.dependencies;if(w)for(var b=0,f=w.length;b<f;b++){var N=w[b];if(N.id===c)return!0;var d=this._modules2[N.id];d&&!e[N.id]&&(e[N.id]=!0,g.push(d))}}return!1},v.prototype._findCyclePath=function(o,c,p){if(o===c||p===50)return[o];var e=this._modules2[o];if(!e)return null;var b=e.dependencies;if(b)for(var f=0,g=b.length;f<g;f++){var L=this._findCyclePath(b[f].id,c,p+1);if(L!==null)return L.push(o),L}return null},v.prototype._createRequire=function(o){var c=this,p=function(e,b,f){return c._relativeRequire(o,e,b,f)};return p.toUrl=function(e){return c._config.requireToUrl(o.resolveModule(e))},p.getStats=function(){return c.getLoaderEvents()},p.hasDependencyCycle=function(){return c._hasDependencyCycle},p.config=function(e,b){b===void 0&&(b=!1),c.configure(e,b)},p.__$__nodeRequire=U.global.nodeRequire,p},v.prototype._loadModule=function(o){var c=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var p=this._moduleIdProvider.getStrModuleId(o),e=this._config.moduleIdToPaths(p),b=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(p.indexOf("/")===-1||b.test(p))&&e.push("node|"+p);var f=-1,g=function(L){if(f++,f>=e.length)c._onLoadError(o,L);else{var w=e[f],N=c.getRecorder();if(c._config.isBuild()&&w==="empty:"){c._buildInfoPath[o]=w,c.defineModule(c._moduleIdProvider.getStrModuleId(o),[],null,null,null),c._onLoad(o);return}N.record(10,w),c._scriptLoader.load(c,w,function(){c._config.isBuild()&&(c._buildInfoPath[o]=w),N.record(11,w),c._onLoad(o)},function(d){N.record(12,w),g(d)})}};g(null)}},v.prototype._loadPluginDependency=function(o,c){var p=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var e=function(b){p.defineModule(p._moduleIdProvider.getStrModuleId(c.id),[],b,null,null)};e.error=function(b){p._config.onError(p._createLoadError(c.id,b))},o.load(c.pluginParam,this._createRequire(i.ROOT),e,this._config.getOptionsLiteral())}},v.prototype._resolve=function(o){var c=this,p=o.dependencies;if(p)for(var e=0,b=p.length;e<b;e++){var f=p[e];if(f===A.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(f===A.MODULE){o.unresolvedDependenciesCount--;continue}if(f===A.REQUIRE){o.unresolvedDependenciesCount--;continue}var g=this._modules2[f.id];if(g&&g.isComplete()){if(g.error){o.onDependencyError(g.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var L=this._findCyclePath(f.id,o.id,0)||[];L.reverse(),L.push(f.id),console.warn(L.map(function(d){return c._moduleIdProvider.getStrModuleId(d)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(o.id),f instanceof t){var w=this._modules2[f.pluginId];if(w&&w.isComplete()){this._loadPluginDependency(w.exports,f);continue}var N=this._inversePluginDependencies2.get(f.pluginId);N||(N=[],this._inversePluginDependencies2.set(f.pluginId,N)),N.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},v.prototype._onModuleComplete=function(o){var c=this,p=this.getRecorder();if(!o.isComplete()){var e=o.dependencies,b=[];if(e)for(var f=0,g=e.length;f<g;f++){var L=e[f];if(L===A.EXPORTS){b[f]=o.exports;continue}if(L===A.MODULE){b[f]={id:o.strId,config:function(){return c._config.getConfigForModule(o.strId)}};continue}if(L===A.REQUIRE){b[f]=this._createRequire(o.moduleIdResolver);continue}var w=this._modules2[L.id];if(w){b[f]=w.exports;continue}b[f]=null}var N=function(s){return(c._inverseDependencies2[s]||[]).map(function(a){return c._moduleIdProvider.getStrModuleId(a)})};o.complete(p,this._config,b,N);var d=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,d)for(var f=0,g=d.length;f<g;f++){var C=d[f],l=this._modules2[C];l.unresolvedDependenciesCount--,l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}var h=this._inversePluginDependencies2.get(o.id);if(h){this._inversePluginDependencies2.delete(o.id);for(var f=0,g=h.length;f<g;f++)this._loadPluginDependency(o.exports,h[f])}}},v}();U.ModuleManager=y})(ae||(ae={}));var Y,ae;(function(U){var i=new U.Environment,_=null,M=function(v,o,c){typeof v!="string"&&(c=o,o=v,v=null),(typeof o!="object"||!Array.isArray(o))&&(c=o,o=null),o||(o=["require","exports","module"]),v?_.defineModule(v,o,c,null,null):_.enqueueDefineAnonymousModule(o,c)};M.amd={jQuery:!0};var A=function(v,o){o===void 0&&(o=!1),_.configure(v,o)},t=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};t.config=A,t.getConfig=function(){return _.getConfig().getOptionsLiteral()},t.reset=function(){_=_.reset()},t.getBuildInfo=function(){return _.getBuildInfo()},t.getStats=function(){return _.getLoaderEvents()},t.define=M;function y(){if(typeof U.global.require<"u"||typeof require<"u"){var v=U.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){var o=U.ensureRecordedNodeRequire(_.getRecorder(),v);U.global.nodeRequire=o,t.nodeRequire=o,t.__$__nodeRequire=o}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=t:(i.isElectronRenderer||(U.global.define=M),U.global.require=t)}U.init=y,(typeof U.global.define!="function"||!U.global.define.amd)&&(_=new U.ModuleManager(i,U.createScriptLoader(i),M,t,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require<"u"&&typeof U.global.require!="function"&&t.config(U.global.require),Y=function(){return M.apply(null,arguments)},Y.amd=M.amd,typeof doNotInitLoader>"u"&&y())})(ae||(ae={}));var le=this&&this.__awaiter||function(U,i,_,M){function A(t){return t instanceof _?t:new _(function(y){y(t)})}return new(_||(_=Promise))(function(t,y){function v(p){try{c(M.next(p))}catch(e){y(e)}}function o(p){try{c(M.throw(p))}catch(e){y(e)}}function c(p){p.done?t(p.value):A(p.value).then(v,o)}c((M=M.apply(U,i||[])).next())})};Y(X[22],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=i.create=i.setPseudoTranslation=i.getConfiguredDefaultLocale=i.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function A(g,L){let w;return L.length===0?w=g:w=g.replace(/\{(\d+)\}/g,(N,d)=>{const C=d[0],l=L[C];let h=N;return typeof l=="string"?h=l:(typeof l=="number"||typeof l=="boolean"||l===void 0||l===null)&&(h=String(l)),h}),_&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function t(g,L){let w=g[L];return w||(w=g["*"],w)?w:null}function y(g){return g.charAt(g.length-1)==="/"?g:g+"/"}function v(g,L,w){return le(this,void 0,void 0,function*(){const N=y(g)+y(L)+"vscode/"+y(w),d=yield fetch(N);if(d.ok)return yield d.json();throw new Error(`${d.status} - ${d.statusText}`)})}function o(g){return function(L,w){const N=Array.prototype.slice.call(arguments,2);return A(g[L],N)}}function c(g,L,...w){return A(L,w)}i.localize=c;function p(g){}i.getConfiguredDefaultLocale=p;function e(g){_=g}i.setPseudoTranslation=e;function b(g,L){var w;return{localize:o(L[g]),getConfiguredDefaultLocale:(w=L.getConfiguredDefaultLocale)!==null&&w!==void 0?w:N=>{}}}i.create=b;function f(g,L,w,N){var d;const C=(d=N["vs/nls"])!==null&&d!==void 0?d:{};if(!g||g.length===0)return w({localize:c,getConfiguredDefaultLocale:()=>{var r;return(r=C.availableLanguages)===null||r===void 0?void 0:r["*"]}});const l=C.availableLanguages?t(C.availableLanguages,g):null,h=l===null||l===M;let s=".nls";h||(s=s+"."+l);const a=r=>{Array.isArray(r)?r.localize=o(r):r.localize=o(r[g]),r.getConfiguredDefaultLocale=()=>{var u;return(u=C.availableLanguages)===null||u===void 0?void 0:u["*"]},w(r)};typeof C.loadBundle=="function"?C.loadBundle(g,l,(r,u)=>{r?L([g+".nls"],a):a(u)}):C.translationServiceUrl&&!h?le(this,void 0,void 0,function*(){var r;try{const u=yield v(C.translationServiceUrl,l,g);return a(u)}catch(u){if(!l.includes("-"))return console.error(u),L([g+".nls"],a);try{const m=l.split("-")[0],S=yield v(C.translationServiceUrl,m,g);return(r=C.availableLanguages)!==null&&r!==void 0||(C.availableLanguages={}),C.availableLanguages["*"]=m,a(S)}catch(m){return console.error(m),L([g+".nls"],a)}}}):L([g+s],a,r=>{if(s===".nls"){console.error("Failed trying to load default language strings",r);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,r),L([g+".nls"],a)})}i.load=f}),function(){var U,i;const _=self.MonacoEnvironment,M=_&&_.baseUrl?_.baseUrl:"../../../",A=typeof((U=self.trustedTypes)===null||U===void 0?void 0:U.createPolicy)=="function"?(i=self.trustedTypes)===null||i===void 0?void 0:i.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,...b)=>{const f=b.slice(0,-1).join(","),g=b.pop().toString();return`(function anonymous(${f}) { ${g}
})`}}):void 0;function t(){try{return(A?self.eval(A.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function y(){return new Promise((e,b)=>{if(typeof self.define=="function"&&self.define.amd)return e();const f=M+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&t()){fetch(f).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${f}`,(A?self.eval(A.createScript("",L)):new Function(L)).call(self),e()}).then(void 0,b);return}A?importScripts(A.createScriptURL(f)):importScripts(f),e()})}function v(){require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:A,amdModulesPattern:/^vs\//})}function o(e){y().then(()=>{v(),require([e],function(b){setTimeout(function(){const f=b.create((g,L)=>{self.postMessage(g,L)},null);for(self.onmessage=g=>f.onmessage(g.data,g.ports);p.length>0;)self.onmessage(p.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&v();let c=!0;const p=[];self.onmessage=e=>{if(!c){p.push(e);return}c=!1,o(e.data)}}(),Y(X[23],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CallbackIterable=i.ArrayQueue=i.findMinBy=i.findLastMaxBy=i.findMaxBy=i.numberComparator=i.compareBy=i.CompareResult=i.splice=i.insertInto=i.asArray=i.pushMany=i.pushToEnd=i.pushToStart=i.arrayInsert=i.range=i.firstOrDefault=i.lastIndex=i.findLast=i.distinct=i.isNonEmptyArray=i.isFalsyOrEmpty=i.coalesce=i.groupBy=i.quickSelect=i.findFirstInSorted=i.binarySearch2=i.binarySearch=i.removeFastWithoutKeepingOrder=i.equals=i.tail2=i.tail=void 0;function _(k,I=0){return k[k.length-(1+I)]}i.tail=_;function M(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}i.tail2=M;function A(k,I,T=(W,z)=>W===z){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let W=0,z=k.length;W<z;W++)if(!T(k[W],I[W]))return!1;return!0}i.equals=A;function t(k,I){const T=k.length-1;I<T&&(k[I]=k[T]),k.pop()}i.removeFastWithoutKeepingOrder=t;function y(k,I,T){return v(k.length,W=>T(k[W],I))}i.binarySearch=y;function v(k,I){let T=0,W=k-1;for(;T<=W;){const z=(T+W)/2|0,n=I(z);if(n<0)T=z+1;else if(n>0)W=z-1;else return z}return-(T+1)}i.binarySearch2=v;function o(k,I){let T=0,W=k.length;if(W===0)return 0;for(;T<W;){const z=Math.floor((T+W)/2);I(k[z])?W=z:T=z+1}return T}i.findFirstInSorted=o;function c(k,I,T){if(k=k|0,k>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],z=[],n=[],se=[];for(const de of I){const ge=T(de,W);ge<0?z.push(de):ge>0?n.push(de):se.push(de)}return k<z.length?c(k,z,T):k<z.length+se.length?se[0]:c(k-(z.length+se.length),n,T)}i.quickSelect=c;function p(k,I){const T=[];let W;for(const z of k.slice(0).sort(I))!W||I(W[0],z)!==0?(W=[z],T.push(W)):W.push(z);return T}i.groupBy=p;function e(k){return k.filter(I=>!!I)}i.coalesce=e;function b(k){return!Array.isArray(k)||k.length===0}i.isFalsyOrEmpty=b;function f(k){return Array.isArray(k)&&k.length>0}i.isNonEmptyArray=f;function g(k,I=T=>T){const T=new Set;return k.filter(W=>{const z=I(W);return T.has(z)?!1:(T.add(z),!0)})}i.distinct=g;function L(k,I){const T=w(k,I);if(T!==-1)return k[T]}i.findLast=L;function w(k,I){for(let T=k.length-1;T>=0;T--){const W=k[T];if(I(W))return T}return-1}i.lastIndex=w;function N(k,I){return k.length>0?k[0]:I}i.firstOrDefault=N;function d(k,I){let T=typeof I=="number"?k:0;typeof I=="number"?T=k:(T=0,I=k);const W=[];if(T<=I)for(let z=T;z<I;z++)W.push(z);else for(let z=T;z>I;z--)W.push(z);return W}i.range=d;function C(k,I,T){const W=k.slice(0,I),z=k.slice(I);return W.concat(T,z)}i.arrayInsert=C;function l(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.unshift(I))}i.pushToStart=l;function h(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.push(I))}i.pushToEnd=h;function s(k,I){for(const T of I)k.push(T)}i.pushMany=s;function a(k){return Array.isArray(k)?k:[k]}i.asArray=a;function r(k,I,T){const W=m(k,I),z=k.length,n=T.length;k.length=z+n;for(let se=z-1;se>=W;se--)k[se+n]=k[se];for(let se=0;se<n;se++)k[se+W]=T[se]}i.insertInto=r;function u(k,I,T,W){const z=m(k,I),n=k.splice(z,T);return r(k,z,W),n}i.splice=u;function m(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}var S;(function(k){function I(z){return z<0}k.isLessThan=I;function T(z){return z>0}k.isGreaterThan=T;function W(z){return z===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(S=i.CompareResult||(i.CompareResult={}));function R(k,I){return(T,W)=>I(k(T),k(W))}i.compareBy=R;const E=(k,I)=>k-I;i.numberComparator=E;function P(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const z=k[W];I(z,T)>0&&(T=z)}return T}i.findMaxBy=P;function F(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const z=k[W];I(z,T)>=0&&(T=z)}return T}i.findLastMaxBy=F;function V(k,I){return P(k,(T,W)=>-I(T,W))}i.findMinBy=V;class O{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let T=this.c;for(;T<this.f.length&&I(this.f[T]);)T++;const W=T===this.c?null:this.f.slice(this.c,T);return this.c=T,W}takeFromEndWhile(I){let T=this.d;for(;T>=0&&I(this.f[T]);)T--;const W=T===this.d?null:this.f.slice(T+1,this.d+1);return this.d=T,W}peek(){if(this.length!==0)return this.f[this.c]}dequeue(){const I=this.f[this.c];return this.c++,I}takeCount(I){const T=this.f.slice(this.c,this.c+I);return this.c+=I,T}}i.ArrayQueue=O;class q{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(T=>(I.push(T),!0)),I}filter(I){return new q(T=>this.iterate(W=>I(W)?T(W):!0))}map(I){return new q(T=>this.iterate(W=>T(I(W))))}findLast(I){let T;return this.iterate(W=>(I(W)&&(T=W),!0)),T}findLastMaxBy(I){let T,W=!0;return this.iterate(z=>((W||S.isGreaterThan(I(z,T)))&&(W=!1,T=z),!0)),T}}i.CallbackIterable=q,q.empty=new q(k=>{})}),Y(X[24],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CachedFunction=i.LRUCachedFunction=void 0;class _{constructor(t){this.c=t,this.a=void 0,this.b=void 0}get(t){const y=JSON.stringify(t);return this.b!==y&&(this.b=y,this.a=this.c(t)),this.a}}i.LRUCachedFunction=_;class M{get cachedValues(){return this.a}constructor(t){this.b=t,this.a=new Map}get(t){if(this.a.has(t))return this.a.get(t);const y=this.b(t);return this.a.set(t,y),y}}i.CachedFunction=M}),Y(X[25],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffChange=void 0;class _{constructor(A,t,y,v){this.originalStart=A,this.originalLength=t,this.modifiedStart=y,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.DiffChange=_}),Y(X[8],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BugIndicatingError=i.ErrorNoTelemetry=i.NotSupportedError=i.illegalState=i.illegalArgument=i.canceled=i.CancellationError=i.isCancellationError=i.transformErrorForSerialization=i.onUnexpectedExternalError=i.onUnexpectedError=i.errorHandler=i.ErrorHandler=void 0;class _{constructor(){this.b=[],this.a=function(w){setTimeout(()=>{throw w.stack?f.isErrorNoTelemetry(w)?new f(w.message+`

`+w.stack):new Error(w.message+`

`+w.stack):w},0)}}c(w){this.b.forEach(N=>{N(w)})}onUnexpectedError(w){this.a(w),this.c(w)}onUnexpectedExternalError(w){this.a(w)}}i.ErrorHandler=_,i.errorHandler=new _;function M(L){v(L)||i.errorHandler.onUnexpectedError(L)}i.onUnexpectedError=M;function A(L){v(L)||i.errorHandler.onUnexpectedExternalError(L)}i.onUnexpectedExternalError=A;function t(L){if(L instanceof Error){const{name:w,message:N}=L,d=L.stacktrace||L.stack;return{$isError:!0,name:w,message:N,stack:d,noTelemetry:f.isErrorNoTelemetry(L)}}return L}i.transformErrorForSerialization=t;const y="Canceled";function v(L){return L instanceof o?!0:L instanceof Error&&L.name===y&&L.message===y}i.isCancellationError=v;class o extends Error{constructor(){super(y),this.name=this.message}}i.CancellationError=o;function c(){const L=new Error(y);return L.name=L.message,L}i.canceled=c;function p(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}i.illegalArgument=p;function e(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}i.illegalState=e;class b extends Error{constructor(w){super("NotSupported"),w&&(this.message=w)}}i.NotSupportedError=b;class f extends Error{constructor(w){super(w),this.name="CodeExpectedError"}static fromError(w){if(w instanceof f)return w;const N=new f;return N.message=w.message,N.stack=w.stack,N}static isErrorNoTelemetry(w){return w.name==="CodeExpectedError"}}i.ErrorNoTelemetry=f;class g extends Error{constructor(w){super(w||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}i.BugIndicatingError=g}),Y(X[9],Q([0,1,8]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.checkAdjacentItems=i.assertFn=i.assertNever=i.ok=void 0;function M(v,o){if(!v)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}i.ok=M;function A(v,o="Unreachable"){throw new Error(o)}i.assertNever=A;function t(v){if(!v()){debugger;v(),(0,_.onUnexpectedError)(new _.BugIndicatingError("Assertion Failed"))}}i.assertFn=t;function y(v,o){let c=0;for(;c<v.length-1;){const p=v[c],e=v[c+1];if(!o(p,e))return!1;c++}return!0}i.checkAdjacentItems=y}),Y(X[26],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.once=void 0;function _(M){const A=this;let t=!1,y;return function(){return t||(t=!0,y=M.apply(A,arguments)),y}}i.once=_}),Y(X[13],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var _;(function(M){function A(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}M.is=A;const t=Object.freeze([]);function y(){return t}M.empty=y;function*v(l){yield l}M.single=v;function o(l){return A(l)?l:v(l)}M.wrap=o;function c(l){return l||t}M.from=c;function p(l){return!l||l[Symbol.iterator]().next().done===!0}M.isEmpty=p;function e(l){return l[Symbol.iterator]().next().value}M.first=e;function b(l,h){for(const s of l)if(h(s))return!0;return!1}M.some=b;function f(l,h){for(const s of l)if(h(s))return s}M.find=f;function*g(l,h){for(const s of l)h(s)&&(yield s)}M.filter=g;function*L(l,h){let s=0;for(const a of l)yield h(a,s++)}M.map=L;function*w(...l){for(const h of l)for(const s of h)yield s}M.concat=w;function N(l,h,s){let a=s;for(const r of l)a=h(a,r);return a}M.reduce=N;function*d(l,h,s=l.length){for(h<0&&(h+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);h<s;h++)yield l[h]}M.slice=d;function C(l,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,l];const a=l[Symbol.iterator]();for(let r=0;r<h;r++){const u=a.next();if(u.done)return[s,M.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return a}}]}M.consume=C})(_=i.Iterable||(i.Iterable={}))}),Y(X[27],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyChord=i.KeyCodeUtils=i.IMMUTABLE_KEY_CODE_TO_CODE=i.IMMUTABLE_CODE_TO_KEY_CODE=i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=i.EVENT_KEY_CODE_MAP=void 0;class _{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,f){this._keyCodeToStr[b]=f,this._strToKeyCode[f.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||0}}const M=new _,A=new _,t=new _;i.EVENT_KEY_CODE_MAP=new Array(230),i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const y=[],v=Object.create(null),o=Object.create(null);i.IMMUTABLE_CODE_TO_KEY_CODE=[],i.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)i.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)i.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",b=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],f=[],g=[];for(const L of b){const[w,N,d,C,l,h,s,a,r,u]=L;if(g[d]||(g[d]=!0,y[d]=C,v[C]=d,o[C.toLowerCase()]=d,N&&(i.IMMUTABLE_CODE_TO_KEY_CODE[d]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(i.IMMUTABLE_KEY_CODE_TO_CODE[l]=d))),!f[l]){if(f[l]=!0,!h)throw new Error(`String representation missing for key code ${l} around scan code ${C}`);M.define(l,h),A.define(l,r||h),t.define(l,u||r||h)}s&&(i.EVENT_KEY_CODE_MAP[s]=l),a&&(i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=l)}i.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var c;(function(e){function b(d){return M.keyCodeToStr(d)}e.toString=b;function f(d){return M.strToKeyCode(d)}e.fromString=f;function g(d){return A.keyCodeToStr(d)}e.toUserSettingsUS=g;function L(d){return t.keyCodeToStr(d)}e.toUserSettingsGeneral=L;function w(d){return A.strToKeyCode(d)||t.strToKeyCode(d)}e.fromUserSettings=w;function N(d){if(d>=93&&d<=108)return null;switch(d){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(d)}e.toElectronAccelerator=N})(c=i.KeyCodeUtils||(i.KeyCodeUtils={}));function p(e,b){const f=(b&65535)<<16>>>0;return(e|f)>>>0}i.KeyChord=p}),Y(X[28],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Lazy=void 0;class _{constructor(A){this.d=A,this.a=!1}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.Lazy=_}),Y(X[10],Q([0,1,26,13]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DisposableMap=i.ImmortalReference=i.SafeDisposable=i.RefCountedDisposable=i.MutableDisposable=i.Disposable=i.DisposableStore=i.toDisposable=i.combinedDisposable=i.dispose=i.isDisposable=i.markAsSingleton=i.setDisposableTracker=void 0;const A=!1;let t=null;function y(a){t=a}if(i.setDisposableTracker=y,A){const a="__is_disposable_tracked__";y(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==N.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==N.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function v(a){return t?.trackDisposable(a),a}function o(a){t?.markAsDisposed(a)}function c(a,r){t?.setParent(a,r)}function p(a,r){if(!!t)for(const u of a)t.setParent(u,r)}function e(a){return t?.markAsSingleton(a),a}i.markAsSingleton=e;function b(a){return typeof a.dispose=="function"&&a.dispose.length===0}i.isDisposable=b;function f(a){if(M.Iterable.is(a)){const r=[];for(const u of a)if(u)try{u.dispose()}catch(m){r.push(m)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}i.dispose=f;function g(...a){const r=L(()=>f(a));return p(a,r),r}i.combinedDisposable=g;function L(a){const r=v({dispose:(0,_.once)(()=>{o(r),a()})});return r}i.toDisposable=L;class w{constructor(){this.a=new Set,this.b=!1,v(this)}dispose(){this.b||(o(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(this.a.size!==0)try{f(this.a)}finally{this.a.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return c(r,this),this.b?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(r),r}}i.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this.f=new w,v(this),c(this.f,this)}dispose(){o(this),this.f.dispose()}q(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(r)}}i.Disposable=N,N.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(r){var u;this.b||r===this.a||((u=this.a)===null||u===void 0||u.dispose(),r&&c(r,this),this.a=r)}clear(){this.value=void 0}dispose(){var r;this.b=!0,o(this),(r=this.a)===null||r===void 0||r.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&c(r,null),r}}i.MutableDisposable=d;class C{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.RefCountedDisposable=C;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(r){let u=r;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,o(this))},this}}i.SafeDisposable=l;class h{constructor(r){this.object=r}dispose(){}}i.ImmortalReference=h;class s{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}get(r){return this.a.get(r)}set(r,u,m=!1){var S;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||(S=this.a.get(r))===null||S===void 0||S.dispose(),this.a.set(r,u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.DisposableMap=s}),Y(X[14],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkedList=void 0;class _{constructor(t){this.element=t,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class M{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let t=this.a;for(;t!==_.Undefined;){const y=t.next;t.prev=_.Undefined,t.next=_.Undefined,t=y}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(t){return this.d(t,!1)}push(t){return this.d(t,!0)}d(t,y){const v=new _(t);if(this.a===_.Undefined)this.a=v,this.b=v;else if(y){const c=this.b;this.b=v,v.prev=c,c.next=v}else{const c=this.a;this.a=v,v.next=c,c.prev=v}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(v))}}shift(){if(this.a!==_.Undefined){const t=this.a.element;return this.e(this.a),t}}pop(){if(this.b!==_.Undefined){const t=this.b.element;return this.e(this.b),t}}e(t){if(t.prev!==_.Undefined&&t.next!==_.Undefined){const y=t.prev;y.next=t.next,t.next.prev=y}else t.prev===_.Undefined&&t.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):t.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):t.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let t=this.a;for(;t!==_.Undefined;)yield t.element,t=t.next}}i.LinkedList=M}),Y(X[4],Q([0,1,24,28]),function(U,i,_,M){"use strict";var A;Object.defineProperty(i,"__esModule",{value:!0}),i.InvisibleCharacters=i.AmbiguousCharacters=i.noBreakWhitespace=i.getLeftDeleteOffset=i.singleLetterHash=i.containsUppercaseCharacter=i.startsWithUTF8BOM=i.UTF8_BOM_CHARACTER=i.isEmojiImprecise=i.isFullWidthCharacter=i.containsUnusualLineTerminators=i.UNUSUAL_LINE_TERMINATORS=i.isBasicASCII=i.containsRTL=i.getCharContainingOffset=i.prevCharLength=i.nextCharLength=i.GraphemeIterator=i.CodePointIterator=i.getNextCodePoint=i.computeCodePoint=i.isLowSurrogate=i.isHighSurrogate=i.commonSuffixLength=i.commonPrefixLength=i.startsWithIgnoreCase=i.equalsIgnoreCase=i.isUpperAsciiLetter=i.isLowerAsciiLetter=i.isAsciiDigit=i.compareSubstringIgnoreCase=i.compareIgnoreCase=i.compareSubstring=i.compare=i.lastNonWhitespaceIndex=i.getLeadingWhitespace=i.firstNonWhitespaceIndex=i.splitLines=i.regExpFlags=i.regExpLeadsToEndlessLoop=i.createRegExp=i.stripWildcards=i.convertSimple2RegExpPattern=i.rtrim=i.ltrim=i.trim=i.escapeRegExpCharacters=i.escape=i.format=i.isFalsyOrWhitespace=void 0;function t(D){return!D||typeof D!="string"?!0:D.trim().length===0}i.isFalsyOrWhitespace=t;const y=/{(\d+)}/g;function v(D,...B){return B.length===0?D:D.replace(y,function(x,j){const Z=parseInt(j,10);return isNaN(Z)||Z<0||Z>=B.length?x:B[Z]})}i.format=v;function o(D){return D.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}i.escape=o;function c(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}i.escapeRegExpCharacters=c;function p(D,B=" "){const x=e(D,B);return b(x,B)}i.trim=p;function e(D,B){if(!D||!B)return D;const x=B.length;if(x===0||D.length===0)return D;let j=0;for(;D.indexOf(B,j)===j;)j=j+x;return D.substring(j)}i.ltrim=e;function b(D,B){if(!D||!B)return D;const x=B.length,j=D.length;if(x===0||j===0)return D;let Z=j,ie=-1;for(;ie=D.lastIndexOf(B,Z-1),!(ie===-1||ie+x!==Z);){if(ie===0)return"";Z=ie}return D.substring(0,Z)}i.rtrim=b;function f(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}i.convertSimple2RegExpPattern=f;function g(D){return D.replace(/\*/g,"")}i.stripWildcards=g;function L(D,B,x={}){if(!D)throw new Error("Cannot create regex from empty string");B||(D=c(D)),x.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let j="";return x.global&&(j+="g"),x.matchCase||(j+="i"),x.multiline&&(j+="m"),x.unicode&&(j+="u"),new RegExp(D,j)}i.createRegExp=L;function w(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}i.regExpLeadsToEndlessLoop=w;function N(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}i.regExpFlags=N;function d(D){return D.split(/\r\n|\r|\n/)}i.splitLines=d;function C(D){for(let B=0,x=D.length;B<x;B++){const j=D.charCodeAt(B);if(j!==32&&j!==9)return B}return-1}i.firstNonWhitespaceIndex=C;function l(D,B=0,x=D.length){for(let j=B;j<x;j++){const Z=D.charCodeAt(j);if(Z!==32&&Z!==9)return D.substring(B,j)}return D.substring(B,x)}i.getLeadingWhitespace=l;function h(D,B=D.length-1){for(let x=B;x>=0;x--){const j=D.charCodeAt(x);if(j!==32&&j!==9)return x}return-1}i.lastNonWhitespaceIndex=h;function s(D,B){return D<B?-1:D>B?1:0}i.compare=s;function a(D,B,x=0,j=D.length,Z=0,ie=B.length){for(;x<j&&Z<ie;x++,Z++){const fe=D.charCodeAt(x),re=B.charCodeAt(Z);if(fe<re)return-1;if(fe>re)return 1}const oe=j-x,be=ie-Z;return oe<be?-1:oe>be?1:0}i.compareSubstring=a;function r(D,B){return u(D,B,0,D.length,0,B.length)}i.compareIgnoreCase=r;function u(D,B,x=0,j=D.length,Z=0,ie=B.length){for(;x<j&&Z<ie;x++,Z++){let fe=D.charCodeAt(x),re=B.charCodeAt(Z);if(fe===re)continue;if(fe>=128||re>=128)return a(D.toLowerCase(),B.toLowerCase(),x,j,Z,ie);S(fe)&&(fe-=32),S(re)&&(re-=32);const ce=fe-re;if(ce!==0)return ce}const oe=j-x,be=ie-Z;return oe<be?-1:oe>be?1:0}i.compareSubstringIgnoreCase=u;function m(D){return D>=48&&D<=57}i.isAsciiDigit=m;function S(D){return D>=97&&D<=122}i.isLowerAsciiLetter=S;function R(D){return D>=65&&D<=90}i.isUpperAsciiLetter=R;function E(D,B){return D.length===B.length&&u(D,B)===0}i.equalsIgnoreCase=E;function P(D,B){const x=B.length;return B.length>D.length?!1:u(D,B,0,x)===0}i.startsWithIgnoreCase=P;function F(D,B){const x=Math.min(D.length,B.length);let j;for(j=0;j<x;j++)if(D.charCodeAt(j)!==B.charCodeAt(j))return j;return x}i.commonPrefixLength=F;function V(D,B){const x=Math.min(D.length,B.length);let j;const Z=D.length-1,ie=B.length-1;for(j=0;j<x;j++)if(D.charCodeAt(Z-j)!==B.charCodeAt(ie-j))return j;return x}i.commonSuffixLength=V;function O(D){return 55296<=D&&D<=56319}i.isHighSurrogate=O;function q(D){return 56320<=D&&D<=57343}i.isLowSurrogate=q;function k(D,B){return(D-55296<<10)+(B-56320)+65536}i.computeCodePoint=k;function I(D,B,x){const j=D.charCodeAt(x);if(O(j)&&x+1<B){const Z=D.charCodeAt(x+1);if(q(Z))return k(j,Z)}return j}i.getNextCodePoint=I;function T(D,B){const x=D.charCodeAt(B-1);if(q(x)&&B>1){const j=D.charCodeAt(B-2);if(O(j))return k(j,x)}return x}class W{get offset(){return this.e}constructor(B,x=0){this.c=B,this.d=B.length,this.e=x}setOffset(B){this.e=B}prevCodePoint(){const B=T(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=I(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}i.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(B,x=0){this.c=new W(B,x)}nextGraphemeLength(){const B=ne.getInstance(),x=this.c,j=x.offset;let Z=B.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const ie=x.offset,oe=B.getGraphemeBreakType(x.nextCodePoint());if(te(Z,oe)){x.setOffset(ie);break}Z=oe}return x.offset-j}prevGraphemeLength(){const B=ne.getInstance(),x=this.c,j=x.offset;let Z=B.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const ie=x.offset,oe=B.getGraphemeBreakType(x.prevCodePoint());if(te(oe,Z)){x.setOffset(ie);break}Z=oe}return j-x.offset}eol(){return this.c.eol()}}i.GraphemeIterator=z;function n(D,B){return new z(D,B).nextGraphemeLength()}i.nextCharLength=n;function se(D,B){return new z(D,B).prevGraphemeLength()}i.prevCharLength=se;function de(D,B){B>0&&q(D.charCodeAt(B))&&B--;const x=B+n(D,B);return[x-se(D,x),x]}i.getCharContainingOffset=de;let ge;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(D){return ge||(ge=pe()),ge.test(D)}i.containsRTL=Se;const Ne=/^[\t\n\r\x20-\x7E]*$/;function _e(D){return Ne.test(D)}i.isBasicASCII=_e,i.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(D){return i.UNUSUAL_LINE_TERMINATORS.test(D)}i.containsUnusualLineTerminators=J;function H(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}i.isFullWidthCharacter=H;function G(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}i.isEmojiImprecise=G,i.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function $(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}i.startsWithUTF8BOM=$;function K(D,B=!1){return D?(B&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}i.containsUppercaseCharacter=K;function ee(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}i.singleLetterHash=ee;function te(D,B){return D===0?B!==5&&B!==7:D===2&&B===3?!1:D===4||D===2||D===3||B===4||B===2||B===3?!0:!(D===8&&(B===8||B===9||B===11||B===12)||(D===11||D===9)&&(B===9||B===10)||(D===12||D===10)&&B===10||B===5||B===13||B===7||D===1||D===13&&B===14||D===6&&B===6)}class ne{static getInstance(){return ne.c||(ne.c=new ne),ne.c}constructor(){this.d=ve()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const x=this.d,j=x.length/3;let Z=1;for(;Z<=j;)if(B<x[3*Z])Z=2*Z;else if(B>x[3*Z+1])Z=2*Z+1;else return x[3*Z+2];return 0}}ne.c=null;function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(D,B){if(D===0)return 0;const x=we(D,B);if(x!==void 0)return x;const j=new W(B,D);return j.prevCodePoint(),j.offset}i.getLeftDeleteOffset=Le;function we(D,B){const x=new W(B,D);let j=x.prevCodePoint();for(;Ce(j)||j===65039||j===8419;){if(x.offset===0)return;j=x.prevCodePoint()}if(!G(j))return;let Z=x.offset;return Z>0&&x.prevCodePoint()===8205&&(Z=x.offset),Z}function Ce(D){return 127995<=D&&D<=127999}i.noBreakWhitespace="\xA0";class ue{static getInstance(B){return ue.d.get(Array.from(B))}static getLocales(){return ue.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.AmbiguousCharacters=ue,A=ue,ue.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.d=new _.LRUCachedFunction(D=>{function B(re){const ce=new Map;for(let he=0;he<re.length;he+=2)ce.set(re[he],re[he+1]);return ce}function x(re,ce){const he=new Map(re);for(const[ye,Ae]of ce)he.set(ye,Ae);return he}function j(re,ce){if(!re)return ce;const he=new Map;for(const[ye,Ae]of re)ce.has(ye)&&he.set(ye,Ae);return he}const Z=A.c.value;let ie=D.filter(re=>!re.startsWith("_")&&re in Z);ie.length===0&&(ie=["_default"]);let oe;for(const re of ie){const ce=B(Z[re]);oe=j(oe,ce)}const be=B(Z._common),fe=x(be,oe);return new ue(fe)}),ue.e=new M.Lazy(()=>Object.keys(ue.c.value).filter(D=>!D.startsWith("_")));class me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(me.c())),this.d}static isInvisibleCharacter(B){return me.e().has(B)}static get codePoints(){return me.e()}}i.InvisibleCharacters=me,me.d=void 0}),Y(X[29],Q([0,1,4]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function M(L){return A(L,0)}i.hash=M;function A(L,w){switch(typeof L){case"object":return L===null?t(349,w):Array.isArray(L)?o(L,w):c(L,w);case"string":return v(L,w);case"boolean":return y(L,w);case"number":return t(L,w);case"undefined":return t(937,w);default:return t(617,w)}}i.doHash=A;function t(L,w){return(w<<5)-w+L|0}i.numberHash=t;function y(L,w){return t(L?433:863,w)}function v(L,w){w=t(149417,w);for(let N=0,d=L.length;N<d;N++)w=t(L.charCodeAt(N),w);return w}i.stringHash=v;function o(L,w){return w=t(104579,w),L.reduce((N,d)=>A(d,N),w)}function c(L,w){return w=t(181387,w),Object.keys(L).sort().reduce((N,d)=>(N=v(d,N),A(L[d],N)),w)}function p(L,w,N=32){const d=N-w,C=~((1<<d)-1);return(L<<w|(C&L)>>>d)>>>0}function e(L,w=0,N=L.byteLength,d=0){for(let C=0;C<N;C++)L[w+C]=d}function b(L,w,N="0"){for(;L.length<w;)L=N+L;return L}function f(L,w=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(N=>N.toString(16).padStart(2,"0")).join(""):b((L>>>0).toString(16),w/4)}i.toHexString=f;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const N=w.length;if(N===0)return;const d=this.p;let C=this.r,l=this.u,h,s;for(l!==0?(h=l,s=-1,l=0):(h=w.charCodeAt(0),s=0);;){let a=h;if(_.isHighSurrogate(h))if(s+1<N){const r=w.charCodeAt(s+1);_.isLowSurrogate(r)?(s++,a=_.computeCodePoint(h,r)):a=65533}else{l=h;break}else _.isLowSurrogate(h)&&(a=65533);if(C=this.w(d,C,a),s++,s<N)h=w.charCodeAt(s);else break}this.r=C,this.u=l}w(w,N,d){return d<128?w[N++]=d:d<2048?(w[N++]=192|(d&1984)>>>6,w[N++]=128|(d&63)>>>0):d<65536?(w[N++]=224|(d&61440)>>>12,w[N++]=128|(d&4032)>>>6,w[N++]=128|(d&63)>>>0):(w[N++]=240|(d&1835008)>>>18,w[N++]=128|(d&258048)>>>12,w[N++]=128|(d&4032)>>>6,w[N++]=128|(d&63)>>>0),N>=64&&(this.y(),N-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),N}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,e(this.p,this.r),this.r>56&&(this.y(),e(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,N=this.q;for(let m=0;m<64;m+=4)w.setUint32(m,N.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)w.setUint32(m,p(w.getUint32(m-12,!1)^w.getUint32(m-32,!1)^w.getUint32(m-56,!1)^w.getUint32(m-64,!1),1),!1);let d=this.h,C=this.l,l=this.m,h=this.n,s=this.o,a,r,u;for(let m=0;m<80;m++)m<20?(a=C&l|~C&h,r=1518500249):m<40?(a=C^l^h,r=1859775393):m<60?(a=C&l|C&h|l&h,r=2400959708):(a=C^l^h,r=3395469782),u=p(d,5)+a+s+r+w.getUint32(m*4,!1)&4294967295,s=h,h=l,l=p(C,30),C=d,d=u;this.h=this.h+d&4294967295,this.l=this.l+C&4294967295,this.m=this.m+l&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}i.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),Y(X[15],Q([0,1,25,29]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LcsDiff=i.stringDiff=i.StringDiffSequence=void 0;class A{constructor(e){this.a=e}getElements(){const e=this.a,b=new Int32Array(e.length);for(let f=0,g=e.length;f<g;f++)b[f]=e.charCodeAt(f);return b}}i.StringDiffSequence=A;function t(p,e,b){return new c(new A(p),new A(e)).ComputeDiff(b).changes}i.stringDiff=t;class y{static Assert(e,b){if(!e)throw new Error(b)}}class v{static Copy(e,b,f,g,L){for(let w=0;w<L;w++)f[g+w]=e[b+w]}static Copy2(e,b,f,g,L){for(let w=0;w<L;w++)f[g+w]=e[b+w]}}class o{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(e,b){this.b=Math.min(this.b,e),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(e,b){this.b=Math.min(this.b,e),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(e,b,f=null){this.a=f,this.b=e,this.c=b;const[g,L,w]=c.o(e),[N,d,C]=c.o(b);this.d=w&&C,this.e=g,this.f=L,this.g=N,this.h=d,this.k=[],this.m=[]}static n(e){return e.length>0&&typeof e[0]=="string"}static o(e){const b=e.getElements();if(c.n(b)){const f=new Int32Array(b.length);for(let g=0,L=b.length;g<L;g++)f[g]=(0,M.stringHash)(b[g],0);return[b,f,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(e,b){return this.f[e]!==this.h[b]?!1:this.d?this.e[e]===this.g[b]:!0}q(e,b){if(!this.p(e,b))return!1;const f=c.r(this.b,e),g=c.r(this.c,b);return f===g}static r(e,b){return typeof e.getStrictElement=="function"?e.getStrictElement(b):null}s(e,b){return this.f[e]!==this.f[b]?!1:this.d?this.e[e]===this.e[b]:!0}u(e,b){return this.h[e]!==this.h[b]?!1:this.d?this.g[e]===this.g[b]:!0}ComputeDiff(e){return this.v(0,this.f.length-1,0,this.h.length-1,e)}v(e,b,f,g,L){const w=[!1];let N=this.w(e,b,f,g,w);return L&&(N=this.z(N)),{quitEarly:w[0],changes:N}}w(e,b,f,g,L){for(L[0]=!1;e<=b&&f<=g&&this.p(e,f);)e++,f++;for(;b>=e&&g>=f&&this.p(b,g);)b--,g--;if(e>b||f>g){let h;return f<=g?(y.Assert(e===b+1,"originalStart should only be one more than originalEnd"),h=[new _.DiffChange(e,0,f,g-f+1)]):e<=b?(y.Assert(f===g+1,"modifiedStart should only be one more than modifiedEnd"),h=[new _.DiffChange(e,b-e+1,f,0)]):(y.Assert(e===b+1,"originalStart should only be one more than originalEnd"),y.Assert(f===g+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const w=[0],N=[0],d=this.y(e,b,f,g,w,N,L),C=w[0],l=N[0];if(d!==null)return d;if(!L[0]){const h=this.w(e,C,f,l,L);let s=[];return L[0]?s=[new _.DiffChange(C+1,b-(C+1)+1,l+1,g-(l+1)+1)]:s=this.w(C+1,b,l+1,g,L),this.H(h,s)}return[new _.DiffChange(e,b-e+1,f,g-f+1)]}x(e,b,f,g,L,w,N,d,C,l,h,s,a,r,u,m,S,R){let E=null,P=null,F=new o,V=b,O=f,q=a[0]-m[0]-g,k=-1073741824,I=this.k.length-1;do{const T=q+e;T===V||T<O&&C[T-1]<C[T+1]?(h=C[T+1],r=h-q-g,h<k&&F.MarkNextChange(),k=h,F.AddModifiedElement(h+1,r),q=T+1-e):(h=C[T-1]+1,r=h-q-g,h<k&&F.MarkNextChange(),k=h-1,F.AddOriginalElement(h,r+1),q=T-1-e),I>=0&&(C=this.k[I],e=C[0],V=1,O=C.length-1)}while(--I>=-1);if(E=F.getReverseChanges(),R[0]){let T=a[0]+1,W=m[0]+1;if(E!==null&&E.length>0){const z=E[E.length-1];T=Math.max(T,z.getOriginalEnd()),W=Math.max(W,z.getModifiedEnd())}P=[new _.DiffChange(T,s-T+1,W,u-W+1)]}else{F=new o,V=w,O=N,q=a[0]-m[0]-d,k=1073741824,I=S?this.m.length-1:this.m.length-2;do{const T=q+L;T===V||T<O&&l[T-1]>=l[T+1]?(h=l[T+1]-1,r=h-q-d,h>k&&F.MarkNextChange(),k=h+1,F.AddOriginalElement(h+1,r+1),q=T+1-L):(h=l[T-1],r=h-q-d,h>k&&F.MarkNextChange(),k=h,F.AddModifiedElement(h+1,r+1),q=T-1-L),I>=0&&(l=this.m[I],L=l[0],V=1,O=l.length-1)}while(--I>=-1);P=F.getChanges()}return this.H(E,P)}y(e,b,f,g,L,w,N){let d=0,C=0,l=0,h=0,s=0,a=0;e--,f--,L[0]=0,w[0]=0,this.k=[],this.m=[];const r=b-e+(g-f),u=r+1,m=new Int32Array(u),S=new Int32Array(u),R=g-f,E=b-e,P=e-f,F=b-g,O=(E-R)%2===0;m[R]=e,S[E]=b,N[0]=!1;for(let q=1;q<=r/2+1;q++){let k=0,I=0;l=this.J(R-q,q,R,u),h=this.J(R+q,q,R,u);for(let W=l;W<=h;W+=2){W===l||W<h&&m[W-1]<m[W+1]?d=m[W+1]:d=m[W-1]+1,C=d-(W-R)-P;const z=d;for(;d<b&&C<g&&this.p(d+1,C+1);)d++,C++;if(m[W]=d,d+C>k+I&&(k=d,I=C),!O&&Math.abs(W-E)<=q-1&&d>=S[W])return L[0]=d,w[0]=C,z<=S[W]&&1447>0&&q<=1447+1?this.x(R,l,h,P,E,s,a,F,m,S,d,b,L,C,g,w,O,N):null}const T=(k-e+(I-f)-q)/2;if(this.a!==null&&!this.a(k,T))return N[0]=!0,L[0]=k,w[0]=I,T>0&&1447>0&&q<=1447+1?this.x(R,l,h,P,E,s,a,F,m,S,d,b,L,C,g,w,O,N):(e++,f++,[new _.DiffChange(e,b-e+1,f,g-f+1)]);s=this.J(E-q,q,E,u),a=this.J(E+q,q,E,u);for(let W=s;W<=a;W+=2){W===s||W<a&&S[W-1]>=S[W+1]?d=S[W+1]-1:d=S[W-1],C=d-(W-E)-F;const z=d;for(;d>e&&C>f&&this.p(d,C);)d--,C--;if(S[W]=d,O&&Math.abs(W-R)<=q&&d<=m[W])return L[0]=d,w[0]=C,z>=m[W]&&1447>0&&q<=1447+1?this.x(R,l,h,P,E,s,a,F,m,S,d,b,L,C,g,w,O,N):null}if(q<=1447){let W=new Int32Array(h-l+2);W[0]=R-l+1,v.Copy2(m,l,W,1,h-l+1),this.k.push(W),W=new Int32Array(a-s+2),W[0]=E-s+1,v.Copy2(S,s,W,1,a-s+1),this.m.push(W)}}return this.x(R,l,h,P,E,s,a,F,m,S,d,b,L,C,g,w,O,N)}z(e){for(let b=0;b<e.length;b++){const f=e[b],g=b<e.length-1?e[b+1].originalStart:this.f.length,L=b<e.length-1?e[b+1].modifiedStart:this.h.length,w=f.originalLength>0,N=f.modifiedLength>0;for(;f.originalStart+f.originalLength<g&&f.modifiedStart+f.modifiedLength<L&&(!w||this.s(f.originalStart,f.originalStart+f.originalLength))&&(!N||this.u(f.modifiedStart,f.modifiedStart+f.modifiedLength));){const C=this.q(f.originalStart,f.modifiedStart);if(this.q(f.originalStart+f.originalLength,f.modifiedStart+f.modifiedLength)&&!C)break;f.originalStart++,f.modifiedStart++}const d=[null];if(b<e.length-1&&this.I(e[b],e[b+1],d)){e[b]=d[0],e.splice(b+1,1),b--;continue}}for(let b=e.length-1;b>=0;b--){const f=e[b];let g=0,L=0;if(b>0){const h=e[b-1];g=h.originalStart+h.originalLength,L=h.modifiedStart+h.modifiedLength}const w=f.originalLength>0,N=f.modifiedLength>0;let d=0,C=this.G(f.originalStart,f.originalLength,f.modifiedStart,f.modifiedLength);for(let h=1;;h++){const s=f.originalStart-h,a=f.modifiedStart-h;if(s<g||a<L||w&&!this.s(s,s+f.originalLength)||N&&!this.u(a,a+f.modifiedLength))break;const u=(s===g&&a===L?5:0)+this.G(s,f.originalLength,a,f.modifiedLength);u>C&&(C=u,d=h)}f.originalStart-=d,f.modifiedStart-=d;const l=[null];if(b>0&&this.I(e[b-1],e[b],l)){e[b-1]=l[0],e.splice(b,1),b++;continue}}if(this.d)for(let b=1,f=e.length;b<f;b++){const g=e[b-1],L=e[b],w=L.originalStart-g.originalStart-g.originalLength,N=g.originalStart,d=L.originalStart+L.originalLength,C=d-N,l=g.modifiedStart,h=L.modifiedStart+L.modifiedLength,s=h-l;if(w<5&&C<20&&s<20){const a=this.A(N,C,l,s,w);if(a){const[r,u]=a;(r!==g.originalStart+g.originalLength||u!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=r-g.originalStart,g.modifiedLength=u-g.modifiedStart,L.originalStart=r+w,L.modifiedStart=u+w,L.originalLength=d-L.originalStart,L.modifiedLength=h-L.modifiedStart)}}}return e}A(e,b,f,g,L){if(b<L||g<L)return null;const w=e+b-L+1,N=f+g-L+1;let d=0,C=0,l=0;for(let h=e;h<w;h++)for(let s=f;s<N;s++){const a=this.B(h,s,L);a>0&&a>d&&(d=a,C=h,l=s)}return d>0?[C,l]:null}B(e,b,f){let g=0;for(let L=0;L<f;L++){if(!this.p(e+L,b+L))return 0;g+=this.e[e+L].length}return g}C(e){return e<=0||e>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[e])}D(e,b){if(this.C(e)||this.C(e-1))return!0;if(b>0){const f=e+b;if(this.C(f-1)||this.C(f))return!0}return!1}E(e){return e<=0||e>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[e])}F(e,b){if(this.E(e)||this.E(e-1))return!0;if(b>0){const f=e+b;if(this.E(f-1)||this.E(f))return!0}return!1}G(e,b,f,g){const L=this.D(e,b)?1:0,w=this.F(f,g)?1:0;return L+w}H(e,b){const f=[];if(e.length===0||b.length===0)return b.length>0?b:e;if(this.I(e[e.length-1],b[0],f)){const g=new Array(e.length+b.length-1);return v.Copy(e,0,g,0,e.length-1),g[e.length-1]=f[0],v.Copy(b,1,g,e.length,b.length-1),g}else{const g=new Array(e.length+b.length);return v.Copy(e,0,g,0,e.length),v.Copy(b,0,g,e.length,b.length),g}}I(e,b,f){if(y.Assert(e.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),y.Assert(e.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=b.originalStart||e.modifiedStart+e.modifiedLength>=b.modifiedStart){const g=e.originalStart;let L=e.originalLength;const w=e.modifiedStart;let N=e.modifiedLength;return e.originalStart+e.originalLength>=b.originalStart&&(L=b.originalStart+b.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=b.modifiedStart&&(N=b.modifiedStart+b.modifiedLength-e.modifiedStart),f[0]=new _.DiffChange(g,L,w,N),!0}else return f[0]=null,!1}J(e,b,f,g){if(e>=0&&e<g)return e;const L=f,w=g-f-1,N=b%2===0;if(e<0){const d=L%2===0;return N===d?0:1}else{const d=w%2===0;return N===d?g-1:g-2}}}i.LcsDiff=c}),Y(X[16],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.withNullAsUndefined=i.validateConstraint=i.validateConstraints=i.isFunction=i.assertIsDefined=i.assertType=i.isUndefinedOrNull=i.isDefined=i.isUndefined=i.isBoolean=i.isIterable=i.isNumber=i.isTypedArray=i.isObject=i.isString=void 0;function _(N){return typeof N=="string"}i.isString=_;function M(N){return typeof N=="object"&&N!==null&&!Array.isArray(N)&&!(N instanceof RegExp)&&!(N instanceof Date)}i.isObject=M;function A(N){const d=Object.getPrototypeOf(Uint8Array);return typeof N=="object"&&N instanceof d}i.isTypedArray=A;function t(N){return typeof N=="number"&&!isNaN(N)}i.isNumber=t;function y(N){return!!N&&typeof N[Symbol.iterator]=="function"}i.isIterable=y;function v(N){return N===!0||N===!1}i.isBoolean=v;function o(N){return typeof N>"u"}i.isUndefined=o;function c(N){return!p(N)}i.isDefined=c;function p(N){return o(N)||N===null}i.isUndefinedOrNull=p;function e(N,d){if(!N)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}i.assertType=e;function b(N){if(p(N))throw new Error("Assertion Failed: argument is undefined or null");return N}i.assertIsDefined=b;function f(N){return typeof N=="function"}i.isFunction=f;function g(N,d){const C=Math.min(N.length,d.length);for(let l=0;l<C;l++)L(N[l],d[l])}i.validateConstraints=g;function L(N,d){if(_(d)){if(typeof N!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(f(d)){try{if(N instanceof d)return}catch{}if(!p(N)&&N.constructor===d||d.length===1&&d.call(void 0,N)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}i.validateConstraint=L;function w(N){return N===null?void 0:N}i.withNullAsUndefined=w}),Y(X[30],Q([0,1,16]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Codicon=i.getCodiconFontCharacters=i.getCodiconAriaLabel=void 0;function M(v){return v?v.replace(/\$\((.*?)\)/g,(o,c)=>` ${c} `).trim():""}i.getCodiconAriaLabel=M;const A=Object.create(null);function t(v,o){if((0,_.isString)(o)){const c=A[o];if(c===void 0)throw new Error(`${v} references an unknown codicon: ${o}`);o=c}return A[v]=o,{id:v}}function y(){return A}i.getCodiconFontCharacters=y,i.Codicon={add:t("add",6e4),plus:t("plus",6e4),gistNew:t("gist-new",6e4),repoCreate:t("repo-create",6e4),lightbulb:t("lightbulb",60001),lightBulb:t("light-bulb",60001),repo:t("repo",60002),repoDelete:t("repo-delete",60002),gistFork:t("gist-fork",60003),repoForked:t("repo-forked",60003),gitPullRequest:t("git-pull-request",60004),gitPullRequestAbandoned:t("git-pull-request-abandoned",60004),recordKeys:t("record-keys",60005),keyboard:t("keyboard",60005),tag:t("tag",60006),tagAdd:t("tag-add",60006),tagRemove:t("tag-remove",60006),person:t("person",60007),personFollow:t("person-follow",60007),personOutline:t("person-outline",60007),personFilled:t("person-filled",60007),gitBranch:t("git-branch",60008),gitBranchCreate:t("git-branch-create",60008),gitBranchDelete:t("git-branch-delete",60008),sourceControl:t("source-control",60008),mirror:t("mirror",60009),mirrorPublic:t("mirror-public",60009),star:t("star",60010),starAdd:t("star-add",60010),starDelete:t("star-delete",60010),starEmpty:t("star-empty",60010),comment:t("comment",60011),commentAdd:t("comment-add",60011),alert:t("alert",60012),warning:t("warning",60012),search:t("search",60013),searchSave:t("search-save",60013),logOut:t("log-out",60014),signOut:t("sign-out",60014),logIn:t("log-in",60015),signIn:t("sign-in",60015),eye:t("eye",60016),eyeUnwatch:t("eye-unwatch",60016),eyeWatch:t("eye-watch",60016),circleFilled:t("circle-filled",60017),primitiveDot:t("primitive-dot",60017),closeDirty:t("close-dirty",60017),debugBreakpoint:t("debug-breakpoint",60017),debugBreakpointDisabled:t("debug-breakpoint-disabled",60017),debugHint:t("debug-hint",60017),primitiveSquare:t("primitive-square",60018),edit:t("edit",60019),pencil:t("pencil",60019),info:t("info",60020),issueOpened:t("issue-opened",60020),gistPrivate:t("gist-private",60021),gitForkPrivate:t("git-fork-private",60021),lock:t("lock",60021),mirrorPrivate:t("mirror-private",60021),close:t("close",60022),removeClose:t("remove-close",60022),x:t("x",60022),repoSync:t("repo-sync",60023),sync:t("sync",60023),clone:t("clone",60024),desktopDownload:t("desktop-download",60024),beaker:t("beaker",60025),microscope:t("microscope",60025),vm:t("vm",60026),deviceDesktop:t("device-desktop",60026),file:t("file",60027),fileText:t("file-text",60027),more:t("more",60028),ellipsis:t("ellipsis",60028),kebabHorizontal:t("kebab-horizontal",60028),mailReply:t("mail-reply",60029),reply:t("reply",60029),organization:t("organization",60030),organizationFilled:t("organization-filled",60030),organizationOutline:t("organization-outline",60030),newFile:t("new-file",60031),fileAdd:t("file-add",60031),newFolder:t("new-folder",60032),fileDirectoryCreate:t("file-directory-create",60032),trash:t("trash",60033),trashcan:t("trashcan",60033),history:t("history",60034),clock:t("clock",60034),folder:t("folder",60035),fileDirectory:t("file-directory",60035),symbolFolder:t("symbol-folder",60035),logoGithub:t("logo-github",60036),markGithub:t("mark-github",60036),github:t("github",60036),terminal:t("terminal",60037),console:t("console",60037),repl:t("repl",60037),zap:t("zap",60038),symbolEvent:t("symbol-event",60038),error:t("error",60039),stop:t("stop",60039),variable:t("variable",60040),symbolVariable:t("symbol-variable",60040),array:t("array",60042),symbolArray:t("symbol-array",60042),symbolModule:t("symbol-module",60043),symbolPackage:t("symbol-package",60043),symbolNamespace:t("symbol-namespace",60043),symbolObject:t("symbol-object",60043),symbolMethod:t("symbol-method",60044),symbolFunction:t("symbol-function",60044),symbolConstructor:t("symbol-constructor",60044),symbolBoolean:t("symbol-boolean",60047),symbolNull:t("symbol-null",60047),symbolNumeric:t("symbol-numeric",60048),symbolNumber:t("symbol-number",60048),symbolStructure:t("symbol-structure",60049),symbolStruct:t("symbol-struct",60049),symbolParameter:t("symbol-parameter",60050),symbolTypeParameter:t("symbol-type-parameter",60050),symbolKey:t("symbol-key",60051),symbolText:t("symbol-text",60051),symbolReference:t("symbol-reference",60052),goToFile:t("go-to-file",60052),symbolEnum:t("symbol-enum",60053),symbolValue:t("symbol-value",60053),symbolRuler:t("symbol-ruler",60054),symbolUnit:t("symbol-unit",60054),activateBreakpoints:t("activate-breakpoints",60055),archive:t("archive",60056),arrowBoth:t("arrow-both",60057),arrowDown:t("arrow-down",60058),arrowLeft:t("arrow-left",60059),arrowRight:t("arrow-right",60060),arrowSmallDown:t("arrow-small-down",60061),arrowSmallLeft:t("arrow-small-left",60062),arrowSmallRight:t("arrow-small-right",60063),arrowSmallUp:t("arrow-small-up",60064),arrowUp:t("arrow-up",60065),bell:t("bell",60066),bold:t("bold",60067),book:t("book",60068),bookmark:t("bookmark",60069),debugBreakpointConditionalUnverified:t("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:t("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:t("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:t("debug-breakpoint-data-unverified",60072),debugBreakpointData:t("debug-breakpoint-data",60073),debugBreakpointDataDisabled:t("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:t("debug-breakpoint-log-unverified",60074),debugBreakpointLog:t("debug-breakpoint-log",60075),debugBreakpointLogDisabled:t("debug-breakpoint-log-disabled",60075),briefcase:t("briefcase",60076),broadcast:t("broadcast",60077),browser:t("browser",60078),bug:t("bug",60079),calendar:t("calendar",60080),caseSensitive:t("case-sensitive",60081),check:t("check",60082),checklist:t("checklist",60083),chevronDown:t("chevron-down",60084),dropDownButton:t("drop-down-button",60084),chevronLeft:t("chevron-left",60085),chevronRight:t("chevron-right",60086),chevronUp:t("chevron-up",60087),chromeClose:t("chrome-close",60088),chromeMaximize:t("chrome-maximize",60089),chromeMinimize:t("chrome-minimize",60090),chromeRestore:t("chrome-restore",60091),circle:t("circle",60092),circleOutline:t("circle-outline",60092),debugBreakpointUnverified:t("debug-breakpoint-unverified",60092),circleSlash:t("circle-slash",60093),circuitBoard:t("circuit-board",60094),clearAll:t("clear-all",60095),clippy:t("clippy",60096),closeAll:t("close-all",60097),cloudDownload:t("cloud-download",60098),cloudUpload:t("cloud-upload",60099),code:t("code",60100),collapseAll:t("collapse-all",60101),colorMode:t("color-mode",60102),commentDiscussion:t("comment-discussion",60103),compareChanges:t("compare-changes",60157),creditCard:t("credit-card",60105),dash:t("dash",60108),dashboard:t("dashboard",60109),database:t("database",60110),debugContinue:t("debug-continue",60111),debugDisconnect:t("debug-disconnect",60112),debugPause:t("debug-pause",60113),debugRestart:t("debug-restart",60114),debugStart:t("debug-start",60115),debugStepInto:t("debug-step-into",60116),debugStepOut:t("debug-step-out",60117),debugStepOver:t("debug-step-over",60118),debugStop:t("debug-stop",60119),debug:t("debug",60120),deviceCameraVideo:t("device-camera-video",60121),deviceCamera:t("device-camera",60122),deviceMobile:t("device-mobile",60123),diffAdded:t("diff-added",60124),diffIgnored:t("diff-ignored",60125),diffModified:t("diff-modified",60126),diffRemoved:t("diff-removed",60127),diffRenamed:t("diff-renamed",60128),diff:t("diff",60129),discard:t("discard",60130),editorLayout:t("editor-layout",60131),emptyWindow:t("empty-window",60132),exclude:t("exclude",60133),extensions:t("extensions",60134),eyeClosed:t("eye-closed",60135),fileBinary:t("file-binary",60136),fileCode:t("file-code",60137),fileMedia:t("file-media",60138),filePdf:t("file-pdf",60139),fileSubmodule:t("file-submodule",60140),fileSymlinkDirectory:t("file-symlink-directory",60141),fileSymlinkFile:t("file-symlink-file",60142),fileZip:t("file-zip",60143),files:t("files",60144),filter:t("filter",60145),flame:t("flame",60146),foldDown:t("fold-down",60147),foldUp:t("fold-up",60148),fold:t("fold",60149),folderActive:t("folder-active",60150),folderOpened:t("folder-opened",60151),gear:t("gear",60152),gift:t("gift",60153),gistSecret:t("gist-secret",60154),gist:t("gist",60155),gitCommit:t("git-commit",60156),gitCompare:t("git-compare",60157),gitMerge:t("git-merge",60158),githubAction:t("github-action",60159),githubAlt:t("github-alt",60160),globe:t("globe",60161),grabber:t("grabber",60162),graph:t("graph",60163),gripper:t("gripper",60164),heart:t("heart",60165),home:t("home",60166),horizontalRule:t("horizontal-rule",60167),hubot:t("hubot",60168),inbox:t("inbox",60169),issueClosed:t("issue-closed",60324),issueReopened:t("issue-reopened",60171),issues:t("issues",60172),italic:t("italic",60173),jersey:t("jersey",60174),json:t("json",60175),kebabVertical:t("kebab-vertical",60176),key:t("key",60177),law:t("law",60178),lightbulbAutofix:t("lightbulb-autofix",60179),linkExternal:t("link-external",60180),link:t("link",60181),listOrdered:t("list-ordered",60182),listUnordered:t("list-unordered",60183),liveShare:t("live-share",60184),loading:t("loading",60185),location:t("location",60186),mailRead:t("mail-read",60187),mail:t("mail",60188),markdown:t("markdown",60189),megaphone:t("megaphone",60190),mention:t("mention",60191),milestone:t("milestone",60192),mortarBoard:t("mortar-board",60193),move:t("move",60194),multipleWindows:t("multiple-windows",60195),mute:t("mute",60196),noNewline:t("no-newline",60197),note:t("note",60198),octoface:t("octoface",60199),openPreview:t("open-preview",60200),package_:t("package",60201),paintcan:t("paintcan",60202),pin:t("pin",60203),play:t("play",60204),run:t("run",60204),plug:t("plug",60205),preserveCase:t("preserve-case",60206),preview:t("preview",60207),project:t("project",60208),pulse:t("pulse",60209),question:t("question",60210),quote:t("quote",60211),radioTower:t("radio-tower",60212),reactions:t("reactions",60213),references:t("references",60214),refresh:t("refresh",60215),regex:t("regex",60216),remoteExplorer:t("remote-explorer",60217),remote:t("remote",60218),remove:t("remove",60219),replaceAll:t("replace-all",60220),replace:t("replace",60221),repoClone:t("repo-clone",60222),repoForcePush:t("repo-force-push",60223),repoPull:t("repo-pull",60224),repoPush:t("repo-push",60225),report:t("report",60226),requestChanges:t("request-changes",60227),rocket:t("rocket",60228),rootFolderOpened:t("root-folder-opened",60229),rootFolder:t("root-folder",60230),rss:t("rss",60231),ruby:t("ruby",60232),saveAll:t("save-all",60233),saveAs:t("save-as",60234),save:t("save",60235),screenFull:t("screen-full",60236),screenNormal:t("screen-normal",60237),searchStop:t("search-stop",60238),server:t("server",60240),settingsGear:t("settings-gear",60241),settings:t("settings",60242),shield:t("shield",60243),smiley:t("smiley",60244),sortPrecedence:t("sort-precedence",60245),splitHorizontal:t("split-horizontal",60246),splitVertical:t("split-vertical",60247),squirrel:t("squirrel",60248),starFull:t("star-full",60249),starHalf:t("star-half",60250),symbolClass:t("symbol-class",60251),symbolColor:t("symbol-color",60252),symbolCustomColor:t("symbol-customcolor",60252),symbolConstant:t("symbol-constant",60253),symbolEnumMember:t("symbol-enum-member",60254),symbolField:t("symbol-field",60255),symbolFile:t("symbol-file",60256),symbolInterface:t("symbol-interface",60257),symbolKeyword:t("symbol-keyword",60258),symbolMisc:t("symbol-misc",60259),symbolOperator:t("symbol-operator",60260),symbolProperty:t("symbol-property",60261),wrench:t("wrench",60261),wrenchSubaction:t("wrench-subaction",60261),symbolSnippet:t("symbol-snippet",60262),tasklist:t("tasklist",60263),telescope:t("telescope",60264),textSize:t("text-size",60265),threeBars:t("three-bars",60266),thumbsdown:t("thumbsdown",60267),thumbsup:t("thumbsup",60268),tools:t("tools",60269),triangleDown:t("triangle-down",60270),triangleLeft:t("triangle-left",60271),triangleRight:t("triangle-right",60272),triangleUp:t("triangle-up",60273),twitter:t("twitter",60274),unfold:t("unfold",60275),unlock:t("unlock",60276),unmute:t("unmute",60277),unverified:t("unverified",60278),verified:t("verified",60279),versions:t("versions",60280),vmActive:t("vm-active",60281),vmOutline:t("vm-outline",60282),vmRunning:t("vm-running",60283),watch:t("watch",60284),whitespace:t("whitespace",60285),wholeWord:t("whole-word",60286),window:t("window",60287),wordWrap:t("word-wrap",60288),zoomIn:t("zoom-in",60289),zoomOut:t("zoom-out",60290),listFilter:t("list-filter",60291),listFlat:t("list-flat",60292),listSelection:t("list-selection",60293),selection:t("selection",60293),listTree:t("list-tree",60294),debugBreakpointFunctionUnverified:t("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:t("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:t("debug-breakpoint-function-disabled",60296),debugStackframeActive:t("debug-stackframe-active",60297),circleSmallFilled:t("circle-small-filled",60298),debugStackframeDot:t("debug-stackframe-dot",60298),debugStackframe:t("debug-stackframe",60299),debugStackframeFocused:t("debug-stackframe-focused",60299),debugBreakpointUnsupported:t("debug-breakpoint-unsupported",60300),symbolString:t("symbol-string",60301),debugReverseContinue:t("debug-reverse-continue",60302),debugStepBack:t("debug-step-back",60303),debugRestartFrame:t("debug-restart-frame",60304),callIncoming:t("call-incoming",60306),callOutgoing:t("call-outgoing",60307),menu:t("menu",60308),expandAll:t("expand-all",60309),feedback:t("feedback",60310),groupByRefType:t("group-by-ref-type",60311),ungroupByRefType:t("ungroup-by-ref-type",60312),account:t("account",60313),bellDot:t("bell-dot",60314),debugConsole:t("debug-console",60315),library:t("library",60316),output:t("output",60317),runAll:t("run-all",60318),syncIgnored:t("sync-ignored",60319),pinned:t("pinned",60320),githubInverted:t("github-inverted",60321),debugAlt:t("debug-alt",60305),serverProcess:t("server-process",60322),serverEnvironment:t("server-environment",60323),pass:t("pass",60324),stopCircle:t("stop-circle",60325),playCircle:t("play-circle",60326),record:t("record",60327),debugAltSmall:t("debug-alt-small",60328),vmConnect:t("vm-connect",60329),cloud:t("cloud",60330),merge:t("merge",60331),exportIcon:t("export",60332),graphLeft:t("graph-left",60333),magnet:t("magnet",60334),notebook:t("notebook",60335),redo:t("redo",60336),checkAll:t("check-all",60337),pinnedDirty:t("pinned-dirty",60338),passFilled:t("pass-filled",60339),circleLargeFilled:t("circle-large-filled",60340),circleLarge:t("circle-large",60341),circleLargeOutline:t("circle-large-outline",60341),combine:t("combine",60342),gather:t("gather",60342),table:t("table",60343),variableGroup:t("variable-group",60344),typeHierarchy:t("type-hierarchy",60345),typeHierarchySub:t("type-hierarchy-sub",60346),typeHierarchySuper:t("type-hierarchy-super",60347),gitPullRequestCreate:t("git-pull-request-create",60348),runAbove:t("run-above",60349),runBelow:t("run-below",60350),notebookTemplate:t("notebook-template",60351),debugRerun:t("debug-rerun",60352),workspaceTrusted:t("workspace-trusted",60353),workspaceUntrusted:t("workspace-untrusted",60354),workspaceUnspecified:t("workspace-unspecified",60355),terminalCmd:t("terminal-cmd",60356),terminalDebian:t("terminal-debian",60357),terminalLinux:t("terminal-linux",60358),terminalPowershell:t("terminal-powershell",60359),terminalTmux:t("terminal-tmux",60360),terminalUbuntu:t("terminal-ubuntu",60361),terminalBash:t("terminal-bash",60362),arrowSwap:t("arrow-swap",60363),copy:t("copy",60364),personAdd:t("person-add",60365),filterFilled:t("filter-filled",60366),wand:t("wand",60367),debugLineByLine:t("debug-line-by-line",60368),inspect:t("inspect",60369),layers:t("layers",60370),layersDot:t("layers-dot",60371),layersActive:t("layers-active",60372),compass:t("compass",60373),compassDot:t("compass-dot",60374),compassActive:t("compass-active",60375),azure:t("azure",60376),issueDraft:t("issue-draft",60377),gitPullRequestClosed:t("git-pull-request-closed",60378),gitPullRequestDraft:t("git-pull-request-draft",60379),debugAll:t("debug-all",60380),debugCoverage:t("debug-coverage",60381),runErrors:t("run-errors",60382),folderLibrary:t("folder-library",60383),debugContinueSmall:t("debug-continue-small",60384),beakerStop:t("beaker-stop",60385),graphLine:t("graph-line",60386),graphScatter:t("graph-scatter",60387),pieChart:t("pie-chart",60388),bracket:t("bracket",60388),bracketDot:t("bracket-dot",60389),bracketError:t("bracket-error",60390),lockSmall:t("lock-small",60391),azureDevops:t("azure-devops",60392),verifiedFilled:t("verified-filled",60393),newLine:t("newline",60394),layout:t("layout",60395),layoutActivitybarLeft:t("layout-activitybar-left",60396),layoutActivitybarRight:t("layout-activitybar-right",60397),layoutPanelLeft:t("layout-panel-left",60398),layoutPanelCenter:t("layout-panel-center",60399),layoutPanelJustify:t("layout-panel-justify",60400),layoutPanelRight:t("layout-panel-right",60401),layoutPanel:t("layout-panel",60402),layoutSidebarLeft:t("layout-sidebar-left",60403),layoutSidebarRight:t("layout-sidebar-right",60404),layoutStatusbar:t("layout-statusbar",60405),layoutMenubar:t("layout-menubar",60406),layoutCentered:t("layout-centered",60407),layoutSidebarRightOff:t("layout-sidebar-right-off",60416),layoutPanelOff:t("layout-panel-off",60417),layoutSidebarLeftOff:t("layout-sidebar-left-off",60418),target:t("target",60408),indent:t("indent",60409),recordSmall:t("record-small",60410),errorSmall:t("error-small",60411),arrowCircleDown:t("arrow-circle-down",60412),arrowCircleLeft:t("arrow-circle-left",60413),arrowCircleRight:t("arrow-circle-right",60414),arrowCircleUp:t("arrow-circle-up",60415),heartFilled:t("heart-filled",60420),map:t("map",60421),mapFilled:t("map-filled",60422),circleSmall:t("circle-small",60423),bellSlash:t("bell-slash",60424),bellSlashDot:t("bell-slash-dot",60425),commentUnresolved:t("comment-unresolved",60426),gitPullRequestGoToChanges:t("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:t("git-pull-request-new-changes",60428),searchFuzzy:t("search-fuzzy",60429),commentDraft:t("comment-draft",60430),dialogError:t("dialog-error","error"),dialogWarning:t("dialog-warning","warning"),dialogInfo:t("dialog-info","info"),dialogClose:t("dialog-close","close"),treeItemExpanded:t("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:t("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:t("tree-filter-on-type-off","list-selection"),treeFilterClear:t("tree-filter-clear","close"),treeItemLoading:t("tree-item-loading","loading"),menuSelection:t("menu-selection","check"),menuSubmenu:t("menu-submenu","chevron-right"),menuBarMore:t("menubar-more","more"),scrollbarButtonLeft:t("scrollbar-button-left","triangle-left"),scrollbarButtonRight:t("scrollbar-button-right","triangle-right"),scrollbarButtonUp:t("scrollbar-button-up","triangle-up"),scrollbarButtonDown:t("scrollbar-button-down","triangle-down"),toolBarMore:t("toolbar-more","more"),quickInputBack:t("quick-input-back","arrow-left")}}),Y(X[11],Q([0,1,16]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const g=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([L,w])=>{g[L]=w&&typeof w=="object"?M(w):w}),g}i.deepClone=M;function A(f){if(!f||typeof f!="object")return f;const g=[f];for(;g.length>0;){const L=g.shift();Object.freeze(L);for(const w in L)if(t.call(L,w)){const N=L[w];typeof N=="object"&&!Object.isFrozen(N)&&!(0,_.isTypedArray)(N)&&g.push(N)}}return f}i.deepFreeze=A;const t=Object.prototype.hasOwnProperty;function y(f,g){return v(f,g,new Set)}i.cloneAndChange=y;function v(f,g,L){if((0,_.isUndefinedOrNull)(f))return f;const w=g(f);if(typeof w<"u")return w;if(Array.isArray(f)){const N=[];for(const d of f)N.push(v(d,g,L));return N}if((0,_.isObject)(f)){if(L.has(f))throw new Error("Cannot clone recursive data-structure");L.add(f);const N={};for(const d in f)t.call(f,d)&&(N[d]=v(f[d],g,L));return L.delete(f),N}return f}function o(f,g,L=!0){return(0,_.isObject)(f)?((0,_.isObject)(g)&&Object.keys(g).forEach(w=>{w in f?L&&((0,_.isObject)(f[w])&&(0,_.isObject)(g[w])?o(f[w],g[w],L):f[w]=g[w]):f[w]=g[w]}),f):g}i.mixin=o;function c(f,g){if(f===g)return!0;if(f==null||g===null||g===void 0||typeof f!=typeof g||typeof f!="object"||Array.isArray(f)!==Array.isArray(g))return!1;let L,w;if(Array.isArray(f)){if(f.length!==g.length)return!1;for(L=0;L<f.length;L++)if(!c(f[L],g[L]))return!1}else{const N=[];for(w in f)N.push(w);N.sort();const d=[];for(w in g)d.push(w);if(d.sort(),!c(N,d))return!1;for(L=0;L<N.length;L++)if(!c(f[N[L]],g[N[L]]))return!1}return!0}i.equals=c;function p(f){let g=[],L=Object.getPrototypeOf(f);for(;Object.prototype!==L;)g=g.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return g}i.getAllPropertyNames=p;function e(f){const g=[];for(const L of p(f))typeof f[L]=="function"&&g.push(L);return g}i.getAllMethodNames=e;function b(f,g){const L=N=>function(){const d=Array.prototype.slice.call(arguments,0);return g(N,d)},w={};for(const N of f)w[N]=L(N);return w}i.createProxyObject=b}),Y(X[17],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toUint32=i.toUint8=void 0;function _(A){return A<0?0:A>255?255:A|0}i.toUint8=_;function M(A){return A<0?0:A>4294967295?4294967295:A|0}i.toUint32=M}),Y(X[18],Q([0,1,17]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharacterSet=i.CharacterClassifier=void 0;class M{constructor(y){const v=(0,_.toUint8)(y);this.c=v,this.a=M.d(v),this.b=new Map}static d(y){const v=new Uint8Array(256);return v.fill(y),v}set(y,v){const o=(0,_.toUint8)(v);y>=0&&y<256?this.a[y]=o:this.b.set(y,o)}get(y){return y>=0&&y<256?this.a[y]:this.b.get(y)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.CharacterClassifier=M;class A{constructor(){this.a=new M(0)}add(y){this.a.set(y,1)}has(y){return this.a.get(y)===1}clear(){return this.a.clear()}}i.CharacterSet=A}),Y(X[3],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Position=void 0;class _{constructor(A,t){this.lineNumber=A,this.column=t}with(A=this.lineNumber,t=this.column){return A===this.lineNumber&&t===this.column?this:new _(A,t)}delta(A=0,t=0){return this.with(this.lineNumber+A,this.column+t)}equals(A){return _.equals(this,A)}static equals(A,t){return!A&&!t?!0:!!A&&!!t&&A.lineNumber===t.lineNumber&&A.column===t.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,t){return A.lineNumber<t.lineNumber?!0:t.lineNumber<A.lineNumber?!1:A.column<t.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,t){return A.lineNumber<t.lineNumber?!0:t.lineNumber<A.lineNumber?!1:A.column<=t.column}static compare(A,t){const y=A.lineNumber|0,v=t.lineNumber|0;if(y===v){const o=A.column|0,c=t.column|0;return o-c}return y-v}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}i.Position=_}),Y(X[2],Q([0,1,3]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Range=void 0;class M{constructor(t,y,v,o){t>v||t===v&&y>o?(this.startLineNumber=v,this.startColumn=o,this.endLineNumber=t,this.endColumn=y):(this.startLineNumber=t,this.startColumn=y,this.endLineNumber=v,this.endColumn=o)}isEmpty(){return M.isEmpty(this)}static isEmpty(t){return t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn}containsPosition(t){return M.containsPosition(this,t)}static containsPosition(t,y){return!(y.lineNumber<t.startLineNumber||y.lineNumber>t.endLineNumber||y.lineNumber===t.startLineNumber&&y.column<t.startColumn||y.lineNumber===t.endLineNumber&&y.column>t.endColumn)}static strictContainsPosition(t,y){return!(y.lineNumber<t.startLineNumber||y.lineNumber>t.endLineNumber||y.lineNumber===t.startLineNumber&&y.column<=t.startColumn||y.lineNumber===t.endLineNumber&&y.column>=t.endColumn)}containsRange(t){return M.containsRange(this,t)}static containsRange(t,y){return!(y.startLineNumber<t.startLineNumber||y.endLineNumber<t.startLineNumber||y.startLineNumber>t.endLineNumber||y.endLineNumber>t.endLineNumber||y.startLineNumber===t.startLineNumber&&y.startColumn<t.startColumn||y.endLineNumber===t.endLineNumber&&y.endColumn>t.endColumn)}strictContainsRange(t){return M.strictContainsRange(this,t)}static strictContainsRange(t,y){return!(y.startLineNumber<t.startLineNumber||y.endLineNumber<t.startLineNumber||y.startLineNumber>t.endLineNumber||y.endLineNumber>t.endLineNumber||y.startLineNumber===t.startLineNumber&&y.startColumn<=t.startColumn||y.endLineNumber===t.endLineNumber&&y.endColumn>=t.endColumn)}plusRange(t){return M.plusRange(this,t)}static plusRange(t,y){let v,o,c,p;return y.startLineNumber<t.startLineNumber?(v=y.startLineNumber,o=y.startColumn):y.startLineNumber===t.startLineNumber?(v=y.startLineNumber,o=Math.min(y.startColumn,t.startColumn)):(v=t.startLineNumber,o=t.startColumn),y.endLineNumber>t.endLineNumber?(c=y.endLineNumber,p=y.endColumn):y.endLineNumber===t.endLineNumber?(c=y.endLineNumber,p=Math.max(y.endColumn,t.endColumn)):(c=t.endLineNumber,p=t.endColumn),new M(v,o,c,p)}intersectRanges(t){return M.intersectRanges(this,t)}static intersectRanges(t,y){let v=t.startLineNumber,o=t.startColumn,c=t.endLineNumber,p=t.endColumn;const e=y.startLineNumber,b=y.startColumn,f=y.endLineNumber,g=y.endColumn;return v<e?(v=e,o=b):v===e&&(o=Math.max(o,b)),c>f?(c=f,p=g):c===f&&(p=Math.min(p,g)),v>c||v===c&&o>p?null:new M(v,o,c,p)}equalsRange(t){return M.equalsRange(this,t)}static equalsRange(t,y){return!t&&!y?!0:!!t&&!!y&&t.startLineNumber===y.startLineNumber&&t.startColumn===y.startColumn&&t.endLineNumber===y.endLineNumber&&t.endColumn===y.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(t){return new _.Position(t.endLineNumber,t.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(t){return new _.Position(t.startLineNumber,t.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(t,y){return new M(this.startLineNumber,this.startColumn,t,y)}setStartPosition(t,y){return new M(t,y,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(t){return new M(t.startLineNumber,t.startColumn,t.startLineNumber,t.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(t){return new M(t.endLineNumber,t.endColumn,t.endLineNumber,t.endColumn)}delta(t){return new M(this.startLineNumber+t,this.startColumn,this.endLineNumber+t,this.endColumn)}static fromPositions(t,y=t){return new M(t.lineNumber,t.column,y.lineNumber,y.column)}static lift(t){return t?new M(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null}static isIRange(t){return t&&typeof t.startLineNumber=="number"&&typeof t.startColumn=="number"&&typeof t.endLineNumber=="number"&&typeof t.endColumn=="number"}static areIntersectingOrTouching(t,y){return!(t.endLineNumber<y.startLineNumber||t.endLineNumber===y.startLineNumber&&t.endColumn<y.startColumn||y.endLineNumber<t.startLineNumber||y.endLineNumber===t.startLineNumber&&y.endColumn<t.startColumn)}static areIntersecting(t,y){return!(t.endLineNumber<y.startLineNumber||t.endLineNumber===y.startLineNumber&&t.endColumn<=y.startColumn||y.endLineNumber<t.startLineNumber||y.endLineNumber===t.startLineNumber&&y.endColumn<=t.startColumn)}static compareRangesUsingStarts(t,y){if(t&&y){const c=t.startLineNumber|0,p=y.startLineNumber|0;if(c===p){const e=t.startColumn|0,b=y.startColumn|0;if(e===b){const f=t.endLineNumber|0,g=y.endLineNumber|0;if(f===g){const L=t.endColumn|0,w=y.endColumn|0;return L-w}return f-g}return e-b}return c-p}return(t?1:0)-(y?1:0)}static compareRangesUsingEnds(t,y){return t.endLineNumber===y.endLineNumber?t.endColumn===y.endColumn?t.startLineNumber===y.startLineNumber?t.startColumn-y.startColumn:t.startLineNumber-y.startLineNumber:t.endColumn-y.endColumn:t.endLineNumber-y.endLineNumber}static spansMultipleLines(t){return t.endLineNumber>t.startLineNumber}toJSON(){return this}}i.Range=M}),Y(X[31],Q([0,1,3,2]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Selection=void 0;class A extends M.Range{constructor(y,v,o,c){super(y,v,o,c),this.selectionStartLineNumber=y,this.selectionStartColumn=v,this.positionLineNumber=o,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return A.selectionsEqual(this,y)}static selectionsEqual(y,v){return y.selectionStartLineNumber===v.selectionStartLineNumber&&y.selectionStartColumn===v.selectionStartColumn&&y.positionLineNumber===v.positionLineNumber&&y.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,v){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,y,v):new A(y,v,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(y,v){return this.getDirection()===0?new A(y,v,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,y,v)}static fromPositions(y,v=y){return new A(y.lineNumber,y.column,v.lineNumber,v.column)}static fromRange(y,v){return v===0?new A(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):new A(y.endLineNumber,y.endColumn,y.startLineNumber,y.startColumn)}static liftSelection(y){return new A(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,v){if(y&&!v||!y&&v)return!1;if(!y&&!v)return!0;if(y.length!==v.length)return!1;for(let o=0,c=y.length;o<c;o++)if(!this.selectionsEqual(y[o],v[o]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,v,o,c,p){return p===0?new A(y,v,o,c):new A(o,c,y,v)}}i.Selection=A}),Y(X[32],Q([0,1,18]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMapForWordSeparators=i.WordCharacterClassifier=void 0;class M extends _.CharacterClassifier{constructor(y){super(0);for(let v=0,o=y.length;v<o;v++)this.set(y.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}i.WordCharacterClassifier=M;function A(t){const y={};return v=>(y.hasOwnProperty(v)||(y[v]=t(v)),y[v])}i.getMapForWordSeparators=A(t=>new M(t))}),Y(X[19],Q([0,1,13,14]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getWordAtText=i.ensureValidWordDefinition=i.DEFAULT_WORD_REGEXP=i.USUAL_WORD_SEPARATORS=void 0,i.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(c=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const e of i.USUAL_WORD_SEPARATORS)c.indexOf(e)>=0||(p+="\\"+e);return p+="\\s]+)",new RegExp(p,"g")}i.DEFAULT_WORD_REGEXP=A();function t(c){let p=i.DEFAULT_WORD_REGEXP;if(c&&c instanceof RegExp)if(c.global)p=c;else{let e="g";c.ignoreCase&&(e+="i"),c.multiline&&(e+="m"),c.unicode&&(e+="u"),p=new RegExp(c.source,e)}return p.lastIndex=0,p}i.ensureValidWordDefinition=t;const y=new M.LinkedList;y.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(c,p,e,b,f){if(f||(f=_.Iterable.first(y)),e.length>f.maxLen){let d=c-f.maxLen/2;return d<0?d=0:b+=d,e=e.substring(d,c+f.maxLen/2),v(c,p,e,b,f)}const g=Date.now(),L=c-1-b;let w=-1,N=null;for(let d=1;!(Date.now()-g>=f.timeBudget);d++){const C=L-f.windowSize*d;p.lastIndex=Math.max(0,C);const l=o(p,e,L,w);if(!l&&N||(N=l,C<=0))break;w=C}if(N){const d={word:N[0],startColumn:b+1+N.index,endColumn:b+1+N.index+N[0].length};return p.lastIndex=0,d}return null}i.getWordAtText=v;function o(c,p,e,b){let f;for(;f=c.exec(p);){const g=f.index||0;if(g<=e&&c.lastIndex>=e)return f;if(b>0&&g>b)return null}return null}}),Y(X[6],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OffsetRange=i.SequenceDiff=void 0;class _{constructor(t,y){this.seq1Range=t,this.seq2Range=y}reverse(){return new _(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}i.SequenceDiff=_;class M{constructor(t,y){this.start=t,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(t){return new M(this.start+t,this.endExclusive+t)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(t){return new M(Math.min(this.start,t.start),Math.max(this.endExclusive,t.endExclusive))}}i.OffsetRange=M}),Y(X[33],Q([0,1,6]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.shiftSequenceDiffs=i.joinSequenceDiffs=i.smoothenSequenceDiffs=i.optimizeSequenceDiffs=void 0;function M(o,c,p){let e=p;return e=t(o,c,e),e=y(o,c,e),e}i.optimizeSequenceDiffs=M;function A(o,c,p){const e=[];for(const b of p){const f=e[e.length-1];if(!f){e.push(b);continue}b.seq1Range.start-f.seq1Range.endExclusive<=2||b.seq2Range.start-f.seq2Range.endExclusive<=2?e[e.length-1]=new _.SequenceDiff(f.seq1Range.join(b.seq1Range),f.seq2Range.join(b.seq2Range)):e.push(b)}return e}i.smoothenSequenceDiffs=A;function t(o,c,p){const e=[];p.length>0&&e.push(p[0]);for(let b=1;b<p.length;b++){const f=e[e.length-1],g=p[b];if(g.seq1Range.isEmpty){let L=!0;const w=g.seq1Range.start-f.seq1Range.endExclusive;for(let N=1;N<=w;N++)if(c.getElement(g.seq2Range.start-N)!==c.getElement(g.seq2Range.endExclusive-N)){L=!1;break}if(L){e[e.length-1]=new _.SequenceDiff(f.seq1Range,new _.OffsetRange(f.seq2Range.start,g.seq2Range.endExclusive-w));continue}}e.push(g)}return e}i.joinSequenceDiffs=t;function y(o,c,p){if(!o.getBoundaryScore||!c.getBoundaryScore)return p;for(let e=0;e<p.length;e++){const b=p[e];if(b.seq1Range.isEmpty){const f=e>0?p[e-1].seq2Range.endExclusive:-1,g=e+1<p.length?p[e+1].seq2Range.start:c.length;p[e]=v(b,o,c,g,f)}else if(b.seq2Range.isEmpty){const f=e>0?p[e-1].seq1Range.endExclusive:-1,g=e+1<p.length?p[e+1].seq1Range.start:o.length;p[e]=v(b.reverse(),c,o,g,f).reverse()}}return p}i.shiftSequenceDiffs=y;function v(o,c,p,e,b){let g=1;for(;o.seq2Range.start-g>b&&p.getElement(o.seq2Range.start-g)===p.getElement(o.seq2Range.endExclusive-g)&&g<20;)g++;g--;let L=0;for(;o.seq2Range.start+L<e&&p.getElement(o.seq2Range.start+L)===p.getElement(o.seq2Range.endExclusive+L)&&L<20;)L++;if(g===0&&L===0)return o;let w=0,N=-1;for(let d=-g;d<=L;d++){const C=o.seq2Range.start+d,l=o.seq2Range.endExclusive+d,h=o.seq1Range.start+d,s=c.getBoundaryScore(h)+p.getBoundaryScore(C)+p.getBoundaryScore(l);s>N&&(N=s,w=d)}return w!==0?new _.SequenceDiff(o.seq1Range.delta(w),o.seq2Range.delta(w)):o}}),Y(X[34],Q([0,1,6]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MyersDiffAlgorithm=void 0;class M{compute(o,c){if(o.length===0)return[new _.SequenceDiff(new _.OffsetRange(0,0),new _.OffsetRange(0,c.length))];if(c.length===0)return[new _.SequenceDiff(new _.OffsetRange(0,o.length),new _.OffsetRange(0,0))];function p(C,l){for(;C<o.length&&l<c.length&&o.getElement(C)===c.getElement(l);)C++,l++;return C}let e=0;const b=new t;b.set(0,p(0,0));const f=new y;f.set(0,b.get(0)===0?null:new A(null,0,0,b.get(0)));let g=0;e:for(;;)for(e++,g=-e;g<=e;g+=2){const C=g===e?-1:b.get(g+1),l=g===-e?-1:b.get(g-1)+1,h=Math.min(Math.max(C,l),o.length),s=h-g,a=p(h,s);b.set(g,a);const r=h===C?f.get(g+1):f.get(g-1);if(f.set(g,a!==h?new A(r,h,s,a-h):r),b.get(g)===o.length&&b.get(g)-g===c.length)break e}let L=f.get(g);const w=[];let N=o.length,d=c.length;for(;;){const C=L?L.x+L.length:0,l=L?L.y+L.length:0;if((C!==N||l!==d)&&w.push(new _.SequenceDiff(new _.OffsetRange(C,N),new _.OffsetRange(l,d))),!L)break;N=L.x,d=L.y,L=L.prev}return w.reverse(),w}}i.MyersDiffAlgorithm=M;class A{constructor(o,c,p,e){this.prev=o,this.x=c,this.y=p,this.length=e}}class t{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,c){if(o<0){if(o=-o-1,o>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[o]=c}else{if(o>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[o]=c}}}class y{constructor(){this.a=[],this.b=[]}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,c){o<0?(o=-o-1,this.b[o]=c):this.a[o]=c}}}),Y(X[35],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Array2D=void 0;class _{constructor(A,t){this.width=A,this.height=t,this.a=[],this.a=new Array(A*t)}get(A,t){return this.a[A+t*this.width]}set(A,t,y){this.a[A+t*this.width]=y}}i.Array2D=_}),Y(X[36],Q([0,1,6,35]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DynamicProgrammingDiffing=void 0;class A{compute(y,v,o){const c=new M.Array2D(y.length,v.length),p=new M.Array2D(y.length,v.length),e=new M.Array2D(y.length,v.length);for(let d=0;d<y.length;d++)for(let C=0;C<v.length;C++){const l=d===0?0:c.get(d-1,C),h=C===0?0:c.get(d,C-1);let s;y.getElement(d)===v.getElement(C)?(d===0||C===0?s=0:s=c.get(d-1,C-1),d>0&&C>0&&p.get(d-1,C-1)===3&&(s+=e.get(d-1,C-1)),s+=o?o(d,C):1):s=-1;const a=Math.max(l,h,s);if(a===s){const r=d>0&&C>0?e.get(d-1,C-1):0;e.set(d,C,r+1),p.set(d,C,3)}else a===l?(e.set(d,C,0),p.set(d,C,1)):a===h&&(e.set(d,C,0),p.set(d,C,2));c.set(d,C,a)}const b=[];let f=y.length,g=v.length;function L(d,C){(d+1!==f||C+1!==g)&&b.push(new _.SequenceDiff(new _.OffsetRange(d+1,f),new _.OffsetRange(C+1,g))),f=d,g=C}let w=y.length-1,N=v.length-1;for(;w>=0&&N>=0;)p.get(w,N)===3?(L(w,N),w--,N--):p.get(w,N)===1?w--:N--;return L(-1,-1),b.reverse(),b}}i.DynamicProgrammingDiffing=A}),Y(X[20],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRange=i.RangeMapping=i.LineRangeMapping=void 0;class _{constructor(y,v,o){this.originalRange=y,this.modifiedRange=v,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}i.LineRangeMapping=_;class M{constructor(y,v){this.originalRange=y,this.modifiedRange=v}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}i.RangeMapping=M;class A{constructor(y,v){this.startLineNumber=y,this.endLineNumberExclusive=v}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(y){return new A(this.startLineNumber+y,this.endLineNumberExclusive+y)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(y){return new A(Math.min(this.startLineNumber,y.startLineNumber),Math.max(this.endLineNumberExclusive,y.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}i.LineRange=A}),Y(X[37],Q([0,1,15,20,4,2,9]),function(U,i,_,M,A,t,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffComputer=i.SmartLinesDiffComputer=void 0;const v=3;class o{computeDiff(l,h,s){var a;const u=new L(l,h,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),m=[];let S=null;for(const R of u.changes){let E;R.originalEndLineNumber===0?E=new M.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):E=new M.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let P;R.modifiedEndLineNumber===0?P=new M.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):P=new M.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let F=new M.LineRangeMapping(E,P,(a=R.charChanges)===null||a===void 0?void 0:a.map(V=>new M.RangeMapping(new t.Range(V.originalStartLineNumber,V.originalStartColumn,V.originalEndLineNumber,V.originalEndColumn),new t.Range(V.modifiedStartLineNumber,V.modifiedStartColumn,V.modifiedEndLineNumber,V.modifiedEndColumn))));S&&(S.modifiedRange.endLineNumberExclusive===F.modifiedRange.startLineNumber||S.originalRange.endLineNumberExclusive===F.originalRange.startLineNumber)&&(F=new M.LineRangeMapping(S.originalRange.join(F.originalRange),S.modifiedRange.join(F.modifiedRange),S.innerChanges&&F.innerChanges?S.innerChanges.concat(F.innerChanges):void 0),m.pop()),m.push(F),S=F}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(m,(R,E)=>E.originalRange.startLineNumber-R.originalRange.endLineNumberExclusive===E.modifiedRange.startLineNumber-R.modifiedRange.endLineNumberExclusive&&R.originalRange.endLineNumberExclusive<E.originalRange.startLineNumber&&R.modifiedRange.endLineNumberExclusive<E.modifiedRange.startLineNumber)),{quitEarly:u.quitEarly,changes:m}}}i.SmartLinesDiffComputer=o;function c(C,l,h,s){return new _.LcsDiff(C,l,h).ComputeDiff(s)}class p{constructor(l){const h=[],s=[];for(let a=0,r=l.length;a<r;a++)h[a]=w(l[a],1),s[a]=N(l[a],1);this.lines=l,this.a=h,this.b=s}getElements(){const l=[];for(let h=0,s=this.lines.length;h<s;h++)l[h]=this.lines[h].substring(this.a[h]-1,this.b[h]-1);return l}getStrictElement(l){return this.lines[l]}getStartLineNumber(l){return l+1}getEndLineNumber(l){return l+1}createCharSequence(l,h,s){const a=[],r=[],u=[];let m=0;for(let S=h;S<=s;S++){const R=this.lines[S],E=l?this.a[S]:1,P=l?this.b[S]:R.length+1;for(let F=E;F<P;F++)a[m]=R.charCodeAt(F-1),r[m]=S+1,u[m]=F,m++;!l&&S<s&&(a[m]=10,r[m]=S+1,u[m]=R.length+1,m++)}return new e(a,r,u)}}class e{constructor(l,h,s){this.a=l,this.b=h,this.d=s}toString(){return"["+this.a.map((l,h)=>(l===10?"\\n":String.fromCharCode(l))+`-(${this.b[h]},${this.d[h]})`).join(", ")+"]"}e(l,h){if(l<0||l>=h.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(l){return l>0&&l===this.b.length?this.getEndLineNumber(l-1):(this.e(l,this.b),this.b[l])}getEndLineNumber(l){return l===-1?this.getStartLineNumber(l+1):(this.e(l,this.b),this.a[l]===10?this.b[l]+1:this.b[l])}getStartColumn(l){return l>0&&l===this.d.length?this.getEndColumn(l-1):(this.e(l,this.d),this.d[l])}getEndColumn(l){return l===-1?this.getStartColumn(l+1):(this.e(l,this.d),this.a[l]===10?1:this.d[l]+1)}}class b{constructor(l,h,s,a,r,u,m,S){this.originalStartLineNumber=l,this.originalStartColumn=h,this.originalEndLineNumber=s,this.originalEndColumn=a,this.modifiedStartLineNumber=r,this.modifiedStartColumn=u,this.modifiedEndLineNumber=m,this.modifiedEndColumn=S}static createFromDiffChange(l,h,s){const a=h.getStartLineNumber(l.originalStart),r=h.getStartColumn(l.originalStart),u=h.getEndLineNumber(l.originalStart+l.originalLength-1),m=h.getEndColumn(l.originalStart+l.originalLength-1),S=s.getStartLineNumber(l.modifiedStart),R=s.getStartColumn(l.modifiedStart),E=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1),P=s.getEndColumn(l.modifiedStart+l.modifiedLength-1);return new b(a,r,u,m,S,R,E,P)}}function f(C){if(C.length<=1)return C;const l=[C[0]];let h=l[0];for(let s=1,a=C.length;s<a;s++){const r=C[s],u=r.originalStart-(h.originalStart+h.originalLength),m=r.modifiedStart-(h.modifiedStart+h.modifiedLength);Math.min(u,m)<v?(h.originalLength=r.originalStart+r.originalLength-h.originalStart,h.modifiedLength=r.modifiedStart+r.modifiedLength-h.modifiedStart):(l.push(r),h=r)}return l}class g{constructor(l,h,s,a,r){this.originalStartLineNumber=l,this.originalEndLineNumber=h,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=a,this.charChanges=r}static createFromDiffResult(l,h,s,a,r,u,m){let S,R,E,P,F;if(h.originalLength===0?(S=s.getStartLineNumber(h.originalStart)-1,R=0):(S=s.getStartLineNumber(h.originalStart),R=s.getEndLineNumber(h.originalStart+h.originalLength-1)),h.modifiedLength===0?(E=a.getStartLineNumber(h.modifiedStart)-1,P=0):(E=a.getStartLineNumber(h.modifiedStart),P=a.getEndLineNumber(h.modifiedStart+h.modifiedLength-1)),u&&h.originalLength>0&&h.originalLength<20&&h.modifiedLength>0&&h.modifiedLength<20&&r()){const V=s.createCharSequence(l,h.originalStart,h.originalStart+h.originalLength-1),O=a.createCharSequence(l,h.modifiedStart,h.modifiedStart+h.modifiedLength-1);if(V.getElements().length>0&&O.getElements().length>0){let q=c(V,O,r,!0).changes;m&&(q=f(q)),F=[];for(let k=0,I=q.length;k<I;k++)F.push(b.createFromDiffChange(q[k],V,O))}}return new g(S,R,E,P,F)}}class L{constructor(l,h,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=l,this.g=h,this.h=new p(l),this.j=new p(h),this.k=d(s.maxComputationTime),this.l=d(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const l=c(this.h,this.j,this.k,this.e),h=l.changes,s=l.quitEarly;if(this.d){const m=[];for(let S=0,R=h.length;S<R;S++)m.push(g.createFromDiffResult(this.d,h[S],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:m}}const a=[];let r=0,u=0;for(let m=-1,S=h.length;m<S;m++){const R=m+1<S?h[m+1]:null,E=R?R.originalStart:this.f.length,P=R?R.modifiedStart:this.g.length;for(;r<E&&u<P;){const F=this.f[r],V=this.g[u];if(F!==V){{let O=w(F,1),q=w(V,1);for(;O>1&&q>1;){const k=F.charCodeAt(O-2),I=V.charCodeAt(q-2);if(k!==I)break;O--,q--}(O>1||q>1)&&this.m(a,r+1,1,O,u+1,1,q)}{let O=N(F,1),q=N(V,1);const k=F.length+1,I=V.length+1;for(;O<k&&q<I;){const T=F.charCodeAt(O-1),W=F.charCodeAt(q-1);if(T!==W)break;O++,q++}(O<k||q<I)&&this.m(a,r+1,O,k,u+1,q,I)}}r++,u++}R&&(a.push(g.createFromDiffResult(this.d,R,this.h,this.j,this.l,this.a,this.b)),r+=R.originalLength,u+=R.modifiedLength)}return{quitEarly:s,changes:a}}m(l,h,s,a,r,u,m){if(this.n(l,h,s,a,r,u,m))return;let S;this.a&&(S=[new b(h,s,h,a,r,u,r,m)]),l.push(new g(h,h,r,r,S))}n(l,h,s,a,r,u,m){const S=l.length;if(S===0)return!1;const R=l[S-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===h&&R.modifiedEndLineNumber===r?(this.a&&R.charChanges&&R.charChanges.push(new b(h,s,h,a,r,u,r,m)),!0):R.originalEndLineNumber+1===h&&R.modifiedEndLineNumber+1===r?(R.originalEndLineNumber=h,R.modifiedEndLineNumber=r,this.a&&R.charChanges&&R.charChanges.push(new b(h,s,h,a,r,u,r,m)),!0):!1}}i.DiffComputer=L;function w(C,l){const h=A.firstNonWhitespaceIndex(C);return h===-1?l:h+1}function N(C,l){const h=A.lastNonWhitespaceIndex(C);return h===-1?l:h+2}function d(C){if(C===0)return()=>!0;const l=Date.now();return()=>Date.now()-l<C}}),Y(X[38],Q([0,1,9,3,2,6,36,33,34,20]),function(U,i,_,M,A,t,y,v,o,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineSequence=i.lineRangeMappingFromRangeMappings=i.StandardLinesDiffComputer=void 0;class p{constructor(){this.b=new y.DynamicProgrammingDiffing,this.c=new o.MyersDiffAlgorithm}computeDiff(h,s,a){const r=new Map;function u(I){let T=r.get(I);return T===void 0&&(T=r.size,r.set(I,T)),T}const m=h.map(I=>u(I.trim())),S=s.map(I=>u(I.trim())),R=new f(m,h),E=new f(S,s);let P=(()=>R.length+E.length<1500?this.b.compute(R,E,(I,T)=>h[I]===s[T]?s[T].length===0?.1:1+Math.log(1+s[T].length):.99):this.c.compute(R,E))();P=(0,v.optimizeSequenceDiffs)(R,E,P);const F=[],V=I=>{for(let T=0;T<I;T++){const W=O+T,z=q+T;if(h[W]!==s[z]){const n=this.e(h,s,new t.SequenceDiff(new t.OffsetRange(W,W+1),new t.OffsetRange(z,z+1)));for(const se of n)F.push(se)}}};let O=0,q=0;for(const I of P){(0,_.assertFn)(()=>I.seq1Range.start-O===I.seq2Range.start-q);const T=I.seq1Range.start-O;V(T),O=I.seq1Range.endExclusive,q=I.seq2Range.endExclusive;const W=this.e(h,s,I);for(const z of W)F.push(z)}V(h.length-O);const k=e(F);return{quitEarly:!1,changes:k}}e(h,s,a){const r=new L(h,a.seq1Range),u=new L(s,a.seq2Range),m=r.length+u.length<500?this.b.compute(r,u):this.c.compute(r,u);let S=(0,v.optimizeSequenceDiffs)(r,u,m);return S=(0,v.smoothenSequenceDiffs)(r,u,S),S.map(E=>new c.RangeMapping(r.translateRange(E.seq1Range).delta(a.seq1Range.start),u.translateRange(E.seq2Range).delta(a.seq2Range.start)))}}i.StandardLinesDiffComputer=p;function e(l){const h=[];for(const s of b(l,(a,r)=>r.originalRange.startLineNumber-(a.originalRange.endLineNumber-(a.originalRange.endColumn>1?0:1))<=1||r.modifiedRange.startLineNumber-(a.modifiedRange.endLineNumber-(a.modifiedRange.endColumn>1?0:1))<=1)){const a=s[0],r=s[s.length-1];h.push(new c.LineRangeMapping(new c.LineRange(a.originalRange.startLineNumber,r.originalRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),new c.LineRange(a.modifiedRange.startLineNumber,r.modifiedRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),s))}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(h,(s,a)=>a.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===a.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<a.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<a.modifiedRange.startLineNumber)),h}i.lineRangeMappingFromRangeMappings=e;function*b(l,h){let s,a;for(const r of l)a!==void 0&&h(a,r)?s.push(r):(s&&(yield s),s=[r]),a=r;s&&(yield s)}class f{constructor(h,s){this.b=h,this.c=s}getElement(h){return this.b[h]}get length(){return this.b.length}getBoundaryScore(h){const s=h===0?0:g(this.c[h-1]),a=h===this.c.length?0:g(this.c[h]);return 1e3-(s+a)}}i.LineSequence=f;function g(l){let h=0;for(;h<l.length&&(l.charCodeAt(h)===32||l.charCodeAt(h)===9);)h++;return h}class L{constructor(h,s){this.lines=h,this.lineRange=s;let a=0;this.c=new Int32Array(s.length);for(let u=s.start;u<s.endExclusive;u++)a+=h[u].length,this.c[u-s.start]=a+1,a++;this.b=new Int32Array(a);let r=0;for(let u=s.start;u<s.endExclusive;u++){const m=h[u];for(let S=0;S<m.length;S++)this.b[r+S]=m.charCodeAt(S);r+=m.length,u<h.length-1&&(this.b[r]=`
`.charCodeAt(0),r+=1)}}getElement(h){return this.b[h]}get length(){return this.b.length}getBoundaryScore(h){const s=d(h>0?this.b[h-1]:-1),a=d(h<this.b.length?this.b[h]:-1);if(s===6&&a===7)return 0;let r=0;return s!==a&&(r+=10,a===1&&(r+=1)),r+=N(s),r+=N(a),r}translateOffset(h){let s=0,a=this.c.length;for(;s<a;){const u=Math.floor((s+a)/2);this.c[u]>h?a=u:s=u+1}const r=s===0?0:this.c[s-1];return new M.Position(s+1,h-r+1)}translateRange(h){return A.Range.fromPositions(this.translateOffset(h.start),this.translateOffset(h.endExclusive))}}const w={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function N(l){return w[l]}function d(l){return l===10?7:l===13?6:C(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function C(l){return l===32||l===9}}),Y(X[39],Q([0,1,37,38]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.linesDiffComputers=void 0,i.linesDiffComputers={smart:new _.SmartLinesDiffComputer,experimental:new M.StandardLinesDiffComputer}}),Y(X[40],Q([0,1,18]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeLinks=i.LinkComputer=i.StateMachine=void 0;class M{constructor(b,f,g){const L=new Uint8Array(b*f);for(let w=0,N=b*f;w<N;w++)L[w]=g;this.a=L,this.rows=b,this.cols=f}get(b,f){return this.a[b*this.cols+f]}set(b,f,g){this.a[b*this.cols+f]=g}}class A{constructor(b){let f=0,g=0;for(let w=0,N=b.length;w<N;w++){const[d,C,l]=b[w];C>f&&(f=C),d>g&&(g=d),l>g&&(g=l)}f++,g++;const L=new M(g,f,0);for(let w=0,N=b.length;w<N;w++){const[d,C,l]=b[w];L.set(d,C,l)}this.a=L,this.b=f}nextState(b,f){return f<0||f>=this.b?0:this.a.get(b,f)}}i.StateMachine=A;let t=null;function y(){return t===null&&(t=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),t}let v=null;function o(){if(v===null){v=new _.CharacterClassifier(0);const e=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<e.length;f++)v.set(e.charCodeAt(f),1);const b=".;:";for(let f=0;f<b.length;f++)v.set(b.charCodeAt(f),2)}return v}class c{static a(b,f,g,L,w){let N=w-1;do{const d=f.charCodeAt(N);if(b.get(d)!==2)break;N--}while(N>L);if(L>0){const d=f.charCodeAt(L-1),C=f.charCodeAt(N);(d===40&&C===41||d===91&&C===93||d===123&&C===125)&&N--}return{range:{startLineNumber:g,startColumn:L+1,endLineNumber:g,endColumn:N+2},url:f.substring(L,N+1)}}static computeLinks(b,f=y()){const g=o(),L=[];for(let w=1,N=b.getLineCount();w<=N;w++){const d=b.getLineContent(w),C=d.length;let l=0,h=0,s=0,a=1,r=!1,u=!1,m=!1,S=!1;for(;l<C;){let R=!1;const E=d.charCodeAt(l);if(a===13){let P;switch(E){case 40:r=!0,P=0;break;case 41:P=r?0:1;break;case 91:m=!0,u=!0,P=0;break;case 93:m=!1,P=u?0:1;break;case 123:S=!0,P=0;break;case 125:P=S?0:1;break;case 39:case 34:case 96:s===E?P=1:s===39||s===34||s===96?P=0:P=1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=m?0:1;break;default:P=g.get(E)}P===1&&(L.push(c.a(g,d,w,h,l)),R=!0)}else if(a===12){let P;E===91?(u=!0,P=0):P=g.get(E),P===1?R=!0:a=13}else a=f.nextState(a,E),a===0&&(R=!0);R&&(a=1,r=!1,u=!1,S=!1,h=l+1,s=E),l++}a===13&&L.push(c.a(g,d,w,h,C))}return L}}i.LinkComputer=c;function p(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:c.computeLinks(e)}i.computeLinks=p}),Y(X[41],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BasicInplaceReplace=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,t,y,v,o){if(A&&t){const c=this.a(t,o);if(c)return{range:A,value:c}}if(y&&v){const c=this.a(v,o);if(c)return{range:y,value:c}}return null}a(A,t){const y=this.b(A,t);return y!==null?y:this.d(A,t)}b(A,t){const y=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let v=Number(A);const o=parseFloat(A);return!isNaN(v)&&!isNaN(o)&&v===o?v===0&&!t?null:(v=Math.floor(v*y),v+=t?y:-y,String(v/y)):null}d(A,t){return this.e(this.c,A,t)}e(A,t,y){let v=null;for(let o=0,c=A.length;v===null&&o<c;o++)v=this.f(A[o],t,y);return v}f(A,t,y){let v=A.indexOf(t);return v>=0?(v+=y?1:-1,v<0?v=A.length-1:v%=A.length,A[v]):null}}i.BasicInplaceReplace=_,_.INSTANCE=new _}),Y(X[42],Q([0,1,11]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.shouldSynchronizeModel=i.ApplyEditsResult=i.SearchData=i.ValidAnnotatedEditOperation=i.isITextSnapshot=i.FindMatch=i.TextModelResolvedOptions=i.InjectedTextCursorStops=i.MinimapPosition=i.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M=i.OverviewRulerLane||(i.OverviewRulerLane={}));var A;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(A=i.MinimapPosition||(i.MinimapPosition={}));var t;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(t=i.InjectedTextCursorStops||(i.InjectedTextCursorStops={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,_.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}i.TextModelResolvedOptions=y;class v{constructor(g,L){this._findMatchBrand=void 0,this.range=g,this.matches=L}}i.FindMatch=v;function o(f){return f&&typeof f.read=="function"}i.isITextSnapshot=o;class c{constructor(g,L,w,N,d,C){this.identifier=g,this.range=L,this.text=w,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=d,this._isTracked=C}}i.ValidAnnotatedEditOperation=c;class p{constructor(g,L,w){this.regex=g,this.wordSeparators=L,this.simpleSearch=w}}i.SearchData=p;class e{constructor(g,L,w){this.reverseEdits=g,this.changes=L,this.trimAutoWhitespaceLineNumbers=w}}i.ApplyEditsResult=e;function b(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}i.shouldSynchronizeModel=b}),Y(X[43],Q([0,1,23,17]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PrefixSumIndexOfResult=i.ConstantTimePrefixSumComputer=i.PrefixSumComputer=void 0;class A{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(o,c){o=(0,M.toUint32)(o);const p=this.a,e=this.b,b=c.length;return b===0?!1:(this.a=new Uint32Array(p.length+b),this.a.set(p.subarray(0,o),0),this.a.set(p.subarray(o),o+b),this.a.set(c,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}setValue(o,c){return o=(0,M.toUint32)(o),c=(0,M.toUint32)(c),this.a[o]===c?!1:(this.a[o]=c,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,c){o=(0,M.toUint32)(o),c=(0,M.toUint32)(c);const p=this.a,e=this.b;if(o>=p.length)return!1;const b=p.length-o;return c>=b&&(c=b),c===0?!1:(this.a=new Uint32Array(p.length-c),this.a.set(p.subarray(0,o),0),this.a.set(p.subarray(o+c),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,M.toUint32)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),o>=this.a.length&&(o=this.a.length-1);for(let p=c;p<=o;p++)this.b[p]=this.b[p-1]+this.a[p];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let c=0,p=this.a.length-1,e=0,b=0,f=0;for(;c<=p;)if(e=c+(p-c)/2|0,b=this.b[e],f=b-this.a[e],o<f)p=e-1;else if(o>=b)c=e+1;else break;return new y(e,o-f)}}i.PrefixSumComputer=A;class t{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const c=this.e[o],p=c>0?this.d[c-1]:0;return new y(c,o-p)}removeValues(o,c){this.a.splice(o,c),this.f(o)}insertValues(o,c){this.a=(0,_.arrayInsert)(this.a,o,c),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,c=this.a.length;o<c;o++){const p=this.a[o],e=o>0?this.d[o-1]:0;this.d[o]=e+p;for(let b=0;b<p;b++)this.e[e+b]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,c){this.a[o]!==c&&(this.a[o]=c,this.f(o))}}i.ConstantTimePrefixSumComputer=t;class y{constructor(o,c){this.index=o,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=c}}i.PrefixSumIndexOfResult=y}),Y(X[44],Q([0,1,4,3,43]),function(U,i,_,M,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MirrorTextModel=void 0;class t{constructor(v,o,c,p){this.c=v,this.d=o,this.f=c,this.g=p,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(v){v.eol&&v.eol!==this.f&&(this.f=v.eol,this.h=null);const o=v.changes;for(const c of o)this.n(c.range),this.o(new M.Position(c.range.startLineNumber,c.range.startColumn),c.text);this.g=v.versionId,this.j=null}k(){if(!this.h){const v=this.f.length,o=this.d.length,c=new Uint32Array(o);for(let p=0;p<o;p++)c[p]=this.d[p].length+v;this.h=new A.PrefixSumComputer(c)}}l(v,o){this.d[v]=o,this.h&&this.h.setValue(v,this.d[v].length+this.f.length)}n(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.l(v.startLineNumber-1,this.d[v.startLineNumber-1].substring(0,v.startColumn-1)+this.d[v.startLineNumber-1].substring(v.endColumn-1));return}this.l(v.startLineNumber-1,this.d[v.startLineNumber-1].substring(0,v.startColumn-1)+this.d[v.endLineNumber-1].substring(v.endColumn-1)),this.d.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.h&&this.h.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}o(v,o){if(o.length===0)return;const c=(0,_.splitLines)(o);if(c.length===1){this.l(v.lineNumber-1,this.d[v.lineNumber-1].substring(0,v.column-1)+c[0]+this.d[v.lineNumber-1].substring(v.column-1));return}c[c.length-1]+=this.d[v.lineNumber-1].substring(v.column-1),this.l(v.lineNumber-1,this.d[v.lineNumber-1].substring(0,v.column-1)+c[0]);const p=new Uint32Array(c.length-1);for(let e=1;e<c.length;e++)this.d.splice(v.lineNumber+e-1,0,c[e]),p[e-1]=c[e].length+this.f.length;this.h&&this.h.insertValues(v.lineNumber,p)}}i.MirrorTextModel=t}),Y(X[45],Q([0,1,4,32,3,2,42]),function(U,i,_,M,A,t,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Searcher=i.isValidMatch=i.TextModelSearch=i.createFindMatch=i.isMultilineRegexSource=i.SearchParams=void 0;const v=999;class o{constructor(d,C,l,h){this.searchString=d,this.isRegex=C,this.matchCase=l,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=c(this.searchString):d=this.searchString.indexOf(`
`)>=0;let C=null;try{C=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!C)return null;let l=!this.isRegex&&!d;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new y.SearchData(C,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}i.SearchParams=o;function c(N){if(!N||N.length===0)return!1;for(let d=0,C=N.length;d<C;d++){const l=N.charCodeAt(d);if(l===10)return!0;if(l===92){if(d++,d>=C)break;const h=N.charCodeAt(d);if(h===110||h===114||h===87)return!0}}return!1}i.isMultilineRegexSource=c;function p(N,d,C){if(!C)return new y.FindMatch(N,null);const l=[];for(let h=0,s=d.length;h<s;h++)l[h]=d[h];return new y.FindMatch(N,l)}i.createFindMatch=p;class e{constructor(d){const C=[];let l=0;for(let h=0,s=d.length;h<s;h++)d.charCodeAt(h)===10&&(C[l++]=h);this.a=C}findLineFeedCountBeforeOffset(d){const C=this.a;let l=0,h=C.length-1;if(h===-1||d<=C[0])return 0;for(;l<h;){const s=l+((h-l)/2>>0);C[s]>=d?h=s-1:C[s+1]>=d?(l=s,h=s):l=s+1}return l+1}}class b{static findMatches(d,C,l,h,s){const a=C.parseSearchRequest();return a?a.regex.multiline?this.b(d,l,new w(a.wordSeparators,a.regex),h,s):this.c(d,l,a,h,s):[]}static a(d,C,l,h,s,a){let r,u=0;h?(u=h.findLineFeedCountBeforeOffset(s),r=C+s+u):r=C+s;let m;if(h){const P=h.findLineFeedCountBeforeOffset(s+a.length)-u;m=r+a.length+P}else m=r+a.length;const S=d.getPositionAt(r),R=d.getPositionAt(m);return new t.Range(S.lineNumber,S.column,R.lineNumber,R.column)}static b(d,C,l,h,s){const a=d.getOffsetAt(C.getStartPosition()),r=d.getValueInRange(C,1),u=d.getEOL()===`\r
`?new e(r):null,m=[];let S=0,R;for(l.reset(0);R=l.next(r);)if(m[S++]=p(this.a(d,a,r,u,R.index,R[0]),R,h),S>=s)return m;return m}static c(d,C,l,h,s){const a=[];let r=0;if(C.startLineNumber===C.endLineNumber){const m=d.getLineContent(C.startLineNumber).substring(C.startColumn-1,C.endColumn-1);return r=this.d(l,m,C.startLineNumber,C.startColumn-1,r,a,h,s),a}const u=d.getLineContent(C.startLineNumber).substring(C.startColumn-1);r=this.d(l,u,C.startLineNumber,C.startColumn-1,r,a,h,s);for(let m=C.startLineNumber+1;m<C.endLineNumber&&r<s;m++)r=this.d(l,d.getLineContent(m),m,0,r,a,h,s);if(r<s){const m=d.getLineContent(C.endLineNumber).substring(0,C.endColumn-1);r=this.d(l,m,C.endLineNumber,0,r,a,h,s)}return a}static d(d,C,l,h,s,a,r,u){const m=d.wordSeparators;if(!r&&d.simpleSearch){const E=d.simpleSearch,P=E.length,F=C.length;let V=-P;for(;(V=C.indexOf(E,V+P))!==-1;)if((!m||L(m,C,F,V,P))&&(a[s++]=new y.FindMatch(new t.Range(l,V+1+h,l,V+1+P+h),null),s>=u))return s;return s}const S=new w(d.wordSeparators,d.regex);let R;S.reset(0);do if(R=S.next(C),R&&(a[s++]=p(new t.Range(l,R.index+1+h,l,R.index+1+R[0].length+h),R,r),s>=u))return s;while(R);return s}static findNextMatch(d,C,l,h){const s=C.parseSearchRequest();if(!s)return null;const a=new w(s.wordSeparators,s.regex);return s.regex.multiline?this.e(d,l,a,h):this.f(d,l,a,h)}static e(d,C,l,h){const s=new A.Position(C.lineNumber,1),a=d.getOffsetAt(s),r=d.getLineCount(),u=d.getValueInRange(new t.Range(s.lineNumber,s.column,r,d.getLineMaxColumn(r)),1),m=d.getEOL()===`\r
`?new e(u):null;l.reset(C.column-1);const S=l.next(u);return S?p(this.a(d,a,u,m,S.index,S[0]),S,h):C.lineNumber!==1||C.column!==1?this.e(d,new A.Position(1,1),l,h):null}static f(d,C,l,h){const s=d.getLineCount(),a=C.lineNumber,r=d.getLineContent(a),u=this.g(l,r,a,C.column,h);if(u)return u;for(let m=1;m<=s;m++){const S=(a+m-1)%s,R=d.getLineContent(S+1),E=this.g(l,R,S+1,1,h);if(E)return E}return null}static g(d,C,l,h,s){d.reset(h-1);const a=d.next(C);return a?p(new t.Range(l,a.index+1,l,a.index+1+a[0].length),a,s):null}static findPreviousMatch(d,C,l,h){const s=C.parseSearchRequest();if(!s)return null;const a=new w(s.wordSeparators,s.regex);return s.regex.multiline?this.h(d,l,a,h):this.j(d,l,a,h)}static h(d,C,l,h){const s=this.b(d,new t.Range(1,1,C.lineNumber,C.column),l,h,10*v);if(s.length>0)return s[s.length-1];const a=d.getLineCount();return C.lineNumber!==a||C.column!==d.getLineMaxColumn(a)?this.h(d,new A.Position(a,d.getLineMaxColumn(a)),l,h):null}static j(d,C,l,h){const s=d.getLineCount(),a=C.lineNumber,r=d.getLineContent(a).substring(0,C.column-1),u=this.k(l,r,a,h);if(u)return u;for(let m=1;m<=s;m++){const S=(s+a-m-1)%s,R=d.getLineContent(S+1),E=this.k(l,R,S+1,h);if(E)return E}return null}static k(d,C,l,h){let s=null,a;for(d.reset(0);a=d.next(C);)s=p(new t.Range(l,a.index+1,l,a.index+1+a[0].length),a,h);return s}}i.TextModelSearch=b;function f(N,d,C,l,h){if(l===0)return!0;const s=d.charCodeAt(l-1);if(N.get(s)!==0||s===13||s===10)return!0;if(h>0){const a=d.charCodeAt(l);if(N.get(a)!==0)return!0}return!1}function g(N,d,C,l,h){if(l+h===C)return!0;const s=d.charCodeAt(l+h);if(N.get(s)!==0||s===13||s===10)return!0;if(h>0){const a=d.charCodeAt(l+h-1);if(N.get(a)!==0)return!0}return!1}function L(N,d,C,l,h){return f(N,d,C,l,h)&&g(N,d,C,l,h)}i.isValidMatch=L;class w{constructor(d,C){this._wordSeparators=d,this.a=C,this.b=-1,this.c=0}reset(d){this.a.lastIndex=d,this.b=-1,this.c=0}next(d){const C=d.length;let l;do{if(this.b+this.c===C||(l=this.a.exec(d),!l))return null;const h=l.index,s=l[0].length;if(h===this.b&&s===this.c){if(s===0){_.getNextCodePoint(d,C,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=s,!this._wordSeparators||L(this._wordSeparators,d,C,h,s))return l}while(l);return null}}i.Searcher=w}),Y(X[46],Q([0,1,2,45,4,9,19]),function(U,i,_,M,A,t,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(b,f,g){const L=g?g.startLineNumber:1,w=g?g.endLineNumber:b.getLineCount(),N=new c(f),d=N.getCandidateCodePoints();let C;d==="allNonBasicAscii"?C=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):C=new RegExp(`${o(Array.from(d))}`,"g");const l=new M.Searcher(null,C),h=[];let s=!1,a,r=0,u=0,m=0;e:for(let S=L,R=w;S<=R;S++){const E=b.getLineContent(S),P=E.length;l.reset(0);do if(a=l.next(E),a){let F=a.index,V=a.index+a[0].length;if(F>0){const I=E.charCodeAt(F-1);A.isHighSurrogate(I)&&F--}if(V+1<P){const I=E.charCodeAt(V-1);A.isHighSurrogate(I)&&V++}const O=E.substring(F,V);let q=(0,y.getWordAtText)(F+1,y.DEFAULT_WORD_REGEXP,E,0);q&&q.endColumn<=F+1&&(q=null);const k=N.shouldHighlightNonBasicASCII(O,q?q.word:null);if(k!==0){k===3?r++:k===2?u++:k===1?m++:(0,t.assertNever)(k);const I=1e3;if(h.length>=I){s=!0;break e}h.push(new _.Range(S,F+1,S,V+1))}}while(a)}return{ranges:h,hasMore:s,ambiguousCharacterCount:r,invisibleCharacterCount:u,nonBasicAsciiCharacterCount:m}}static computeUnicodeHighlightReason(b,f){const g=new c(f);switch(g.shouldHighlightNonBasicASCII(b,null)){case 0:return null;case 2:return{kind:1};case 3:{const w=b.codePointAt(0),N=g.ambiguousCharacters.getPrimaryConfusable(w),d=A.AmbiguousCharacters.getLocales().filter(C=>!A.AmbiguousCharacters.getInstance(new Set([...f.allowedLocales,C])).isAmbiguous(w));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:d}}case 1:return{kind:2}}}}i.UnicodeTextModelHighlighter=v;function o(e,b){return`[${A.escapeRegExpCharacters(e.map(g=>String.fromCodePoint(g)).join(""))}]`}class c{constructor(b){this.b=b,this.a=new Set(b.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(b.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const b=new Set;if(this.b.invisibleCharacters)for(const f of A.InvisibleCharacters.codePoints)p(String.fromCodePoint(f))||b.add(f);if(this.b.ambiguousCharacters)for(const f of this.ambiguousCharacters.getConfusableCodePoints())b.add(f);for(const f of this.a)b.delete(f);return b}shouldHighlightNonBasicASCII(b,f){const g=b.codePointAt(0);if(this.a.has(g))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,w=!1;if(f)for(const N of f){const d=N.codePointAt(0),C=A.isBasicASCII(N);L=L||C,!C&&!this.ambiguousCharacters.isAmbiguous(d)&&!A.InvisibleCharacters.isInvisibleCharacter(d)&&(w=!0)}return!L&&w?0:this.b.invisibleCharacters&&!p(b)&&A.InvisibleCharacters.isInvisibleCharacter(g)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(g)?3:0}}function p(e){return e===" "||e===`
`||e==="	"}}),Y(X[47],Q([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.MouseTargetType=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var _;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(_=i.AccessibilitySupport||(i.AccessibilitySupport={}));var M;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(M=i.CodeActionTriggerType||(i.CodeActionTriggerType={}));var A;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(A=i.CompletionItemInsertTextRule||(i.CompletionItemInsertTextRule={}));var t;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(t=i.CompletionItemKind||(i.CompletionItemKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=i.CompletionItemTag||(i.CompletionItemTag={}));var v;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=i.CompletionTriggerKind||(i.CompletionTriggerKind={}));var o;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(o=i.ContentWidgetPositionPreference||(i.ContentWidgetPositionPreference={}));var c;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(c=i.CursorChangeReason||(i.CursorChangeReason={}));var p;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p=i.DefaultEndOfLine||(i.DefaultEndOfLine={}));var e;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(e=i.DocumentHighlightKind||(i.DocumentHighlightKind={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b=i.EditorAutoIndentStrategy||(i.EditorAutoIndentStrategy={}));var f;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(f=i.EditorOption||(i.EditorOption={}));var g;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g=i.EndOfLinePreference||(i.EndOfLinePreference={}));var L;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(L=i.EndOfLineSequence||(i.EndOfLineSequence={}));var w;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(w=i.IndentAction||(i.IndentAction={}));var N;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(N=i.InjectedTextCursorStops||(i.InjectedTextCursorStops={}));var d;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(d=i.InlayHintKind||(i.InlayHintKind={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C=i.InlineCompletionTriggerKind||(i.InlineCompletionTriggerKind={}));var l;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(l=i.KeyCode||(i.KeyCode={}));var h;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(h=i.MarkerSeverity||(i.MarkerSeverity={}));var s;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(s=i.MarkerTag||(i.MarkerTag={}));var a;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(a=i.MinimapPosition||(i.MinimapPosition={}));var r;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(r=i.MouseTargetType||(i.MouseTargetType={}));var u;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(u=i.OverlayWidgetPositionPreference||(i.OverlayWidgetPositionPreference={}));var m;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(m=i.OverviewRulerLane||(i.OverviewRulerLane={}));var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S=i.PositionAffinity||(i.PositionAffinity={}));var R;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(R=i.RenderLineNumbersType||(i.RenderLineNumbersType={}));var E;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(E=i.RenderMinimap||(i.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=i.ScrollType||(i.ScrollType={}));var F;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(F=i.ScrollbarVisibility||(i.ScrollbarVisibility={}));var V;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(V=i.SelectionDirection||(i.SelectionDirection={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O=i.SignatureHelpTriggerKind||(i.SignatureHelpTriggerKind={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q=i.SymbolKind||(i.SymbolKind={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k=i.SymbolTag||(i.SymbolTag={}));var I;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(I=i.TextEditorCursorBlinkingStyle||(i.TextEditorCursorBlinkingStyle={}));var T;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(T=i.TextEditorCursorStyle||(i.TextEditorCursorStyle={}));var W;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W=i.TrackedRangeStickiness||(i.TrackedRangeStickiness={}));var z;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(z=i.WrappingIndent||(i.WrappingIndent={}))}),Y(X[48],Q([22,55]),function(U,i){return U.create("vs/base/common/platform",i)}),Y(X[5],Q([0,1,48]),function(U,i,_){"use strict";var M;Object.defineProperty(i,"__esModule",{value:!0}),i.isAndroid=i.isEdge=i.isSafari=i.isFirefox=i.isChrome=i.isLittleEndian=i.OS=i.setTimeout0=i.setTimeout0IsFaster=i.language=i.userAgent=i.isMobile=i.isIOS=i.isWebWorker=i.isWeb=i.isNative=i.isLinux=i.isMacintosh=i.isWindows=i.globals=i.LANGUAGE_DEFAULT=void 0,i.LANGUAGE_DEFAULT="en";let A=!1,t=!1,y=!1,v=!1,o=!1,c=!1,p=!1,e=!1,b=!1,f=!1,g,L=i.LANGUAGE_DEFAULT,w,N;i.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof i.globals.vscode<"u"&&typeof i.globals.vscode.process<"u"?d=i.globals.vscode.process:typeof process<"u"&&(d=process);const C=typeof((M=d?.versions)===null||M===void 0?void 0:M.electron)=="string",l=C&&d?.type==="renderer";if(typeof navigator=="object"&&!l)N=navigator.userAgent,A=N.indexOf("Windows")>=0,t=N.indexOf("Macintosh")>=0,e=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=N.indexOf("Linux")>=0,f=N?.indexOf("Mobi")>=0,c=!0,g=_.getConfiguredDefaultLocale(_.localize(0,null))||i.LANGUAGE_DEFAULT,L=g;else if(typeof d=="object"){A=d.platform==="win32",t=d.platform==="darwin",y=d.platform==="linux",v=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,p=C,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=i.LANGUAGE_DEFAULT,L=i.LANGUAGE_DEFAULT;const u=d.env.VSCODE_NLS_CONFIG;if(u)try{const m=JSON.parse(u),S=m.availableLanguages["*"];g=m.locale,L=S||i.LANGUAGE_DEFAULT,w=m._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");let h=0;t?h=1:A?h=3:y&&(h=2),i.isWindows=A,i.isMacintosh=t,i.isLinux=y,i.isNative=o,i.isWeb=c,i.isWebWorker=c&&typeof i.globals.importScripts=="function",i.isIOS=e,i.isMobile=f,i.userAgent=N,i.language=L,i.setTimeout0IsFaster=typeof i.globals.postMessage=="function"&&!i.globals.importScripts,i.setTimeout0=(()=>{if(i.setTimeout0IsFaster){const u=[];i.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let R=0,E=u.length;R<E;R++){const P=u[R];if(P.id===S.data.vscodeScheduleAsyncWork){u.splice(R,1),P.callback();return}}});let m=0;return S=>{const R=++m;u.push({id:R,callback:S}),i.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return u=>setTimeout(u)})(),i.OS=t||e?2:A?1:3;let s=!0,a=!1;function r(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,s=new Uint16Array(u.buffer)[0]===(2<<8)+1}return s}i.isLittleEndian=r,i.isChrome=!!(i.userAgent&&i.userAgent.indexOf("Chrome")>=0),i.isFirefox=!!(i.userAgent&&i.userAgent.indexOf("Firefox")>=0),i.isSafari=!!(!i.isChrome&&i.userAgent&&i.userAgent.indexOf("Safari")>=0),i.isEdge=!!(i.userAgent&&i.userAgent.indexOf("Edg/")>=0),i.isAndroid=!!(i.userAgent&&i.userAgent.indexOf("Android")>=0)}),Y(X[49],Q([0,1,5]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.platform=i.env=i.cwd=void 0;let M;if(typeof _.globals.vscode<"u"&&typeof _.globals.vscode.process<"u"){const A=_.globals.vscode.process;M={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=M.cwd,i.env=M.env,i.platform=M.platform}),Y(X[50],Q([0,1,49]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sep=i.extname=i.basename=i.dirname=i.relative=i.resolve=i.normalize=i.posix=i.win32=void 0;const M=65,A=97,t=90,y=122,v=46,o=47,c=92,p=58,e=63;class b extends Error{constructor(a,r,u){let m;typeof r=="string"&&r.indexOf("not ")===0?(m="must not be",r=r.replace(/^not /,"")):m="must be";const S=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${S} ${m} of type ${r}`;R+=`. Received type ${typeof u}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function f(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function g(s,a){if(typeof s!="string")throw new b(a,"string",s)}const L=_.platform==="win32";function w(s){return s===o||s===c}function N(s){return s===o}function d(s){return s>=M&&s<=t||s>=A&&s<=y}function C(s,a,r,u){let m="",S=0,R=-1,E=0,P=0;for(let F=0;F<=s.length;++F){if(F<s.length)P=s.charCodeAt(F);else{if(u(P))break;P=o}if(u(P)){if(!(R===F-1||E===1))if(E===2){if(m.length<2||S!==2||m.charCodeAt(m.length-1)!==v||m.charCodeAt(m.length-2)!==v){if(m.length>2){const V=m.lastIndexOf(r);V===-1?(m="",S=0):(m=m.slice(0,V),S=m.length-1-m.lastIndexOf(r)),R=F,E=0;continue}else if(m.length!==0){m="",S=0,R=F,E=0;continue}}a&&(m+=m.length>0?`${r}..`:"..",S=2)}else m.length>0?m+=`${r}${s.slice(R+1,F)}`:m=s.slice(R+1,F),S=F-R-1;R=F,E=0}else P===v&&E!==-1?++E:E=-1}return m}function l(s,a){f(a,"pathObject");const r=a.dir||a.root,u=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${u}`:`${r}${s}${u}`:u}i.win32={resolve(...s){let a="",r="",u=!1;for(let m=s.length-1;m>=-1;m--){let S;if(m>=0){if(S=s[m],g(S,"path"),S.length===0)continue}else a.length===0?S=_.cwd():(S=_.env[`=${a}`]||_.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==a.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${a}\\`));const R=S.length;let E=0,P="",F=!1;const V=S.charCodeAt(0);if(R===1)w(V)&&(E=1,F=!0);else if(w(V))if(F=!0,w(S.charCodeAt(1))){let O=2,q=O;for(;O<R&&!w(S.charCodeAt(O));)O++;if(O<R&&O!==q){const k=S.slice(q,O);for(q=O;O<R&&w(S.charCodeAt(O));)O++;if(O<R&&O!==q){for(q=O;O<R&&!w(S.charCodeAt(O));)O++;(O===R||O!==q)&&(P=`\\\\${k}\\${S.slice(q,O)}`,E=O)}}}else E=1;else d(V)&&S.charCodeAt(1)===p&&(P=S.slice(0,2),E=2,R>2&&w(S.charCodeAt(2))&&(F=!0,E=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(u){if(a.length>0)break}else if(r=`${S.slice(E)}\\${r}`,u=F,F&&a.length>0)break}return r=C(r,!u,"\\",w),u?`${a}\\${r}`:`${a}${r}`||"."},normalize(s){g(s,"path");const a=s.length;if(a===0)return".";let r=0,u,m=!1;const S=s.charCodeAt(0);if(a===1)return N(S)?"\\":s;if(w(S))if(m=!0,w(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!w(s.charCodeAt(E));)E++;if(E<a&&E!==P){const F=s.slice(P,E);for(P=E;E<a&&w(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!w(s.charCodeAt(E));)E++;if(E===a)return`\\\\${F}\\${s.slice(P)}\\`;E!==P&&(u=`\\\\${F}\\${s.slice(P,E)}`,r=E)}}}else r=1;else d(S)&&s.charCodeAt(1)===p&&(u=s.slice(0,2),r=2,a>2&&w(s.charCodeAt(2))&&(m=!0,r=3));let R=r<a?C(s.slice(r),!m,"\\",w):"";return R.length===0&&!m&&(R="."),R.length>0&&w(s.charCodeAt(a-1))&&(R+="\\"),u===void 0?m?`\\${R}`:R:m?`${u}\\${R}`:`${u}${R}`},isAbsolute(s){g(s,"path");const a=s.length;if(a===0)return!1;const r=s.charCodeAt(0);return w(r)||a>2&&d(r)&&s.charCodeAt(1)===p&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,r;for(let S=0;S<s.length;++S){const R=s[S];g(R,"path"),R.length>0&&(a===void 0?a=r=R:a+=`\\${R}`)}if(a===void 0)return".";let u=!0,m=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++m;const S=r.length;S>1&&w(r.charCodeAt(1))&&(++m,S>2&&(w(r.charCodeAt(2))?++m:u=!1))}if(u){for(;m<a.length&&w(a.charCodeAt(m));)m++;m>=2&&(a=`\\${a.slice(m)}`)}return i.win32.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a)return"";const r=i.win32.resolve(s),u=i.win32.resolve(a);if(r===u||(s=r.toLowerCase(),a=u.toLowerCase(),s===a))return"";let m=0;for(;m<s.length&&s.charCodeAt(m)===c;)m++;let S=s.length;for(;S-1>m&&s.charCodeAt(S-1)===c;)S--;const R=S-m;let E=0;for(;E<a.length&&a.charCodeAt(E)===c;)E++;let P=a.length;for(;P-1>E&&a.charCodeAt(P-1)===c;)P--;const F=P-E,V=R<F?R:F;let O=-1,q=0;for(;q<V;q++){const I=s.charCodeAt(m+q);if(I!==a.charCodeAt(E+q))break;I===c&&(O=q)}if(q!==V){if(O===-1)return u}else{if(F>V){if(a.charCodeAt(E+q)===c)return u.slice(E+q+1);if(q===2)return u.slice(E+q)}R>V&&(s.charCodeAt(m+q)===c?O=q:q===2&&(O=3)),O===-1&&(O=0)}let k="";for(q=m+O+1;q<=S;++q)(q===S||s.charCodeAt(q)===c)&&(k+=k.length===0?"..":"\\..");return E+=O,k.length>0?`${k}${u.slice(E,P)}`:(u.charCodeAt(E)===c&&++E,u.slice(E,P))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=i.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const r=a.charCodeAt(2);if(r!==e&&r!==v)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===p&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return s},dirname(s){g(s,"path");const a=s.length;if(a===0)return".";let r=-1,u=0;const m=s.charCodeAt(0);if(a===1)return w(m)?s:".";if(w(m)){if(r=u=1,w(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!w(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&w(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!w(s.charCodeAt(E));)E++;if(E===a)return s;E!==P&&(r=u=E+1)}}}}else d(m)&&s.charCodeAt(1)===p&&(r=a>2&&w(s.charCodeAt(2))?3:2,u=r);let S=-1,R=!0;for(let E=a-1;E>=u;--E)if(w(s.charCodeAt(E))){if(!R){S=E;break}}else R=!1;if(S===-1){if(r===-1)return".";S=r}return s.slice(0,S)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let r=0,u=-1,m=!0,S;if(s.length>=2&&d(s.charCodeAt(0))&&s.charCodeAt(1)===p&&(r=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let R=a.length-1,E=-1;for(S=s.length-1;S>=r;--S){const P=s.charCodeAt(S);if(w(P)){if(!m){r=S+1;break}}else E===-1&&(m=!1,E=S+1),R>=0&&(P===a.charCodeAt(R)?--R===-1&&(u=S):(R=-1,u=E))}return r===u?u=E:u===-1&&(u=s.length),s.slice(r,u)}for(S=s.length-1;S>=r;--S)if(w(s.charCodeAt(S))){if(!m){r=S+1;break}}else u===-1&&(m=!1,u=S+1);return u===-1?"":s.slice(r,u)},extname(s){g(s,"path");let a=0,r=-1,u=0,m=-1,S=!0,R=0;s.length>=2&&s.charCodeAt(1)===p&&d(s.charCodeAt(0))&&(a=u=2);for(let E=s.length-1;E>=a;--E){const P=s.charCodeAt(E);if(w(P)){if(!S){u=E+1;break}continue}m===-1&&(S=!1,m=E+1),P===v?r===-1?r=E:R!==1&&(R=1):r!==-1&&(R=-1)}return r===-1||m===-1||R===0||R===1&&r===m-1&&r===u+1?"":s.slice(r,m)},format:l.bind(null,"\\"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.length;let u=0,m=s.charCodeAt(0);if(r===1)return w(m)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(w(m)){if(u=1,w(s.charCodeAt(1))){let O=2,q=O;for(;O<r&&!w(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&w(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&!w(s.charCodeAt(O));)O++;O===r?u=O:O!==q&&(u=O+1)}}}}else if(d(m)&&s.charCodeAt(1)===p){if(r<=2)return a.root=a.dir=s,a;if(u=2,w(s.charCodeAt(2))){if(r===3)return a.root=a.dir=s,a;u=3}}u>0&&(a.root=s.slice(0,u));let S=-1,R=u,E=-1,P=!0,F=s.length-1,V=0;for(;F>=u;--F){if(m=s.charCodeAt(F),w(m)){if(!P){R=F+1;break}continue}E===-1&&(P=!1,E=F+1),m===v?S===-1?S=F:V!==1&&(V=1):S!==-1&&(V=-1)}return E!==-1&&(S===-1||V===0||V===1&&S===E-1&&S===R+1?a.base=a.name=s.slice(R,E):(a.name=s.slice(R,S),a.base=s.slice(R,E),a.ext=s.slice(S,E))),R>0&&R!==u?a.dir=s.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(L){const s=/\\/g;return()=>{const a=_.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>_.cwd()})();i.posix={resolve(...s){let a="",r=!1;for(let u=s.length-1;u>=-1&&!r;u--){const m=u>=0?s[u]:h();g(m,"path"),m.length!==0&&(a=`${m}/${a}`,r=m.charCodeAt(0)===o)}return a=C(a,!r,"/",N),r?`/${a}`:a.length>0?a:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o,r=s.charCodeAt(s.length-1)===o;return s=C(s,!a,"/",N),s.length===0?a?"/":r?"./":".":(r&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let a;for(let r=0;r<s.length;++r){const u=s[r];g(u,"path"),u.length>0&&(a===void 0?a=u:a+=`/${u}`)}return a===void 0?".":i.posix.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a||(s=i.posix.resolve(s),a=i.posix.resolve(a),s===a))return"";const r=1,u=s.length,m=u-r,S=1,R=a.length-S,E=m<R?m:R;let P=-1,F=0;for(;F<E;F++){const O=s.charCodeAt(r+F);if(O!==a.charCodeAt(S+F))break;O===o&&(P=F)}if(F===E)if(R>E){if(a.charCodeAt(S+F)===o)return a.slice(S+F+1);if(F===0)return a.slice(S+F)}else m>E&&(s.charCodeAt(r+F)===o?P=F:F===0&&(P=0));let V="";for(F=r+P+1;F<=u;++F)(F===u||s.charCodeAt(F)===o)&&(V+=V.length===0?"..":"/..");return`${V}${a.slice(S+P)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o;let r=-1,u=!0;for(let m=s.length-1;m>=1;--m)if(s.charCodeAt(m)===o){if(!u){r=m;break}}else u=!1;return r===-1?a?"/":".":a&&r===1?"//":s.slice(0,r)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let r=0,u=-1,m=!0,S;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let R=a.length-1,E=-1;for(S=s.length-1;S>=0;--S){const P=s.charCodeAt(S);if(P===o){if(!m){r=S+1;break}}else E===-1&&(m=!1,E=S+1),R>=0&&(P===a.charCodeAt(R)?--R===-1&&(u=S):(R=-1,u=E))}return r===u?u=E:u===-1&&(u=s.length),s.slice(r,u)}for(S=s.length-1;S>=0;--S)if(s.charCodeAt(S)===o){if(!m){r=S+1;break}}else u===-1&&(m=!1,u=S+1);return u===-1?"":s.slice(r,u)},extname(s){g(s,"path");let a=-1,r=0,u=-1,m=!0,S=0;for(let R=s.length-1;R>=0;--R){const E=s.charCodeAt(R);if(E===o){if(!m){r=R+1;break}continue}u===-1&&(m=!1,u=R+1),E===v?a===-1?a=R:S!==1&&(S=1):a!==-1&&(S=-1)}return a===-1||u===-1||S===0||S===1&&a===u-1&&a===r+1?"":s.slice(a,u)},format:l.bind(null,"/"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.charCodeAt(0)===o;let u;r?(a.root="/",u=1):u=0;let m=-1,S=0,R=-1,E=!0,P=s.length-1,F=0;for(;P>=u;--P){const V=s.charCodeAt(P);if(V===o){if(!E){S=P+1;break}continue}R===-1&&(E=!1,R=P+1),V===v?m===-1?m=P:F!==1&&(F=1):m!==-1&&(F=-1)}if(R!==-1){const V=S===0&&r?1:S;m===-1||F===0||F===1&&m===R-1&&m===S+1?a.base=a.name=s.slice(V,R):(a.name=s.slice(V,m),a.base=s.slice(V,R),a.ext=s.slice(m,R))}return S>0?a.dir=s.slice(0,S-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},i.posix.win32=i.win32.win32=i.win32,i.posix.posix=i.win32.posix=i.posix,i.normalize=L?i.win32.normalize:i.posix.normalize,i.resolve=L?i.win32.resolve:i.posix.resolve,i.relative=L?i.win32.relative:i.posix.relative,i.dirname=L?i.win32.dirname:i.posix.dirname,i.basename=L?i.win32.basename:i.posix.basename,i.extname=L?i.win32.extname:i.posix.extname,i.sep=L?i.win32.sep:i.posix.sep}),Y(X[21],Q([0,1,5]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StopWatch=void 0;const M=_.globals.performance&&typeof _.globals.performance.now=="function";class A{static create(y=!0){return new A(y)}constructor(y){this.a=M&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?_.globals.performance.now():Date.now()}}i.StopWatch=A}),Y(X[7],Q([0,1,8,10,14,21]),function(U,i,_,M,A,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Relay=i.EventBufferer=i.MicrotaskEmitter=i.DebounceEmitter=i.PauseableEmitter=i.EventDeliveryQueue=i.Emitter=i.EventProfiling=i.Event=void 0;const y=!1,v=!1;var o;(function(a){a.None=()=>M.Disposable.None;function r(J){if(v){const{onDidAddListener:H}=J,G=b.create();let $=0;J.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),H?.()}}}function u(J,H){return q(J,()=>{},0,void 0,void 0,H)}a.defer=u;function m(J){return(H,G=null,$)=>{let K=!1,ee;return ee=J(te=>{if(!K)return ee?ee.dispose():K=!0,H.call(G,te)},null,$),K&&ee.dispose(),ee}}a.once=m;function S(J,H,G){return O(($,K=null,ee)=>J(te=>$.call(K,H(te)),null,ee),G)}a.map=S;function R(J,H,G){return O(($,K=null,ee)=>J(te=>{H(te),$.call(K,te)},null,ee),G)}a.forEach=R;function E(J,H,G){return O(($,K=null,ee)=>J(te=>H(te)&&$.call(K,te),null,ee),G)}a.filter=E;function P(J){return J}a.signal=P;function F(...J){return(H,G=null,$)=>(0,M.combinedDisposable)(...J.map(K=>K(ee=>H.call(G,ee),null,$)))}a.any=F;function V(J,H,G,$){let K=G;return S(J,ee=>(K=H(K,ee),K),$)}a.reduce=V;function O(J,H){let G;const $={onWillAddFirstListener(){G=J(K.fire,K)},onDidRemoveLastListener(){G?.dispose()}};H||r($);const K=new g($);return H?.add(K),K.event}function q(J,H,G=100,$=!1,K,ee){let te,ne,ve,Le=0;const we={leakWarningThreshold:K,onWillAddFirstListener(){te=J(ue=>{Le++,ne=H(ne,ue),$&&!ve&&(Ce.fire(ne),ne=void 0),clearTimeout(ve),ve=setTimeout(()=>{const me=ne;ne=void 0,ve=void 0,(!$||Le>1)&&Ce.fire(me),Le=0},G)})},onDidRemoveLastListener(){te.dispose()}};ee||r(we);const Ce=new g(we);return ee?.add(Ce),Ce.event}a.debounce=q;function k(J,H=0,G){return a.debounce(J,($,K)=>$?($.push(K),$):[K],H,void 0,void 0,G)}a.accumulate=k;function I(J,H=($,K)=>$===K,G){let $=!0,K;return E(J,ee=>{const te=$||!H(ee,K);return $=!1,K=ee,te},G)}a.latch=I;function T(J,H,G){return[a.filter(J,H,G),a.filter(J,$=>!H($),G)]}a.split=T;function W(J,H=!1,G=[]){let $=G.slice(),K=J(ne=>{$?$.push(ne):te.fire(ne)});const ee=()=>{$?.forEach(ne=>te.fire(ne)),$=null},te=new g({onWillAddFirstListener(){K||(K=J(ne=>te.fire(ne)))},onDidAddFirstListener(){$&&(H?setTimeout(ee):ee())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return te.event}a.buffer=W;class z{constructor(H){this.event=H,this.c=new M.DisposableStore}map(H){return new z(S(this.event,H,this.c))}forEach(H){return new z(R(this.event,H,this.c))}filter(H){return new z(E(this.event,H,this.c))}reduce(H,G){return new z(V(this.event,H,G,this.c))}latch(){return new z(I(this.event,void 0,this.c))}debounce(H,G=100,$=!1,K){return new z(q(this.event,H,G,$,K,this.c))}on(H,G,$){return this.event(H,G,$)}once(H,G,$){return m(this.event)(H,G,$)}dispose(){this.c.dispose()}}function n(J){return new z(J)}a.chain=n;function se(J,H,G=$=>$){const $=(...ne)=>te.fire(G(...ne)),K=()=>J.on(H,$),ee=()=>J.removeListener(H,$),te=new g({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromNodeEventEmitter=se;function de(J,H,G=$=>$){const $=(...ne)=>te.fire(G(...ne)),K=()=>J.addEventListener(H,$),ee=()=>J.removeEventListener(H,$),te=new g({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromDOMEventEmitter=de;function ge(J){return new Promise(H=>m(J)(H))}a.toPromise=ge;function pe(J,H){return H(void 0),J(G=>H(G))}a.runAndSubscribe=pe;function Se(J,H){let G=null;function $(ee){G?.dispose(),G=new M.DisposableStore,H(ee,G)}$(void 0);const K=J(ee=>$(ee));return(0,M.toDisposable)(()=>{K.dispose(),G?.dispose()})}a.runAndSubscribeWithStore=Se;class Ne{constructor(H,G){this.obs=H,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};G||r($),this.emitter=new g($),G&&G.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,G){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function _e(J,H){return new Ne(J,H).emitter.event}a.fromObservable=_e})(o=i.Event||(i.Event={}));class c{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${c.c++}`,c.all.add(this)}start(r){this.d=new t.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}i.EventProfiling=c,c.all=new Set,c.c=0;let p=-1;class e{constructor(r,u=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=u,this.d=0}dispose(){var r;(r=this.c)===null||r===void 0||r.clear()}check(r,u){const m=this.threshold;if(m<=0||u<m)return;this.c||(this.c=new Map);const S=this.c.get(r.value)||0;if(this.c.set(r.value,S+1),this.d-=1,this.d<=0){this.d=m*.5;let R,E=0;for(const[P,F]of this.c)(!R||E<F)&&(R=P,E=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${E}):`),console.warn(R)}return()=>{const R=this.c.get(r.value)||0;this.c.set(r.value,R-1)}}}class b{static create(){var r;return new b((r=new Error().stack)!==null&&r!==void 0?r:"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(r,u,m){this.callback=r,this.callbackThis=u,this.stack=m,this.subscription=new M.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class g{constructor(r){var u,m,S,R,E;this.j=!1,this.d=r,this.f=p>0||((u=this.d)===null||u===void 0?void 0:u.leakWarningThreshold)?new e((S=(m=this.d)===null||m===void 0?void 0:m.leakWarningThreshold)!==null&&S!==void 0?S:p):void 0,this.g=!((R=this.d)===null||R===void 0)&&R._profName?new c(this.d._profName):void 0,this.m=(E=this.d)===null||E===void 0?void 0:E.deliveryQueue}dispose(){var r,u,m,S;if(!this.j){if(this.j=!0,this.n){if(y){const R=Array.from(this.n);queueMicrotask(()=>{var E;for(const P of R)P.subscription.isset()&&(P.subscription.unset(),(E=P.stack)===null||E===void 0||E.print())})}this.n.clear()}(r=this.m)===null||r===void 0||r.clear(this),(m=(u=this.d)===null||u===void 0?void 0:u.onDidRemoveLastListener)===null||m===void 0||m.call(u),(S=this.f)===null||S===void 0||S.dispose()}}get event(){return this.l||(this.l=(r,u,m)=>{var S,R,E;if(this.n||(this.n=new A.LinkedList),this.f&&this.n.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.Disposable.None;const P=this.n.isEmpty();P&&((S=this.d)===null||S===void 0?void 0:S.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this);let F,V;this.f&&this.n.size>=Math.ceil(this.f.threshold*.2)&&(V=b.create(),F=this.f.check(V,this.n.size+1)),y&&(V=V??b.create());const O=new f(r,u,V),q=this.n.push(O);P&&((R=this.d)===null||R===void 0?void 0:R.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),!((E=this.d)===null||E===void 0)&&E.onDidAddListener&&this.d.onDidAddListener(this,r,u);const k=O.subscription.set(()=>{F?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof M.DisposableStore?m.add(k):Array.isArray(m)&&m.push(k),k}),this.l}fire(r){var u,m;if(this.n){this.m||(this.m=new w);for(const S of this.n)this.m.push(this,S,r);(u=this.g)===null||u===void 0||u.start(this.m.size),this.m.deliver(),(m=this.g)===null||m===void 0||m.stop()}}hasListeners(){return this.n?!this.n.isEmpty():!1}}i.Emitter=g;class L{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(r,u,m){this.c.push(new N(r,u,m))}clear(r){const u=new A.LinkedList;for(const m of this.c)m.emitter!==r&&u.push(m);this.c=u}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(u){(0,_.onUnexpectedError)(u)}}}}i.EventDeliveryQueue=L;class w extends L{clear(r){this.c.clear()}}class N{constructor(r,u,m){this.emitter=r,this.listener=u,this.event=m}}class d extends g{constructor(r){super(r),this.c=0,this.h=new A.LinkedList,this.k=r?.merge}pause(){this.c++}resume(){if(this.c!==0&&--this.c===0)if(this.k){if(this.h.size>0){const r=Array.from(this.h);this.h.clear(),super.fire(this.k(r))}}else for(;!this.c&&this.h.size!==0;)super.fire(this.h.shift())}fire(r){this.n&&(this.c!==0?this.h.push(r):super.fire(r))}}i.PauseableEmitter=d;class C extends d{constructor(r){var u;super(r),this.o=(u=r.delay)!==null&&u!==void 0?u:100}fire(r){this.p||(this.pause(),this.p=setTimeout(()=>{this.p=void 0,this.resume()},this.o)),super.fire(r)}}i.DebounceEmitter=C;class l extends g{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}i.MicrotaskEmitter=l;class h{constructor(){this.c=[]}wrapEvent(r){return(u,m,S)=>r(R=>{const E=this.c[this.c.length-1];E?E.push(()=>u.call(m,R)):u.call(m,R)},void 0,S)}bufferEvents(r){const u=[];this.c.push(u);const m=r();return this.c.pop(),u.forEach(S=>S()),m}}i.EventBufferer=h;class s{constructor(){this.c=!1,this.d=o.None,this.f=M.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}i.Relay=s}),Y(X[51],Q([0,1,7]),function(U,i,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CancellationTokenSource=i.CancellationToken=void 0;const M=Object.freeze(function(v,o){const c=setTimeout(v.bind(o),0);return{dispose(){clearTimeout(c)}}});var A;(function(v){function o(c){return c===v.None||c===v.Cancelled||c instanceof t?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}v.isCancellationToken=o,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(A=i.CancellationToken||(i.CancellationToken={}));class t{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new _.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(o){this.a=void 0,this.b=void 0,this.b=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new t),this.a}cancel(){this.a?this.a instanceof t&&this.a.cancel():this.a=A.Cancelled}dispose(o=!1){var c;o&&this.cancel(),(c=this.b)===null||c===void 0||c.dispose(),this.a?this.a instanceof t&&this.a.dispose():this.a=A.None}}i.CancellationTokenSource=y}),Y(X[12],Q([0,1,50,5]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.uriToFsPath=i.URI=void 0;const A=/^\w[\w\d+.-]*$/,t=/^\//,y=/^\/\//;function v(r,u){if(!r.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!A.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!t.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(r,u){return!r&&!u?"file":r}function c(r,u){switch(r){case"https":case"http":case"file":u?u[0]!==e&&(u=e+u):u=e;break}return u}const p="",e="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(u){return u instanceof f?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,m,S,R,E,P=!1){typeof u=="object"?(this.scheme=u.scheme||p,this.authority=u.authority||p,this.path=u.path||p,this.query=u.query||p,this.fragment=u.fragment||p):(this.scheme=o(u,P),this.authority=m||p,this.path=c(this.scheme,S||p),this.query=R||p,this.fragment=E||p,v(this,P))}get fsPath(){return C(this,!1)}with(u){if(!u)return this;let{scheme:m,authority:S,path:R,query:E,fragment:P}=u;return m===void 0?m=this.scheme:m===null&&(m=p),S===void 0?S=this.authority:S===null&&(S=p),R===void 0?R=this.path:R===null&&(R=p),E===void 0?E=this.query:E===null&&(E=p),P===void 0?P=this.fragment:P===null&&(P=p),m===this.scheme&&S===this.authority&&R===this.path&&E===this.query&&P===this.fragment?this:new L(m,S,R,E,P)}static parse(u,m=!1){const S=b.exec(u);return S?new L(S[2]||p,a(S[4]||p),a(S[5]||p),a(S[7]||p),a(S[9]||p),m):new L(p,p,p,p,p)}static file(u){let m=p;if(M.isWindows&&(u=u.replace(/\\/g,e)),u[0]===e&&u[1]===e){const S=u.indexOf(e,2);S===-1?(m=u.substring(2),u=e):(m=u.substring(2,S),u=u.substring(S)||e)}return new L("file",m,u,p,p)}static from(u){const m=new L(u.scheme,u.authority,u.path,u.query,u.fragment);return v(m,!0),m}static joinPath(u,...m){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return M.isWindows&&u.scheme==="file"?S=f.file(_.win32.join(C(u,!0),...m)).path:S=_.posix.join(u.path,...m),u.with({path:S})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof f)return u;{const m=new L(u);return m._formatted=u.external,m._fsPath=u._sep===g?u.fsPath:null,m}}else return u}}i.URI=f;const g=M.isWindows?1:void 0;class L extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=g),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(r,u,m){let S,R=-1;for(let E=0;E<r.length;E++){const P=r.charCodeAt(E);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||u&&P===47||m&&P===91||m&&P===93||m&&P===58)R!==-1&&(S+=encodeURIComponent(r.substring(R,E)),R=-1),S!==void 0&&(S+=r.charAt(E));else{S===void 0&&(S=r.substr(0,E));const F=w[P];F!==void 0?(R!==-1&&(S+=encodeURIComponent(r.substring(R,E)),R=-1),S+=F):R===-1&&(R=E)}}return R!==-1&&(S+=encodeURIComponent(r.substring(R))),S!==void 0?S:r}function d(r){let u;for(let m=0;m<r.length;m++){const S=r.charCodeAt(m);S===35||S===63?(u===void 0&&(u=r.substr(0,m)),u+=w[S]):u!==void 0&&(u+=r[m])}return u!==void 0?u:r}function C(r,u){let m;return r.authority&&r.path.length>1&&r.scheme==="file"?m=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?u?m=r.path.substr(1):m=r.path[1].toLowerCase()+r.path.substr(2):m=r.path,M.isWindows&&(m=m.replace(/\//g,"\\")),m}i.uriToFsPath=C;function l(r,u){const m=u?d:N;let S="",{scheme:R,authority:E,path:P,query:F,fragment:V}=r;if(R&&(S+=R,S+=":"),(E||R==="file")&&(S+=e,S+=e),E){let O=E.indexOf("@");if(O!==-1){const q=E.substr(0,O);E=E.substr(O+1),O=q.lastIndexOf(":"),O===-1?S+=m(q,!1,!1):(S+=m(q.substr(0,O),!1,!1),S+=":",S+=m(q.substr(O+1),!1,!0)),S+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?S+=m(E,!1,!0):(S+=m(E.substr(0,O),!1,!0),S+=E.substr(O))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const O=P.charCodeAt(1);O>=65&&O<=90&&(P=`/${String.fromCharCode(O+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const O=P.charCodeAt(0);O>=65&&O<=90&&(P=`${String.fromCharCode(O+32)}:${P.substr(2)}`)}S+=m(P,!0,!1)}return F&&(S+="?",S+=m(F,!1,!1)),V&&(S+="#",S+=u?V:N(V,!1,!1)),S}function h(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+h(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(s)?r.replace(s,u=>h(u)):r}}),Y(X[56],Q([0,1,8,7,10,11,5,4]),function(U,i,_,M,A,t,y,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.create=i.SimpleWorkerServer=i.SimpleWorkerClient=i.logOnceWebWorkerWarning=void 0;const o="$initialize";let c=!1;function p(a){!y.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}i.logOnceWebWorkerWarning=p;class e{constructor(r,u,m,S){this.vsWorker=r,this.req=u,this.method=m,this.args=S,this.type=0}}class b{constructor(r,u,m,S){this.vsWorker=r,this.seq=u,this.res=m,this.err=S,this.type=1}}class f{constructor(r,u,m,S){this.vsWorker=r,this.req=u,this.eventName=m,this.arg=S,this.type=2}}class g{constructor(r,u,m){this.vsWorker=r,this.req=u,this.event=m,this.type=3}}class L{constructor(r,u){this.vsWorker=r,this.req=u,this.type=4}}class w{constructor(r){this.a=-1,this.g=r,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(r){this.a=r}sendMessage(r,u){const m=String(++this.b);return new Promise((S,R)=>{this.c[m]={resolve:S,reject:R},this.o(new e(this.a,m,r,u))})}listen(r,u){let m=null;const S=new M.Emitter({onWillAddFirstListener:()=>{m=String(++this.b),this.d.set(m,S),this.o(new f(this.a,m,r,u))},onDidRemoveLastListener:()=>{this.d.delete(m),this.o(new L(this.a,m)),m=null}});return S.event}handleMessage(r){!r||!r.vsWorker||this.a!==-1&&r.vsWorker!==this.a||this.h(r)}h(r){switch(r.type){case 1:return this.j(r);case 0:return this.k(r);case 2:return this.l(r);case 3:return this.m(r);case 4:return this.n(r)}}j(r){if(!this.c[r.seq]){console.warn("Got reply to unknown seq");return}const u=this.c[r.seq];if(delete this.c[r.seq],r.err){let m=r.err;r.err.$isError&&(m=new Error,m.name=r.err.name,m.message=r.err.message,m.stack=r.err.stack),u.reject(m);return}u.resolve(r.res)}k(r){const u=r.req;this.g.handleMessage(r.method,r.args).then(S=>{this.o(new b(this.a,u,S,void 0))},S=>{S.detail instanceof Error&&(S.detail=(0,_.transformErrorForSerialization)(S.detail)),this.o(new b(this.a,u,void 0,(0,_.transformErrorForSerialization)(S)))})}l(r){const u=r.req,m=this.g.handleEvent(r.eventName,r.arg)(S=>{this.o(new g(this.a,u,S))});this.f.set(u,m)}m(r){if(!this.d.has(r.req)){console.warn("Got event for unknown req");return}this.d.get(r.req).fire(r.event)}n(r){if(!this.f.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(r.req).dispose(),this.f.delete(r.req)}o(r){const u=[];if(r.type===0)for(let m=0;m<r.args.length;m++)r.args[m]instanceof ArrayBuffer&&u.push(r.args[m]);else r.type===1&&r.res instanceof ArrayBuffer&&u.push(r.res);this.g.sendMessage(r,u)}}class N extends A.Disposable{constructor(r,u,m){super();let S=null;this.a=this.q(r.create("vs/base/common/worker/simpleWorker",V=>{this.c.handleMessage(V)},V=>{S?.(V)})),this.c=new w({sendMessage:(V,O)=>{this.a.postMessage(V,O)},handleMessage:(V,O)=>{if(typeof m[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(m[V].apply(m,O))}catch(q){return Promise.reject(q)}},handleEvent:(V,O)=>{if(C(V)){const q=m[V].call(m,O);if(typeof q!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return q}if(d(V)){const q=m[V];if(typeof q!="function")throw new Error(`Missing event ${V} on main thread host.`);return q}throw new Error(`Malformed event name ${V}`)}}),this.c.setWorkerId(this.a.getId());let R=null;typeof y.globals.require<"u"&&typeof y.globals.require.getConfig=="function"?R=y.globals.require.getConfig():typeof y.globals.requirejs<"u"&&(R=y.globals.requirejs.s.contexts._.config);const E=(0,t.getAllMethodNames)(m);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(R)),u,E]);const P=(V,O)=>this.h(V,O),F=(V,O)=>this.c.listen(V,O);this.g=new Promise((V,O)=>{S=O,this.b.then(q=>{V(l(q,P,F))},q=>{O(q),this.j("Worker failed to load "+u,q)})})}getProxyObject(){return this.g}h(r,u){return new Promise((m,S)=>{this.b.then(()=>{this.c.sendMessage(r,u).then(m,S)},S)})}j(r,u){console.error(r),console.info(u)}}i.SimpleWorkerClient=N;function d(a){return a[0]==="o"&&a[1]==="n"&&v.isUpperAsciiLetter(a.charCodeAt(2))}function C(a){return/^onDynamic/.test(a)&&v.isUpperAsciiLetter(a.charCodeAt(9))}function l(a,r,u){const m=E=>function(){const P=Array.prototype.slice.call(arguments,0);return r(E,P)},S=E=>function(P){return u(E,P)},R={};for(const E of a){if(C(E)){R[E]=S(E);continue}if(d(E)){R[E]=u(E,void 0);continue}R[E]=m(E)}return R}class h{constructor(r,u){this.a=u,this.b=null,this.c=new w({sendMessage:(m,S)=>{r(m,S)},handleMessage:(m,S)=>this.d(m,S),handleEvent:(m,S)=>this.f(m,S)})}onmessage(r){this.c.handleMessage(r)}d(r,u){if(r===o)return this.g(u[0],u[1],u[2],u[3]);if(!this.b||typeof this.b[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.b[r].apply(this.b,u))}catch(m){return Promise.reject(m)}}f(r,u){if(!this.b)throw new Error("Missing requestHandler");if(C(r)){const m=this.b[r].call(this.b,u);if(typeof m!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return m}if(d(r)){const m=this.b[r];if(typeof m!="function")throw new Error(`Missing event ${r} on request handler.`);return m}throw new Error(`Malformed event name ${r}`)}g(r,u,m,S){this.c.setWorkerId(r);const P=l(S,(F,V)=>this.c.sendMessage(F,V),(F,V)=>this.c.listen(F,V));return this.a?(this.b=this.a(P),Promise.resolve((0,t.getAllMethodNames)(this.b))):(u&&(typeof u.baseUrl<"u"&&delete u.baseUrl,typeof u.paths<"u"&&typeof u.paths.vs<"u"&&delete u.paths.vs,typeof u.trustedTypesPolicy!==void 0&&delete u.trustedTypesPolicy,u.catchError=!0,y.globals.require.config(u)),new Promise((F,V)=>{(y.globals.require||U)([m],q=>{if(this.b=q.create(P),!this.b){V(new Error("No RequestHandler!"));return}F((0,t.getAllMethodNames)(this.b))},V)}))}}i.SimpleWorkerServer=h;function s(a){return new h(a,null)}i.create=s}),Y(X[52],Q([0,1,7,10]),function(U,i,_,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=void 0;class A{constructor(){this.a=new Map,this.b=new Map,this.c=new _.Emitter,this.onDidChange=this.c.event,this.d=null}fire(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,o){return this.a.set(v,o),this.fire([v]),(0,M.toDisposable)(()=>{this.a.get(v)===o&&(this.a.delete(v),this.fire([v]))})}registerFactory(v,o){var c;(c=this.b.get(v))===null||c===void 0||c.dispose();const p=new t(this,v,o);return this.b.set(v,p),(0,M.toDisposable)(()=>{const e=this.b.get(v);!e||e!==p||(this.b.delete(v),e.dispose())})}getOrCreate(v){return le(this,void 0,void 0,function*(){const o=this.get(v);if(o)return o;const c=this.b.get(v);return!c||c.isResolved?null:(yield c.resolve(),this.get(v))})}get(v){return this.a.get(v)||null}isResolved(v){if(this.get(v))return!0;const c=this.b.get(v);return!!(!c||c.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}i.TokenizationRegistry=A;class t extends M.Disposable{get isResolved(){return this.c}constructor(v,o,c){super(),this.g=v,this.h=o,this.i=c,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this.b||(this.b=this.j()),this.b})}j(){return le(this,void 0,void 0,function*(){const v=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,v&&!this.a&&this.q(this.g.register(this.h,v))})}}}),Y(X[53],Q([0,1,30,12,2,52]),function(U,i,_,M,A,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=i.InlayHintKind=i.Command=i.FoldingRangeKind=i.SymbolKinds=i.isLocationLink=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.InlineCompletionTriggerKind=i.CompletionItemKinds=i.EncodedTokenizationResult=i.TokenizationResult=i.Token=void 0;class y{constructor(C,l,h){this._tokenBrand=void 0,this.offset=C,this.type=l,this.language=h}toString(){return"("+this.offset+", "+this.type+")"}}i.Token=y;class v{constructor(C,l){this._tokenizationResultBrand=void 0,this.tokens=C,this.endState=l}}i.TokenizationResult=v;class o{constructor(C,l){this._encodedTokenizationResultBrand=void 0,this.tokens=C,this.endState=l}}i.EncodedTokenizationResult=o;var c;(function(d){const C=new Map;C.set(0,_.Codicon.symbolMethod),C.set(1,_.Codicon.symbolFunction),C.set(2,_.Codicon.symbolConstructor),C.set(3,_.Codicon.symbolField),C.set(4,_.Codicon.symbolVariable),C.set(5,_.Codicon.symbolClass),C.set(6,_.Codicon.symbolStruct),C.set(7,_.Codicon.symbolInterface),C.set(8,_.Codicon.symbolModule),C.set(9,_.Codicon.symbolProperty),C.set(10,_.Codicon.symbolEvent),C.set(11,_.Codicon.symbolOperator),C.set(12,_.Codicon.symbolUnit),C.set(13,_.Codicon.symbolValue),C.set(15,_.Codicon.symbolEnum),C.set(14,_.Codicon.symbolConstant),C.set(15,_.Codicon.symbolEnum),C.set(16,_.Codicon.symbolEnumMember),C.set(17,_.Codicon.symbolKeyword),C.set(27,_.Codicon.symbolSnippet),C.set(18,_.Codicon.symbolText),C.set(19,_.Codicon.symbolColor),C.set(20,_.Codicon.symbolFile),C.set(21,_.Codicon.symbolReference),C.set(22,_.Codicon.symbolCustomColor),C.set(23,_.Codicon.symbolFolder),C.set(24,_.Codicon.symbolTypeParameter),C.set(25,_.Codicon.account),C.set(26,_.Codicon.issues);function l(a){let r=C.get(a);return r||(console.info("No codicon found for CompletionItemKind "+a),r=_.Codicon.symbolProperty),r}d.toIcon=l;const h=new Map;h.set("method",0),h.set("function",1),h.set("constructor",2),h.set("field",3),h.set("variable",4),h.set("class",5),h.set("struct",6),h.set("interface",7),h.set("module",8),h.set("property",9),h.set("event",10),h.set("operator",11),h.set("unit",12),h.set("value",13),h.set("constant",14),h.set("enum",15),h.set("enum-member",16),h.set("enumMember",16),h.set("keyword",17),h.set("snippet",27),h.set("text",18),h.set("color",19),h.set("file",20),h.set("reference",21),h.set("customcolor",22),h.set("folder",23),h.set("type-parameter",24),h.set("typeParameter",24),h.set("account",25),h.set("issue",26);function s(a,r){let u=h.get(a);return typeof u>"u"&&!r&&(u=9),u}d.fromString=s})(c=i.CompletionItemKinds||(i.CompletionItemKinds={}));var p;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(p=i.InlineCompletionTriggerKind||(i.InlineCompletionTriggerKind={}));var e;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(e=i.SignatureHelpTriggerKind||(i.SignatureHelpTriggerKind={}));var b;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(b=i.DocumentHighlightKind||(i.DocumentHighlightKind={}));function f(d){return d&&M.URI.isUri(d.uri)&&A.Range.isIRange(d.range)&&(A.Range.isIRange(d.originSelectionRange)||A.Range.isIRange(d.targetSelectionRange))}i.isLocationLink=f;var g;(function(d){const C=new Map;C.set(0,_.Codicon.symbolFile),C.set(1,_.Codicon.symbolModule),C.set(2,_.Codicon.symbolNamespace),C.set(3,_.Codicon.symbolPackage),C.set(4,_.Codicon.symbolClass),C.set(5,_.Codicon.symbolMethod),C.set(6,_.Codicon.symbolProperty),C.set(7,_.Codicon.symbolField),C.set(8,_.Codicon.symbolConstructor),C.set(9,_.Codicon.symbolEnum),C.set(10,_.Codicon.symbolInterface),C.set(11,_.Codicon.symbolFunction),C.set(12,_.Codicon.symbolVariable),C.set(13,_.Codicon.symbolConstant),C.set(14,_.Codicon.symbolString),C.set(15,_.Codicon.symbolNumber),C.set(16,_.Codicon.symbolBoolean),C.set(17,_.Codicon.symbolArray),C.set(18,_.Codicon.symbolObject),C.set(19,_.Codicon.symbolKey),C.set(20,_.Codicon.symbolNull),C.set(21,_.Codicon.symbolEnumMember),C.set(22,_.Codicon.symbolStruct),C.set(23,_.Codicon.symbolEvent),C.set(24,_.Codicon.symbolOperator),C.set(25,_.Codicon.symbolTypeParameter);function l(h){let s=C.get(h);return s||(console.info("No codicon found for SymbolKind "+h),s=_.Codicon.symbolProperty),s}d.toIcon=l})(g=i.SymbolKinds||(i.SymbolKinds={}));class L{constructor(C){this.value=C}}i.FoldingRangeKind=L,L.Comment=new L("comment"),L.Imports=new L("imports"),L.Region=new L("region");var w;(function(d){function C(l){return!l||typeof l!="object"?!1:typeof l.id=="string"&&typeof l.title=="string"}d.is=C})(w=i.Command||(i.Command={}));var N;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(N=i.InlayHintKind||(i.InlayHintKind={})),i.TokenizationRegistry=new t.TokenizationRegistry}),Y(X[54],Q([0,1,51,7,27,12,3,2,31,53,47]),function(U,i,_,M,A,t,y,v,o,c,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createMonacoBaseAPI=i.KeyMod=void 0;class e{static chord(g,L){return(0,A.KeyChord)(g,L)}}i.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.CancellationTokenSource,Emitter:M.Emitter,KeyCode:p.KeyCode,KeyMod:e,Position:y.Position,Range:v.Range,Selection:o.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:t.URI,Token:c.Token}}i.createMonacoBaseAPI=b}),Y(X[57],Q([0,1,15,5,12,3,2,44,19,40,41,54,21,46,39,11]),function(U,i,_,M,A,t,y,v,o,c,p,e,b,f,g,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.create=i.EditorSimpleWorker=void 0;class w extends v.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,h){const s=(0,o.getWordAtText)(l.column,(0,o.ensureValidWordDefinition)(h),this.d[l.lineNumber-1],0);return s?new y.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}words(l){const h=this.d,s=this.p.bind(this);let a=0,r="",u=0,m=[];return{*[Symbol.iterator](){for(;;)if(u<m.length){const S=r.substring(m[u].start,m[u].end);u+=1,yield S}else if(a<h.length)r=h[a],m=s(r,l),u=0,a+=1;else break}}}getLineWords(l,h){const s=this.d[l-1],a=this.p(s,h),r=[];for(const u of a)r.push({word:s.substring(u.start,u.end),startColumn:u.start+1,endColumn:u.end+1});return r}p(l,h){const s=[];let a;for(h.lastIndex=0;(a=h.exec(l))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const h=this.f,s=l.startLineNumber-1,a=l.endLineNumber-1,r=[];r.push(this.d[s].substring(l.startColumn-1));for(let u=s+1;u<a;u++)r.push(this.d[u]);return r.push(this.d[a].substring(0,l.endColumn-1)),r.join(h)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const h=this.h.getIndexOf(l),s=this.d[h.index].length;return{lineNumber:1+h.index,column:1+Math.min(h.remainder,s)}}q(l){const h=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),s=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return h.lineNumber!==l.startLineNumber||h.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}r(l){if(!t.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:h,column:s}=l,a=!1;if(h<1)h=1,s=1,a=!0;else if(h>this.d.length)h=this.d.length,s=this.d[h-1].length+1,a=!0;else{const r=this.d[h-1].length+1;s<1?(s=1,a=!0):s>r&&(s=r,a=!0)}return a?{lineNumber:h,column:s}:l}}class N{constructor(l,h){this.c=l,this.d=Object.create(null),this.f=h,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(h=>l.push(this.d[h])),l}acceptNewModel(l){this.d[l.url]=new w(A.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,h){if(!this.d[l])return;this.d[l].onEvents(h)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}computeUnicodeHighlights(l,h,s){return le(this,void 0,void 0,function*(){const a=this.h(l);return a?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,h,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(l,h,s,a){return le(this,void 0,void 0,function*(){const r=this.h(l),u=this.h(h);return!r||!u?null:N.k(r,u,s,a)})}static k(l,h,s,a){const r=a==="experimental"?g.linesDiffComputers.experimental:g.linesDiffComputers.smart,u=l.getLinesContent(),m=h.getLinesContent(),S=r.computeDiff(u,m,s);return{identical:S.changes.length>0?!1:this.l(l,h),quitEarly:S.quitEarly,changes:S.changes.map(E=>{var P;return[E.originalRange.startLineNumber,E.originalRange.endLineNumberExclusive,E.modifiedRange.startLineNumber,E.modifiedRange.endLineNumberExclusive,(P=E.innerChanges)===null||P===void 0?void 0:P.map(F=>[F.originalRange.startLineNumber,F.originalRange.startColumn,F.originalRange.endLineNumber,F.originalRange.endColumn,F.modifiedRange.startLineNumber,F.modifiedRange.startColumn,F.modifiedRange.endLineNumber,F.modifiedRange.endColumn])]})}}static l(l,h){const s=l.getLineCount(),a=h.getLineCount();if(s!==a)return!1;for(let r=1;r<=s;r++){const u=l.getLineContent(r),m=h.getLineContent(r);if(u!==m)return!1}return!0}computeMoreMinimalEdits(l,h){return le(this,void 0,void 0,function*(){const s=this.h(l);if(!s)return h;const a=[];let r;h=h.slice(0).sort((u,m)=>{if(u.range&&m.range)return y.Range.compareRangesUsingStarts(u.range,m.range);const S=u.range?0:1,R=m.range?0:1;return S-R});for(let{range:u,text:m,eol:S}of h){if(typeof S=="number"&&(r=S),y.Range.isEmpty(u)&&!m)continue;const R=s.getValueInRange(u);if(m=m.replace(/\r\n|\n|\r/g,s.eol),R===m)continue;if(Math.max(m.length,R.length)>N.n){a.push({range:u,text:m});continue}const E=(0,_.stringDiff)(R,m,!1),P=s.offsetAt(y.Range.lift(u).getStartPosition());for(const F of E){const V=s.positionAt(P+F.originalStart),O=s.positionAt(P+F.originalStart+F.originalLength),q={text:m.substr(F.modifiedStart,F.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:O.lineNumber,endColumn:O.column}};s.getValueInRange(q.range)!==q.text&&a.push(q)}}return typeof r=="number"&&a.push({eol:r,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(l){return le(this,void 0,void 0,function*(){const h=this.h(l);return h?(0,c.computeLinks)(h):null})}textualSuggest(l,h,s,a){return le(this,void 0,void 0,function*(){const r=new b.StopWatch(!0),u=new RegExp(s,a),m=new Set;e:for(const S of l){const R=this.h(S);if(!!R){for(const E of R.words(u))if(!(E===h||!isNaN(Number(E)))&&(m.add(E),m.size>N.o))break e}}return{words:Array.from(m),duration:r.elapsed()}})}computeWordRanges(l,h,s,a){return le(this,void 0,void 0,function*(){const r=this.h(l);if(!r)return Object.create(null);const u=new RegExp(s,a),m=Object.create(null);for(let S=h.startLineNumber;S<h.endLineNumber;S++){const R=r.getLineWords(S,u);for(const E of R){if(!isNaN(Number(E.word)))continue;let P=m[E.word];P||(P=[],m[E.word]=P),P.push({startLineNumber:S,startColumn:E.startColumn,endLineNumber:S,endColumn:E.endColumn})}}return m})}navigateValueSet(l,h,s,a,r){return le(this,void 0,void 0,function*(){const u=this.h(l);if(!u)return null;const m=new RegExp(a,r);h.startColumn===h.endColumn&&(h={startLineNumber:h.startLineNumber,startColumn:h.startColumn,endLineNumber:h.endLineNumber,endColumn:h.endColumn+1});const S=u.getValueInRange(h),R=u.getWordAtPosition({lineNumber:h.startLineNumber,column:h.startColumn},m);if(!R)return null;const E=u.getValueInRange(R);return p.BasicInplaceReplace.INSTANCE.navigateValueSet(h,S,R,E,s)})}loadForeignModule(l,h,s){const a=(m,S)=>this.c.fhr(m,S),u={host:(0,L.createProxyObject)(s,a),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(u,h),Promise.resolve((0,L.getAllMethodNames)(this.g))):new Promise((m,S)=>{U([l],R=>{this.g=R.create(u,h),m((0,L.getAllMethodNames)(this.g))},S)})}fmr(l,h){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,h))}catch(s){return Promise.reject(s)}}}i.EditorSimpleWorker=N,N.n=1e5,N.o=1e4;function d(C){return new N(C,null)}i.create=d,typeof importScripts=="function"&&(M.globals.monaco=(0,e.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map